unit FAbout;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, {lmdcompo,} lmdclass, {lmdmmS,} lmdformA, {lmdnonvS,
  lmdcctrl, lmdctrl, lmdeditb, lmdmemoc,} LMDMemo, Menus, ComCtrls;

type
  TAbout = class(TForm)
    lname: TLabel;
    lcop: TLabel;
    iml1: TImage;
    m: TMemo;
    Button1: TButton;
    Bevel1: TBevel;
    lAuth: TLabel;
    Image2: TImage;
    llink: TLabel;
    iml2: TImage;
    lVer: TLabel;
    MainMenu1: TMainMenu;
    ExitBtn: TMenuItem;
    Image1: TImage;
    Bevel2: TBevel;
    llink2: TLabel;
    procedure mContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure mMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure llinkClick(Sender: TObject);
    procedure iml1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure iml1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2Click(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure llink2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  About: TAbout;

implementation

uses FMain,FFunc,FData,FCap,ShellAPI;

{$R *.DFM}

procedure TAbout.mContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
activecontrol:=button1;
abort;
end;

procedure TAbout.mMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
activecontrol:=button1;abort;
end;

procedure TAbout.Button1Click(Sender: TObject);
begin
timer_stop;
main.Enabled:=true;
main.show;
main.newbtn.click;
about.hide;
if opt.doShowCounters then counters_show else counters_hide;
end;


procedure TAbout.FormCreate(Sender: TObject);
begin
llink.Hint:=hlink;
//set_about_text;
about_form_created:=true;
//alwaysontop_apply;
//if opt.doAlwaysOnTop then about.FormStyle:=fsStayonTop;
//language_apply;
about.Caption:=cap_about_caption;
imL1.Picture:=main.imLogo.picture;
end;

procedure TAbout.FormClose(Sender: TObject; var Action: TCloseAction);
begin
abort;
end;

procedure TAbout.mKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
activecontrol:=nil;
abort;
end;

procedure TAbout.llinkClick(Sender: TObject);
begin
try shellexecute(application.handle,'',
   hlink,'',
    '',sw_show);exit;except end; 
end;

procedure TAbout.iml1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
iml2.show;
iml1.hide;
end;

procedure TAbout.iml1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
iml1.show;
iml2.hide;
end;

procedure TAbout.Image2Click(Sender: TObject);
begin
{if llink.Caption='link to homepage' then
   begin
   llink.Caption:='feedback';
   llink.Hint:='mailto:dmitriyis@gmail.com?subject='+projectname+#32+ver+' feedback by '+
   opt.replayname;end
   else
   begin
   llink.Caption:='link to homepage';
   llink.Hint:=hlink;end; }
end;

procedure TAbout.ExitBtnClick(Sender: TObject);
begin
main.Enabled:=true;
main.show;
about.hide;
if opt.doShowCounters then counters_show else counters_hide;
end;

procedure TAbout.llink2Click(Sender: TObject);
begin
try shellexecute(application.handle,'',pchar(
   'mailto:dmitriyis@gmail.com?subject='+projectname+#32+ver+' feedback by '+
   opt.replayname),'',
    '',sw_show);exit;except end;
end;

end.
