unit FMultiplayer;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, ExtCtrls, Menus, Buttons;

type
  TMult = class(TForm)
    HostBtn: TButton;
    sePort: TSpinEdit;
    eIP: TEdit;
    ConnectBtn: TButton;
    DisconnectBtn: TButton;
    eName: TEdit;
    lName: TLabel;
    lPort: TLabel;
    lIP: TLabel;
    eChat: TEdit;
    Memo: TMemo;
    sd: TSaveDialog;
    PopupMenu1: TPopupMenu;
    SaveBtn: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure MemoKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure MemoKeyPress(Sender: TObject; var Key: Char);
    procedure MemoClick(Sender: TObject);
    procedure MemoDblClick(Sender: TObject);
    procedure MemoEnter(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure MemoContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Mult: TMult;

implementation

uses FMain,FDATA,FFunc,FCap;

{$R *.DFM}

procedure TMult.FormClose(Sender: TObject; var Action: TCloseAction);
begin
timer_stop;
main.enabled:=true;
main.show;
end;

procedure TMult.FormCreate(Sender: TObject);
begin
mult_form_created:=true;
//language_apply;
mult.lPort.Caption:=cap_lport;
mult.lIP.caption:=cap_lIP;
mult.lname.caption:=cap_lname;
mult.HostBtn.Caption:=cap_hostbtn;
mult.ConnectBtn.Caption:=cap_connectbtn;
mult.DisconnectBtn.Caption:=cap_disconnectbtn;
mult.Caption:=cap_mult_caption;
end;

procedure TMult.MemoKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
abort;
end;

procedure TMult.MemoKeyPress(Sender: TObject; var Key: Char);
begin
abort;
end;

procedure TMult.MemoClick(Sender: TObject);
begin
abort;
end;

procedure TMult.MemoDblClick(Sender: TObject);
begin
abort;
end;

procedure TMult.MemoEnter(Sender: TObject);
begin
abort;
end;

procedure TMult.SaveBtnClick(Sender: TObject);
begin
sd.InitialDir:=opt.apppath;
if sd.Execute then if sd.filename<>'' then
begin
memo.Lines.SaveToFile(sd.filename);
sd.filename:='';
end;
end;

procedure TMult.MemoContextPopup(Sender: TObject; MousePos: TPoint;
  var Handled: Boolean);
begin
popupmenu1.Popup(mouse.cursorpos.x,mouse.cursorpos.y);
abort;
end;

end.
