unit FOptions;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Grids, ExtCtrls, FileCtrl, Buttons, Spin,
  Menus, ShlOBJ, ActiveX, ComObj, Outline;

type
  TOptions_window = class(TForm)
    DefaultBtn: TButton;
    CancelBtn: TButton;
    ApplyBtn: TButton;
    PageSeL: TOutline;
    pStyle: TPanel;
    lpage2: TLabel;
    Bevel1: TBevel;
    cbMarks: TCheckBox;
    cbTenths: TCheckBox;
    pSystem: TPanel;
    cbEnableBossKey: TCheckBox;
    cbSetHighPriority: TCheckBox;
    lPage4: TLabel;
    Bevel2: TBevel;
    cbClipCur: TCheckBox;
    cbProhibitMultInstances: TCheckBox;
    pLanguage: TPanel;
    lPage5: TLabel;
    Bevel3: TBevel;
    LangFLB: TFileListBox;
    pCheat: TPanel;
    lpage3: TLabel;
    Bevel4: TBevel;
    pUser: TPanel;
    lpage1: TLabel;
    Bevel5: TBevel;
    cbHistLog: TCheckBox;
    edIdText: TEdit;
    pMult: TPanel;
    lPage7: TLabel;
    Bevel6: TBevel;
    cbProcListGrab: TCheckBox;
    sbRegAVFext: TSpeedButton;
    cbDisableTimer: TCheckBox;
    cbAutoFlagSet: TCheckBox;
    cbDisableGroupOpen: TCheckBox;
    cbInfiniteLives: TCheckBox;
    cbShowProbabilities: TCheckBox;
    cbApprox3BV: TCheckBox;
    se3BV: TSpinEdit;
    lattempts: TLabel;
    seAttempts: TSpinEdit;
    sb3: TSpeedButton;
    cbSysInfGrab: TCheckBox;
    cbBlockChat: TCheckBox;
    lmultwarn: TLabel;
    Bevel7: TBevel;
    Label10: TLabel;
    imLogo: TImage;
    lstartupmode: TLabel;
    rBeg: TRadioButton;
    rInt: TRadioButton;
    rExp: TRadioButton;
    lskin: TLabel;
    skinBox: TComboBox;
    cbClearanceOnFail: TCheckBox;
    pAutomation: TPanel;
    lPage6: TLabel;
    Bevel9: TBevel;
    cbCond1: TCheckBox;
    sb4: TSpeedButton;
    llangsel: TLabel;
    cbDisableRightClick: TCheckBox;
    cbShow3BVafterGameStart: TCheckBox;
    ltimerskin: TLabel;
    skinTimer: TComboBox;
    cbClearanceOnMiddleBtn: TCheckBox;
    sbJustifyByCenter: TSpeedButton;
    cbAlwaysOnTop: TCheckBox;
    cbMustHave7: TCheckBox;
    cbMustHave8: TCheckBox;
    lReplayName: TLabel;
    edReplayName: TEdit;
    lCountry: TLabel;
    boxCountry: TComboBox;
    lReplayFileName: TLabel;
    edReplayFileName: TEdit;
    edBeg: TEdit;
    lModeName: TLabel;
    edInt: TEdit;
    edExp: TEdit;
    sb1: TSpeedButton;
    cbFillFlags: TCheckBox;
    cbBlit: TCheckBox;
    MainMenu1: TMainMenu;
    ExitBtn: TMenuItem;
    cbLUserid: TCheckBox;
    cbShowEquals: TCheckBox;
    cbShowMines: TCheckBox;
    cbSeekPlugins: TCheckBox;
    pCounter: TPanel;
    lPage8: TLabel;
    Bevel10: TBevel;
    lserowswidth: TLabel;
    seCr1: TSpinEdit;
    seCr2: TSpinEdit;
    mtemplate: TMemo;
    lcounterstext: TLabel;
    sbLoadCnt: TSpeedButton;
    sbSaveCnt: TSpeedButton;
    sb2: TSpeedButton;
    lpos: TLabel;
    sbAddFormula: TSpeedButton;
    sd: TSaveDialog;
    od: TOpenDialog;
    pIRC: TPanel;
    lPage9: TLabel;
    Bevel8: TBevel;
    sb5: TSpeedButton;
    cbIRCtypes: TComboBox;
    cbBlastedCopyIrc: TCheckBox;
    cbFinishedCopyIRC: TCheckBox;
    cbCountersExcludeList: TCheckBox;
    lColorScheme: TLabel;
    cbColor1: TComboBox;
    cbColor2: TComboBox;
    mCntExcludeList: TMemo;
    sbflushlist: TSpeedButton;
    lAutoCopyFormat: TLabel;
    seBoardClearanceCompl: TSpinEdit;
    LBoardClearanceCompl: TLabel;
    sbShortcut: TSpeedButton;
    SpeedButton1: TSpeedButton;
    cbShowCounters: TCheckBox;
    cbShowCountersTitle: TCheckBox;
    cbClearanceOnLeftBtn: TCheckBox;
    cbShowCntGreenBorder: TCheckBox;
    cbDoTimer: TCheckBox;
    cbApprox3BV2: TCheckBox;
    se3BV2: TSpinEdit;
    mTranslateMe: TMemo;
    pMouse: TPanel;
    lpage10: TLabel;
    Bevel11: TBevel;
    lmpcolor: TLabel;
    cbShowCells: TCheckBox;
    cbMpColor: TComboBox;
    cbShowMousePath: TCheckBox;
    cbShowDownState: TCheckBox;
    cbShowLeftCl: TCheckBox;
    cbShowRightCl: TCheckBox;
    cbShowDoubleCl: TCheckBox;
    cbDarkenBoard: TCheckBox;
    cbLClColor: TComboBox;
    llclcolor: TLabel;
    cbRClColor: TComboBox;
    lrclcolor: TLabel;
    cbDClColor: TComboBox;
    ldclcolor: TLabel;
    DefaultPageBtn: TButton;
    cbForcedNewGame: TCheckBox;
    seFNGI: TSpinEdit;
    seFNGE: TSpinEdit;
    seFNGB: TSpinEdit;
    cbForcedNewGameBEEP: TCheckBox;
    cbChangeLayout: TCheckBox;
    cbDotSeparator: TCheckBox;
    imFlag: TImage;
    auttempl: TMemo;
    sbloadaut: TSpeedButton;
    sbSaveAut: TSpeedButton;
    sbDefaultAut: TSpeedButton;
    cbCntonFinish: TCheckBox;
    cbCntonEnd: TCheckBox;
    lTimeZone: TLabel;
    seTimeZone: TSpinEdit;
    edCus: TEdit;
    seCr3: TSpinEdit;
    lserows: TLabel;
    cbUseSmiles: TCheckBox;
    cbExecuteCounters: TCheckBox;
    cbZeroTimer0: TCheckBox;
    procedure ApplyBtnClick(Sender: TObject);
    procedure PageSeLClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CancelBtnClick(Sender: TObject);
    procedure sb3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sb4Click(Sender: TObject);
    procedure DefaultBtnClick(Sender: TObject);
    procedure sbRegAVFextClick(Sender: TObject);
    procedure sbShortcutClick(Sender: TObject);
    procedure sbJustifyByCenterClick(Sender: TObject);
    procedure cbHistLogClick(Sender: TObject);
    procedure cbBlitClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure sb2Click(Sender: TObject);
    procedure mtemplateKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mtemplateMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure mtemplateClick(Sender: TObject);
    procedure mtemplateChange(Sender: TObject);
    procedure sb5Click(Sender: TObject);
    procedure sbAddFormulaClick(Sender: TObject);
    procedure sbSaveCntClick(Sender: TObject);
    procedure sbLoadCntClick(Sender: TObject);
    procedure sbflushlistClick(Sender: TObject);
    procedure cbMarksClick(Sender: TObject);
    procedure DefaultPageBtnClick(Sender: TObject);
    procedure cbChangeLayoutClick(Sender: TObject);
    procedure boxCountryChange(Sender: TObject);
    procedure sbloadautClick(Sender: TObject);
    procedure sbSaveAutClick(Sender: TObject);
    procedure sbDefaultAutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Options_window: TOptions_window;

implementation

uses FMain,FData,FFunc,FCap, FFormula, FCounters;

{$R *.DFM}

procedure TOptions_window.ApplyBtnClick(Sender: TObject);
begin
if not is_correct_useridtext(edIDText.text) then begin
showerror('Player ID text is not correct. Please, retype it in.');
options_window.PageSeL.SelectedItem:=1;
options_window.PageSeL.OnClick(options_window.pagesel);
options_window.ActiveControl:=options_window.edIdText;
exit;end;
//checksum_opt_read;
options_apply;

checksum_opt_store;

reload_user_interface;
reload_image;
options_save;
options_load;

reload_options_checker_values;
debug_add('preferences applied');
debug_add('close preferences window');
timer_stop;
main.Enabled:=true;
main.show;
language_load;
language_apply;

options_window.hide;
settime(0,0);	{0.47} {we're going realtime}
checksum_all_store;
if opt.doShowCounters then counters_show else counters_hide;
//parse_counter;
if ischeatmode then main.NewBtn.click;
end;



procedure TOptions_window.PageSeLClick(Sender: TObject);
begin
if PageSel.SelectedItem=10 then begin // IRC
pMouse.BringToFront;
pMouse.show;
//pUser.hide;
pUser.hide;
pStyle.hide;
pCheat.hide;
pLanguage.hide;
pMult.hide;
pSystem.hide;
pAutomation.hide;
pCounter.Hide;
pIRC.hide;
pMouse.Left:=112;
pMouse.top:=8;
exit;end;

if PageSel.SelectedItem=9 then begin // IRC
pIRC.BringToFront;
pIRC.show;
//pUser.hide;
pUser.hide;
pStyle.hide;
pCheat.hide;
pLanguage.hide;
pMult.hide;
pSystem.hide;
pAutomation.hide;
pCounter.Hide;
pMouse.hide;
pIRC.Left:=112;
pIRC.top:=8;
exit;end;


if PageSel.SelectedItem=8 then begin // COUNTER
pCounter.BringToFront;
pCounter.show;
//pUser.hide;
pUser.hide;
pStyle.hide;
pCheat.hide;
pLanguage.hide;
pMult.hide;
pSystem.hide;
pAutomation.hide;
pIRC.hide;
pMouse.hide;
pCounter.Left:=112;
pCounter.top:=8;
exit;end;

if PageSel.SelectedItem=1 then begin // USER
pUser.BringToFront;
pUser.show;
//pUser.hide;
pStyle.hide;
pCheat.hide;
pLanguage.hide;
pMult.hide;
pSystem.hide;
pAutomation.hide;
pCounter.hide;
pIRC.hide;
pMouse.hide;
pUser.Left:=112;
pUser.top:=8;
exit;end;

if PageSel.SelectedItem=2 then begin // STYLE
pStyle.BringToFront;
pStyle.show;
pUser.hide;
//pStyle.hide;
pCheat.hide;
pLanguage.hide;
pMult.hide;
pSystem.hide;
pAutomation.hide;
pCounter.hide;
pIRC.hide;
pMouse.hide;
pStyle.Left:=112;
pStyle.top:=8;
exit;end;

if PageSel.SelectedItem=3 then begin // CHEAT
pCheat.BringToFront;
pCheat.show;
pUser.hide;
pStyle.hide;
//pCheat.hide;
pLanguage.hide;
pMult.hide;
pSystem.hide;
pAutomation.hide;
pCounter.hide;
pIRC.hide;
pMouse.hide;
pCheat.Left:=112;
pCheat.top:=8;
exit;end;

if PageSel.SelectedItem=4 then begin // SYSTEM
pSystem.BringToFront;
pSystem.show;
pUser.hide;
pStyle.hide;
pCheat.hide;
pLanguage.hide;
pMult.hide;
//pSystem.hide;
pAutomation.hide;
pCounter.hide;
pIRC.hide;
pMouse.hide;
pSystem.Left:=112;
pSystem.top:=8;
exit;end;


if PageSel.SelectedItem=5 then begin
pLanguage.BringToFront;
pLanguage.show;
pUser.hide;
pStyle.hide;
pCheat.hide;
//pLanguage.hide;
pMult.hide;
pSystem.hide;
pAutomation.hide;
langFLB.Directory:=opt.AppPath;
pCounter.hide;
pIRC.hide;
pMouse.hide;
pLanguage.Left:=112;
pLanguage.top:=8;
exit;end;

if PageSel.SelectedItem=6 then begin
pAutomation.BringToFront;
pAutomation.show;
pUser.hide;
pStyle.hide;
pCheat.hide;
pLanguage.hide;
pMult.hide;
pSystem.hide;
pCounter.hide;
pIRC.hide;
pMouse.hide;
//pAutomation.hide;
pAutomation.Left:=112;
pAutomation.top:=8;
exit;end;

if PageSel.SelectedItem=7 then begin
pMult.BringToFront;
pMult.show;
pUser.hide;
pStyle.hide;
pCheat.hide;
pLanguage.hide;
//pMult.hide;
pSystem.hide;
pAutomation.hide;
pCounter.hide;
pMouse.hide;
pIRC.hide;
pMult.Left:=112;
pMult.top:=8;
exit;end;
end;

procedure TOptions_window.FormCreate(Sender: TObject);
begin
options_form_created:=true;
imLogo.Picture:=main.imLogo.picture;
defaultBtn.left:=8;
PageSel.SelectedItem:=1;
//width:=382;
//pagesel.OnClick(pagesel);
pUser.BringToFront;
pUser.show;
//pUser.hide;
pStyle.hide;
pCheat.hide;
pLanguage.hide;
pMult.hide;
pSystem.hide;
pAutomation.hide;
pCounter.hide;
pirc.hide;

pUser.Left:=112;
pUser.top:=8;
pUser.height:=429;
pUser.Width:=361;
pStyle.Left:=112;
pStyle.top:=8;
pStyle.height:=429;
pStyle.Width:=361;
pCheat.Left:=112;
pCheat.top:=8;
pCheat.height:=429;
pCheat.Width:=361;
pLanguage.Left:=112;
pLanguage.top:=8;
pLanguage.height:=429;
pLanguage.Width:=361;
pMult.Left:=112;
pMult.top:=8;
pMult.height:=429;
pMult.Width:=361;
pSystem.Left:=112;
pSystem.top:=8;
pSystem.height:=429;
pSystem.Width:=361;
pAutomation.Left:=112;
pAutomation.top:=8;
pAutomation.height:=429;
pAutomation.Width:=361;
pCounter.Left:=112;
pCounter.top:=8;
pCounter.height:=429;
pCounter.Width:=361;
pIRC.Left:=112;
pIRC.top:=8;
pIRC.height:=429;
pIRC.Width:=361;
pMouse.Left:=112;
pMouse.top:=8;
pMouse.height:=429;
pMouse.Width:=361;


applyBtn.top:=puser.top+pUser.height+8;
DefaultPageBtn.top:=puser.top+pUser.height+8;
cancelBtn.top:=puser.top+pUser.height+8;
defaultBtn.top:=puser.top+pUser.height+8;
clientheight:=defaultbtn.top+defaultbtn.height+8;
clientwidth:=pUser.Left+pUser.Width+8;


DefaultPageBtn.left:=pUser.left;
applyBtn.left:=clientwidth-8-applyBtn.width;
cancelBtn.left:=applyBtn.left-8-cancelBtn.width;


//showerror(inttostr(pUser.Top+pUser.height-bevel8.height));
//bevel8.Top:=pUser.Top+pUser.height-bevel8.height;//236+12;

reload_options_checker_values;
if doLoadcnttempl then load_counters_template;
if doLoadauttempl then load_autosave_template;
//alwaysontop_apply;
//if opt.doAlwaysOnTop then FormStyle:=fsStayonTop;
//language_apply;
lAutoCopyFormat.caption:=cap_opt_lAutoCopyFormat;
lColorScheme.caption:=cap_opt_lColorScheme;
cbBlastedCopyIRC.caption:=cap_opt_cbBlastedCopyTemplate;
cbFinishedCopyIRC.caption:=cap_opt_cbFinishedCopyTemplate;
cbUseSmiles.caption:=cap_opt_cbusesmiles;
cbCountersExcludeList.caption:=cap_opt_cbCountersExcludeList;
sbflushlist.Caption:=cap_opt_sbflushlist;

cbChangeLayout.caption:=cap_opt_dochangeLayout;
cbDarkenBoard.Caption:=cap_opt_cbDarkenBoard;
cbShowCells.caption:=cap_opt_cbShowCells;
cbShowMousePath.caption:=cap_opt_cbShowMousePath;
cbShowDownState.caption:=cap_opt_cbShowDownState;
cbShowLeftCl.caption:=cap_opt_cbShowLeftCl;
cbShowRightCl.caption:=cap_opt_cbShowRightCl;
cbShowDoubleCl.caption:=cap_opt_cbShowDoubleCl;
lmpcolor.caption:=cap_opt_lmpcolor;
llclcolor.caption:=cap_opt_llclcolor;
lrclcolor.caption:=cap_opt_lrclcolor;
ldclcolor.caption:=cap_opt_ldclcolor;



options_window.Caption:=Cap_Opt_Caption;
options_window.DefaultBtn.Caption:=cap_opt_defaultbtn;
options_window.DefaultPageBtn.Caption:=cap_opt_defaultpagebtn;
options_window.CancelBtn.Caption:=cap_opt_cancelbtn;
options_window.ApplyBtn.Caption:=cap_opt_applybtn;
options_window.PageSeL.Items[1].Text:=Cap_Opt_page1;
options_window.PageSeL.Items[2].Text:=Cap_Opt_page2;
options_window.PageSeL.Items[3].Text:=Cap_Opt_page3;
options_window.PageSeL.Items[4].Text:=Cap_Opt_page4;
options_window.PageSeL.Items[5].Text:=Cap_Opt_page5;
options_window.PageSeL.Items[6].Text:=Cap_Opt_page6;
options_window.PageSeL.Items[7].Text:=Cap_Opt_page7;
options_window.lpage1.Caption:=Cap_Opt_lpage1;
options_window.lpage2.Caption:=Cap_Opt_lpage2;
options_window.lpage3.Caption:=Cap_Opt_lpage3;
options_window.lpage4.Caption:=Cap_Opt_lpage4;
options_window.lpage5.Caption:=Cap_Opt_lpage5;
options_window.lpage6.Caption:=Cap_Opt_lpage6;
options_window.lpage7.Caption:=Cap_Opt_lpage7;
options_window.lpage8.Caption:=Cap_Opt_lpage8;
options_window.lpage9.Caption:=Cap_Opt_lpage9;
options_window.lpage10.Caption:=Cap_Opt_lpage10;

options_window.cbluserid.Caption:=Cap_Opt_luserid;
options_window.lReplayName.caption:=Cap_Opt_lreplayname;
options_window.lModeName.caption:=Cap_Opt_lModeName;
options_window.lReplayFileName.caption:=Cap_Opt_lreplayFileName;

options_window.lCountry.Caption:=Cap_Opt_lCountry;

options_window.cbHistLog.Caption:=Cap_Opt_cbhistlog;
Options_window.cbDotSeparator.Caption:=cap_opt_dotseparator;
Options_window.cbExecuteCounters.caption:=cap_opt_doexecutecounters;

options_window.lstartupmode.Caption:=Cap_Opt_startupmode;
Options_window.sbLoadCnt.Caption:=cap_bLoad;
Options_window.sbSaveCnt.Caption:=cap_bSave;
Options_window.sbLoadAut.Caption:=cap_bLoad;
Options_window.sbSaveAut.Caption:=cap_bSave;
Options_window.sbDefaultAut.Caption:=cap_opt_defaultbtn;

Options_window.sbAddFormula.Caption:=cap_opt_formbuilder;

options_window.lserowswidth.Caption:=Cap_Opt_rowswidth;
options_window.lserows.Caption:=Cap_Opt_rows;
options_window.lcounterstext.Caption:=Cap_Opt_counterstext;

options_window.rBeg.Caption:=Cap_Opt_rbeg;
options_window.rInt.Caption:=Cap_Opt_rint;
options_window.rExp.Caption:=Cap_Opt_rexp;
options_window.lskin.Caption:=Cap_Opt_lskin;
options_window.ltimerskin.Caption:=Cap_Opt_ltimerskin;
options_window.cbMarks.Caption:=Cap_Opt_cbmarks;
options_window.cbTenths.Caption:=Cap_Opt_cbtenths;
options_window.cbDoTimer.Caption:=cap_opt_doTimer;
options_window.cbShowEquals.Caption:=Cap_Opt_cbshowequals;

options_window.cbShowCounters.Caption:=Cap_Opt_cbshowcounters;
options_window.cbShowCountersTitle.Caption:=Cap_Opt_cbshowcountersTitle;
options_window.cbShowCntGreenBorder.caption:=Cap_Opt_cbShowCntGreenBorder;
options_window.cbCntOnFinish.caption:=cap_opt_doCntOnFinish;
options_window.cbCntOnEnd.caption:=cap_opt_doCntOnEnd;

options_window.cbClearanceOnFail.Caption:=Cap_Opt_cbclearonfail;
options_window.cbFillFlags.Caption:=cap_opt_cbFillFlags;
options_window.cbClearanceOnMiddleBtn.Caption:=Cap_Opt_clearonmiddle;
options_window.cbClearanceOnLeftBtn.Caption:=Cap_Opt_clearonleft;
options_window.cbDisableTimer.Caption:=Cap_Opt_cbdisabletimer;
options_window.cbZeroTimer0.Caption:=Cap_Opt_cbStartzero;
options_window.cbAutoFlagSet.Caption:=Cap_Opt_cbautoflagset;
options_window.cbDisableGroupOpen.Caption:=Cap_Opt_cbdisablegroupopen;
options_window.cbDisableRightClick.Caption:=Cap_Opt_cbdisablerightclick;
options_window.cbInfiniteLives.Caption:=cap_opt_cblives;
options_window.cbShowProbabilities.Caption:=cap_opt_cbshowprob;
options_window.cbShowMines.Caption:=cap_opt_cbshowmines;
options_window.cbForcedNewGame.Caption:=cap_opt_cbforcednewgame;
options_window.cbForcedNewGameBEEP.Caption:=cap_opt_cbforcednewgameBEEP;


options_window.cbShow3BVafterGameStart.Caption:=cap_opt_cbshow3bvafterstart;
options_window.cbMustHave7.Caption:=cap_opt_cbhave7;
options_window.cbMustHave8.Caption:=cap_opt_cbhave8;
options_window.cbApprox3BV.Caption:=cap_opt_cbapprox;
options_window.cbApprox3BV2.Caption:=cap_opt_cbapprox2;
options_window.lattempts.Caption:=cap_opt_cbattempts;
options_window.cbSetHighPriority.Caption:=cap_opt_cbhighpriority;
options_window.cbSeekPlugins.Caption:=cap_opt_cbSeekPlugins;
//options_window.cbDoNotSaveLastReplays.Caption:=cap_opt_doNotSaveLastReplays;
options_window.cbBlit.Caption:=cap_opt_cbBlit;
options_window.cbEnableBossKey.Caption:=cap_opt_cbenablebosskey;
options_window.cbClipCur.Caption:=cap_opt_cbclipcursor;
options_window.cbAlwaysOnTop.Caption:=cap_opt_cbontop;
options_window.cbProhibitMultInstances.Caption:=cap_opt_cbprohibitinstances;
options_window.sbJustifyByCenter.Caption:=cap_opt_bjustify;
options_window.sbRegAVFext.Caption:=cap_opt_bregext;
options_window.sbShortcut.Caption:=cap_opt_bshortcut;
options_window.llangsel.Caption:=cap_opt_llangsel;
options_window.mTranslateMe.Text:=cap_translateme;
options_window.cbCond1.Caption:=cap_opt_cbcond1;
options_window.lmultwarn.Caption:=cap_opt_lmultwarn;
options_window.cbBlockChat.Caption:=cap_opt_cbblockchat;
options_window.cbProcListGrab.Caption:=cap_opt_cblistgrab;
options_window.cbSysInfGrab.Caption:=cap_opt_cbsysinfgrab;
end;

procedure TOptions_window.CancelBtnClick(Sender: TObject);
begin
timer_stop;
main.Enabled:=true;
main.show;
options_window.hide;
end;

procedure TOptions_window.sb3Click(Sender: TObject);
begin
showerror(cap_opt_cheat_warn);
end;

procedure TOptions_window.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
main.Enabled:=true;
main.show;
options_window.hide;
end;

procedure TOptions_window.sb4Click(Sender: TObject);
begin
//showerror('Replays would be saved to the Minesweeper Arbiter''s default '+
//'folder. Please, read the Help file for more condition explanations');
showerror(cap_opt_cbautowarn);
end;



procedure TOptions_window.DefaultBtnClick(Sender: TObject);
var s:array[0..11]of string;
begin
activecontrol:=ApplyBtn;
if messagedlg('Are you sure you want to reset the Preferences?',
mtConfirmation,[mbYes,mbNo],0)=mrYes then
begin
with opt do begin
s[0]:=hsBegTime;
s[1]:=hsBegName;
s[2]:=hsBegJump;
s[3]:=hsIntTime;
s[4]:=hsIntName;
s[5]:=hsIntJump;
s[6]:=hsExpTime;
s[7]:=hsExpName;
s[8]:=hsExpJump;
s[9]:=hsBeg3bvs;
s[10]:=hsInt3bvs;
s[11]:=hsExp3bvs;
options_load_default;
hsBegTime:=s[0];
hsBegName:=s[1];
hsBegJump:=s[2];
hsIntTime:=s[3];
hsIntName:=s[4];
hsIntJump:=s[5];
hsExpTime:=s[6];
hsExpName:=s[7];
hsExpJump:=s[8];
hsBeg3bvs:=s[9];
hsInt3bvs:=s[10];
hsExp3bvs:=s[11];
checksum_opt_store;
end;
reload_options_checker_values;

options_window.PageSeL.SelectedItem:=1;
options_window.PageSeL.OnClick(options_window.pagesel);
end;
//options_apply;
//options_save;
//options_load;
end;

procedure TOptions_window.sbRegAVFextClick(Sender: TObject);
begin
register_extension_avf;
end;

procedure TOptions_window.sbShortcutClick(Sender: TObject);
var WorkTable:String;P:PItemIDList;C:array [0..1000] of char;
begin
try
if SHGetSpecialFolderLocation(Handle,CSIDL_DESKTOP,p)=NOERROR then
   begin
   SHGetPathFromIDList(P,C);
   WorkTable:=StrPas(C);
   end;
if FileExists(WorkTable+'\Minesweeper Arbiter.exe') then
   DeleteFile(WorkTable+'\Minesweeper Arbiter.exe');
CreateShortCut(Application.ExeName, WorkTable+'\Minesweeper Arbiter.exe', '');
except end;
end;

procedure TOptions_window.sbJustifyByCenterClick(Sender: TObject);
begin
main.Left:=trunc((screen.Width-main.Width)/2);
main.Top:=trunc((screen.Height-main.Height)/2);
checksum_opt_read;
opt.posMainX:=main.left;
opt.posMainY:=main.top;
checksum_opt_store;
end;

procedure TOptions_window.cbHistLogClick(Sender: TObject);
begin
if not cbHistLog.Checked then options_window.cbHistLog.Font.Color:=clRed
   else options_window.cbHistLog.Font.Color:=options_window.Font.Color;
if not cbHistLog.Checked then
showerror('Do not forget to check the history logging on when '+
'you will start the serious trainings.');
end;

procedure TOptions_window.cbBlitClick(Sender: TObject);
begin
if not cbBlit.Checked then
showerror('BitBlt draw method is the fastest method and allocates '+
'less system resources. It is strongly recommended to check it ON.');
end;

procedure TOptions_window.ExitBtnClick(Sender: TObject);
begin
main.Enabled:=true;
main.show;
options_window.hide;
if opt.doShowCounters then counters_show else counters_hide;
end;

procedure TOptions_window.sb2Click(Sender: TObject);
begin
showerror('Counter Indicator format (1 Line):'#13#10+
'template:'#13#10#9+
'(show_case_status) caption_template | formula_template'#13#10+
'example:'#13#10#9+
'REP <3bv/s_caption>|<3bv>/<time>'#13#10+
'output:'#13#10#9+
'3BV/s    2,83'#13#10#13#10+
cap_counter_help);
end;

procedure TOptions_window.mtemplateKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
lpos.Caption:='[ '+inttostr(mtemplate.lines.count)+' ]';
end;

procedure TOptions_window.mtemplateMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
lpos.Caption:='[ '+inttostr(mtemplate.lines.count)+' ]';
end;

procedure TOptions_window.mtemplateClick(Sender: TObject);
begin
lpos.Caption:='[ '+inttostr(mtemplate.lines.count)+' ]';
end;

procedure TOptions_window.mtemplateChange(Sender: TObject);
begin
lpos.Caption:='[ '+inttostr(mtemplate.lines.count)+' ]';
end;

procedure TOptions_window.sb5Click(Sender: TObject);
begin
showerror('Read Help file to know more about game text information '+
   'autocopying for IRC clients. This includes:'#13#10#13#10+
   '   color formats'#13#10+
   '   templates for autocopying'#13#10+
   '   exclude list of counters window indicators');
end;

procedure TOptions_window.sbAddFormulaClick(Sender: TObject);
begin
mtemplate_clearempty;
formula.ActiveControl:=formula.edF;
formula.show;
Enabled:=false;
end;

procedure TOptions_window.sbSaveCntClick(Sender: TObject);
begin
sd.InitialDir:=opt.AppPath;
if sd.execute then
  if sd.FileName<>'' then
  try
  if fileexists(sd.filename)then
  if messagedlg('File exists. Overwrite File?',mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;

  mtemplate.Lines.SaveToFile(sd.filename);
  debug_add('counters template file saved');
  except
  showerror(cap_file_not_saved);
  debug_add('#error: counters template file: '+cap_file_not_saved);
  end;
end;

procedure TOptions_window.sbLoadCntClick(Sender: TObject);
begin
if messagedlg(cap_file_templ_do_save_question,mtConfirmation,[mbYes,mbNo],0)=mrYes then
   begin sbSaveCnt.click;end;

od.InitialDir:=opt.AppPath;
if od.execute then
  if od.FileName<>'' then
  if fileexists(od.FileName) then
  try
  mtemplate.Lines.LoadFromFile(od.filename);
  debug_add('counters template file loaded');
  except
  showerror(cap_file_not_loaded);
  debug_add('#error: counters template file: '+cap_file_not_loaded);
  end;
end;

procedure TOptions_window.sbflushlistClick(Sender: TObject);
var i:integer;
begin
try
if messagedlg('This will fill the list with ALL indicators from Counters window. You will need to edit it manuallu to leave only those indicators, which you do not want to see in the IRC scripts. Continue?',
mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
mCntExcludeList.Clear;
for i:=0 to counters.sg.RowCount-1 do
   mCntExcludeList.Lines.Add(counters.sg.Cells[0,i]);
   debug_add('#irc counters exclude list filled');
except showerror('err');
   end;
end;

procedure TOptions_window.cbMarksClick(Sender: TObject);
begin
  if options_window.cbMarks.Checked then options_window.cbMarks.Font.Color:=clRed
     else options_window.cbMarks.Font.Color:=options_window.Font.Color;
if options_window.cbMarks.Checked then
showerror('Do not forget to check the marks off when '+
'you will start the serious trainings.');
end;

procedure TOptions_window.DefaultPageBtnClick(Sender: TObject);
begin
activecontrol:=ApplyBtn;
if messagedlg('Reload setting on this page?',
mtConfirmation,[mbYes,mbNo],0)=mrYes then
   reload_options_checker_values;
end;

procedure TOptions_window.cbChangeLayoutClick(Sender: TObject);
begin
if not cbChangeLayout.checked then begin
cbdarkenboard.Checked:=false;
cbshowcells.Checked:=false;exit;end;
if cbChangeLayout.checked then begin
cbdarkenboard.Checked:=true;
cbshowcells.Checked:=true;exit;end;
end;

procedure TOptions_window.boxCountryChange(Sender: TObject);
var countrynumber:integer;
begin
countrynumber:=name_to_country();
if CountryNumber>0 then begin
   Options_window.imFlag.Picture:=main.IEmpty.Picture;
   main.imC.GetBitmap(CountryNumber,Options_window.imFlag.picture.bitmap);
end
else
	Options_window.imFlag.Picture:=main.IEmpty.Picture;
end;

procedure TOptions_window.sbloadautClick(Sender: TObject);
begin
if messagedlg(cap_file_templ_do_save_question,mtConfirmation,[mbYes,mbNo],0)=mrYes then
   begin sbSaveCnt.click;end;
od.InitialDir:=opt.AppPath;
if od.execute then
  if od.FileName<>'' then
  if fileexists(od.FileName) then
  try
  auttempl.Lines.LoadFromFile(od.filename);
  debug_add('automatical saving template file loaded');
  except
  showerror(cap_file_not_loaded);
  debug_add('#error: automatical saving template file: '+cap_file_not_loaded);
  end;
end;

procedure TOptions_window.sbSaveAutClick(Sender: TObject);
begin
sd.InitialDir:=opt.AppPath;
if sd.execute then
  if sd.FileName<>'' then
  try
  if fileexists(sd.filename)then
  if messagedlg('File exists. Overwrite File?',mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
  auttempl.Lines.SaveToFile(sd.filename);
  debug_add('automatical saving template file saved');
  except
  showerror(cap_file_not_saved);
  debug_add('#error: automatical saving template file: '+cap_file_not_saved);
  end;
end;

procedure TOptions_window.sbDefaultAutClick(Sender: TObject);
begin
if messagedlg('Are you sure you want to reset automatical replay saving templates',mtConfirmation,[mbYes,mbNo],0)=mrNo then exit;
load_def_autosave_template;
end;

end.
