unit Flocal_high_scores;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Menus, ComCtrls, Tabnotbk, Grids, Ffuncstats;

type
  TLocal_High_Scores = class(TForm)
    MainMenu1: TMainMenu;
    ExitBtn: TMenuItem;
    pager: TPageControl;
    page1: TTabSheet;
    page2: TTabSheet;
    page3: TTabSheet;
    page4: TTabSheet;
    page5: TTabSheet;
    page6: TTabSheet;
    sg1: TStringGrid;
    sg2: TStringGrid;
    sg3: TStringGrid;
    sg4: TStringGrid;
    sg5: TStringGrid;
    sg6: TStringGrid;
    lhspopup: TPopupMenu;
    savehtmlbtn: TMenuItem;
    sd: TSaveDialog;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure ReloadBtnClick(Sender: TObject);
    procedure page1Show(Sender: TObject);
    procedure page2Show(Sender: TObject);
    procedure page3Show(Sender: TObject);
    procedure page4Show(Sender: TObject);
    procedure page5Show(Sender: TObject);
    procedure page6Show(Sender: TObject);
    procedure savehtmlbtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Local_High_Scores: TLocal_High_Scores;

implementation

uses FFunc, FMain, FData,FCap;
{$R *.DFM}

{with opt do if
(hsBegTime='999,000')and
(hsBegName='Anonymous')and
(hsintTime='999,000')and
(hsintName='Anonymous')and
(hsexpTime='999,000')and
(hsexpName='Anonymous')
and(hsBeg3bvs='0,00')and(hsInt3bvs='0,00')and(hsExp3bvs='0,00')
then exit;  }
//if messagedlg(cap_lhs_ask,mtConfirmation,[mbYes,mbNo],0)=mrYes then
{localhighscores_reset;}

procedure TLocal_High_Scores.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
//main.Enabled:=true;
//main.show;
//local_high_scores.hide;

	timer_stop;
	main.Enabled:=true;
	main.show;
	local_high_scores.hide;
	if opt.doShowCounters then counters_show else counters_hide;
end;

procedure TLocal_High_Scores.FormCreate(Sender: TObject);
begin
local_high_scores_form_created:=true;
//imLogo.Picture:=main.imLogo.picture;
//alwaysontop_apply;
//if opt.doAlwaysOnTop then local_high_scores.FormStyle:=fsStayonTop;
//language_apply;
local_high_scores.Caption:=cap_lhs_caption;
Local_High_Scores.savehtmlbtn.Caption:=cap_lhs_savetable;

{local_high_scores.lmode.Caption:=cap_lhs_lmode;
local_high_scores.lbeg.Caption:=cap_lhs_lbeg;
local_high_scores.lInt.Caption:=cap_lhs_lint;
local_high_scores.lExp.caption:=cap_lhs_lexp;
local_high_scores.lTime.Caption:=cap_lhs_ltime;
local_high_scores.lJump.Caption:=cap_lhs_ljump;
local_high_scores.l3bvs.Caption:=cap_lhs_l3bvs;
local_high_scores.lName.Caption:=cap_lhs_lname;}
//local_high_scores.ResetBtn.Caption:=cap_lhs_resetbtn;
//local_high_scores.ReloadBtn.Caption:=cap_lhs_reloadbtn;
end;

procedure TLocal_High_Scores.ExitBtnClick(Sender: TObject);
begin
timer_stop;
main.Enabled:=true;
main.show;
local_high_scores.hide;
if opt.doShowCounters then counters_show else counters_hide;
end;

procedure TLocal_High_Scores.ReloadBtnClick(Sender: TObject);
begin
end;
{procedure TLocal_High_Scores.ReloadBtnClick(Sender: TObject);
begin

   localhighscores_reload;
end;}

procedure TLocal_High_Scores.page1Show(Sender: TObject);
var i:longword;
    sumtime:single;
    sumbvs:single;
    sumios:single;
    sumrqp:single;
    sumioe:single;
//    sumobv:single;
begin
sg1.ColCount:=3;
sg1.RowCount:=25;
sg1.ColWidths[0]:=170;
sg1.ColWidths[1]:=84;
sg1.ColWidths[2]:=160;
//time
sg1.Cols[0][0]:='';
sg1.Cols[1][0]:=cap_lTime;
sg1.Cols[2][0]:=cap_date;
sg1.Cols[0][1]:=cap_main_beginnerbtn;
sg1.Cols[0][2]:=cap_main_intermediatebtn;
sg1.Cols[0][3]:=cap_main_Expertbtn;
sg1.Cols[0][4]:=cap_total;
sumtime:=0;
i:=get_best_time(0);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][1]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg1.Cols[2][1]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][1]:=fl2str(999,000);
    sumtime:=sumtime+999.000;
    end;
i:=get_best_time(1);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][2]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg1.Cols[2][2]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][2]:=fl2str(999,000);
    sumtime:=sumtime+999.000;
    end;
i:=get_best_time(2);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][3]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg1.Cols[2][3]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][3]:=fl2str(999,000);
    sumtime:=sumtime+999.0009;
    end;
if(opt.doRecorderStyletimer) then sumtime:=sumtime+3;
if sumtime>999.000 then sumtime:=999.000;
sg1.cols[1][4]:=exttostr(sumtime);

//-----------------3bv/s----------------------
sg1.Cols[0][5]:='';
sg1.Cols[1][5]:=cap_l3bvs;
sg1.Cols[2][5]:=cap_date;
sg1.Cols[0][6]:=cap_main_beginnerbtn;
sg1.Cols[0][7]:=cap_main_intermediatebtn;
sg1.Cols[0][8]:=cap_main_Expertbtn;
sg1.Cols[0][9]:=cap_total;

sumbvs:=0;
i:=get_best_bvs(0);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][6]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg1.Cols[2][6]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][6]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

i:=get_best_bvs(1);
if hist[i].dateDay>0 then
    begin       
    sg1.Cols[1][7]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg1.Cols[2][7]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][7]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

i:=get_best_bvs(2);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][8]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg1.Cols[2][8]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][8]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

sg1.cols[1][9]:=exttostr(sumbvs);

//rqp
sg1.Cols[0][10]:='';
sg1.Cols[1][10]:=cap_rqp;
sg1.Cols[2][10]:=cap_date;
sg1.Cols[0][11]:=cap_main_beginnerbtn;
sg1.Cols[0][12]:=cap_main_intermediatebtn;
sg1.Cols[0][13]:=cap_main_Expertbtn;
sg1.Cols[0][14]:=cap_total;
sumrqp:=0;
i:=get_best_rqp(0);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][11]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg1.Cols[2][11]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][11]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
i:=get_best_rqp(1);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][12]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg1.Cols[2][12]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][12]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
i:=get_best_rqp(2);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][13]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg1.Cols[2][13]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][13]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
if sumrqp>999.000 then sumrqp:=999.000;
sg1.cols[1][14]:=exttostr(sumrqp);

//-------------IOS--------------
sg1.Cols[0][15]:='';
sg1.Cols[1][15]:=cap_ios;
sg1.Cols[2][15]:=cap_date;
sg1.Cols[0][16]:=cap_main_beginnerbtn;
sg1.Cols[0][17]:=cap_main_intermediatebtn;
sg1.Cols[0][18]:=cap_main_Expertbtn;
sg1.Cols[0][19]:=cap_total;
sumios:=0;
i:=get_best_ios(0);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][16]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg1.Cols[2][16]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][16]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
i:=get_best_ios(1);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][17]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg1.Cols[2][17]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][17]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
i:=get_best_ios(2);
if hist[i].dateDay>0 then
    begin
    sg1.Cols[1][18]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg1.Cols[2][18]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][18]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
sg1.cols[1][19]:=exttostr(sumios);

//IOE
sg1.Cols[0][20]:='';
sg1.Cols[1][20]:=cap_ioeff;
sg1.Cols[2][20]:=cap_date;
sg1.Cols[0][21]:=cap_main_beginnerbtn;
sg1.Cols[0][22]:=cap_main_intermediatebtn;
sg1.Cols[0][23]:=cap_main_Expertbtn;
sg1.Cols[0][24]:=cap_total;

sumioe:=0;
i:=get_best_ioeff(0);
if hist[i].dateDay>0 then
    begin
	{0.47} {ioe isn't correctness}
    {sg1.Cols[1][21]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));}
    {sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg1.Cols[1][21]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);
    sg1.Cols[2][21]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][21]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
i:=get_best_ioeff(1);
if hist[i].dateDay>0 then
    begin
	{0.47}
    {sg1.Cols[1][22]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));
    sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg1.Cols[1][22]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);
    sg1.Cols[2][22]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][22]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
i:=get_best_ioeff(2);
if hist[i].dateDay>0 then
    begin
	{0.47}
    {sg1.Cols[1][23]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));
    sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg1.Cols[1][23]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);	
    sg1.Cols[2][23]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg1.Cols[1][23]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
sg1.cols[1][24]:=exttostr(sumioe);

//OBV
{sg1.Cols[0][20]:='';
sg1.Cols[1][20]:=cap_ioe;
sg1.Cols[2][20]:=cap_date;
sg1.Cols[0][21]:=cap_main_beginnerbtn;
sg1.Cols[0][22]:=cap_main_intermediatebtn;
sg1.Cols[0][23]:=cap_main_Expertbtn;
sg1.Cols[0][24]:=cap_total;}

end;

procedure TLocal_High_Scores.page2Show(Sender: TObject);
var i:longword;
    sumtime:single;
    sumbvs:single;
    sumios:single;
    sumrqp:single;
    sumioe:single;
//    sumobv:single;
begin
sg2.ColCount:=3;
sg2.RowCount:=25;
sg2.ColWidths[0]:=170;
sg2.ColWidths[1]:=84;
sg2.ColWidths[2]:=160;
//time
sg2.Cols[0][0]:='';
sg2.Cols[1][0]:=cap_lTime;
sg2.Cols[2][0]:=cap_date;
sg2.Cols[0][1]:=cap_main_beginnerbtn;
sg2.Cols[0][2]:=cap_main_intermediatebtn;
sg2.Cols[0][3]:=cap_main_Expertbtn;
sg2.Cols[0][4]:=cap_total;
sumtime:=0;
i:=get_best_ftime(0);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][1]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg2.Cols[2][1]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][1]:=fl2str(999,000);
    sumtime:=sumtime+999.000;
    end;
i:=get_best_ftime(1);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][2]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg2.Cols[2][2]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][2]:=fl2str(999,000);
    sumtime:=sumtime+999.000;
    end;
i:=get_best_ftime(2);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][3]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg2.Cols[2][3]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][3]:=fl2str(999,000);
    sumtime:=sumtime+999.0009;
    end;
if(opt.doRecorderStyletimer) then sumtime:=sumtime+3;
if sumtime>999.000 then sumtime:=999.000;
sg2.cols[1][4]:=exttostr(sumtime);

//-----------------3bv/s----------------------
sg2.Cols[0][5]:='';
sg2.Cols[1][5]:=cap_l3bvs;
sg2.Cols[2][5]:=cap_date;
sg2.Cols[0][6]:=cap_main_beginnerbtn;
sg2.Cols[0][7]:=cap_main_intermediatebtn;
sg2.Cols[0][8]:=cap_main_Expertbtn;
sg2.Cols[0][9]:=cap_total;

sumbvs:=0;
i:=get_best_fbvs(0);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][6]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg2.Cols[2][6]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][6]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

i:=get_best_fbvs(1);
if hist[i].dateDay>0 then
    begin       
    sg2.Cols[1][7]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg2.Cols[2][7]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][7]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

i:=get_best_fbvs(2);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][8]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg2.Cols[2][8]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][8]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

sg2.cols[1][9]:=exttostr(sumbvs);

//rqp
sg2.Cols[0][10]:='';
sg2.Cols[1][10]:=cap_rqp;
sg2.Cols[2][10]:=cap_date;
sg2.Cols[0][11]:=cap_main_beginnerbtn;
sg2.Cols[0][12]:=cap_main_intermediatebtn;
sg2.Cols[0][13]:=cap_main_Expertbtn;
sg2.Cols[0][14]:=cap_total;
sumrqp:=0;
i:=get_best_frqp(0);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][11]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg2.Cols[2][11]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][11]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
i:=get_best_frqp(1);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][12]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg2.Cols[2][12]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][12]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
i:=get_best_frqp(2);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][13]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg2.Cols[2][13]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][13]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
if sumrqp>999.000 then sumrqp:=999.000;
sg2.cols[1][14]:=exttostr(sumrqp);

//-------------IOS--------------
sg2.Cols[0][15]:='';
sg2.Cols[1][15]:=cap_ios;
sg2.Cols[2][15]:=cap_date;
sg2.Cols[0][16]:=cap_main_beginnerbtn;
sg2.Cols[0][17]:=cap_main_intermediatebtn;
sg2.Cols[0][18]:=cap_main_Expertbtn;
sg2.Cols[0][19]:=cap_total;
sumios:=0;
i:=get_best_fios(0);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][16]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg2.Cols[2][16]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][16]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
i:=get_best_fios(1);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][17]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg2.Cols[2][17]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][17]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
i:=get_best_fios(2);
if hist[i].dateDay>0 then
    begin
    sg2.Cols[1][18]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg2.Cols[2][18]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][18]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
sg2.cols[1][19]:=exttostr(sumios);

//IOE
sg2.Cols[0][20]:='';
sg2.Cols[1][20]:=cap_ioeff;
sg2.Cols[2][20]:=cap_date;
sg2.Cols[0][21]:=cap_main_beginnerbtn;
sg2.Cols[0][22]:=cap_main_intermediatebtn;
sg2.Cols[0][23]:=cap_main_Expertbtn;
sg2.Cols[0][24]:=cap_total;

sumioe:=0;
i:=get_best_fioe(0);
if hist[i].dateDay>0 then
    begin
    {sg2.Cols[1][21]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));
    sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg2.Cols[1][21]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);	
    sg2.Cols[2][21]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][21]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
i:=get_best_fioe(1);
if hist[i].dateDay>0 then
    begin
    {sg2.Cols[1][22]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));
    sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg2.Cols[1][22]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);				
    sg2.Cols[2][22]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][22]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
i:=get_best_fioe(2);
if hist[i].dateDay>0 then
    begin
    {sg2.Cols[1][23]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));
    sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg2.Cols[1][23]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);				
    sg2.Cols[2][23]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg2.Cols[1][23]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
sg2.cols[1][24]:=exttostr(sumioe);

//OBV
{sg2.Cols[0][20]:='';
sg2.Cols[1][20]:=cap_ioe;
sg2.Cols[2][20]:=cap_date;
sg2.Cols[0][21]:=cap_main_beginnerbtn;
sg2.Cols[0][22]:=cap_main_intermediatebtn;
sg2.Cols[0][23]:=cap_main_Expertbtn;
sg2.Cols[0][24]:=cap_total;}
end;

procedure TLocal_High_Scores.page3Show(Sender: TObject);
var i:longword;
    sumtime:single;
    sumbvs:single;
    sumios:single;
    sumrqp:single;
    sumioe:single;
//    sumobv:single;
begin
sg3.ColCount:=3;
sg3.RowCount:=25;
sg3.ColWidths[0]:=170;
sg3.ColWidths[1]:=84;
sg3.ColWidths[2]:=160;
//time
sg3.Cols[0][0]:='';
sg3.Cols[1][0]:=cap_lTime;
sg3.Cols[2][0]:=cap_date;
sg3.Cols[0][1]:=cap_main_beginnerbtn;
sg3.Cols[0][2]:=cap_main_intermediatebtn;
sg3.Cols[0][3]:=cap_main_Expertbtn;
sg3.Cols[0][4]:=cap_total;
sumtime:=0;
i:=get_best_nftime(0);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][1]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg3.Cols[2][1]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][1]:=fl2str(999,000);
    sumtime:=sumtime+999.000;
    end;
i:=get_best_nftime(1);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][2]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg3.Cols[2][2]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][2]:=fl2str(999,000);
    sumtime:=sumtime+999.000;
    end;
i:=get_best_nftime(2);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][3]:=t2str(hist[i].gameTimeS,hist[i].gameTimeH);
    sumtime:=sumtime+hist[i].gameTimeS+hist[i].gameTimeH/100;
    sg3.Cols[2][3]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][3]:=fl2str(999,000);
    sumtime:=sumtime+999.0009;
    end;
if(opt.doRecorderStyletimer) then sumtime:=sumtime+3;
if sumtime>999.000 then sumtime:=999.000;
sg3.cols[1][4]:=exttostr(sumtime);

//-----------------3bv/s----------------------
sg3.Cols[0][5]:='';
sg3.Cols[1][5]:=cap_l3bvs;
sg3.Cols[2][5]:=cap_date;
sg3.Cols[0][6]:=cap_main_beginnerbtn;
sg3.Cols[0][7]:=cap_main_intermediatebtn;
sg3.Cols[0][8]:=cap_main_Expertbtn;
sg3.Cols[0][9]:=cap_total;

sumbvs:=0;
i:=get_best_nfbvs(0);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][6]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg3.Cols[2][6]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][6]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

i:=get_best_nfbvs(1);
if hist[i].dateDay>0 then
    begin       
    sg3.Cols[1][7]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg3.Cols[2][7]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][7]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

i:=get_best_nfbvs(2);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][8]:=exttostr(hist[i].bvs);
    sumbvs:=sumbvs+hist[i].bvs;
    sg3.Cols[2][8]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][8]:=fl2str(0,0);
    //sumbvs:=sumtime+0;
    end;

sg3.cols[1][9]:=exttostr(sumbvs);

//rqp
sg3.Cols[0][10]:='';
sg3.Cols[1][10]:=cap_rqp;
sg3.Cols[2][10]:=cap_date;
sg3.Cols[0][11]:=cap_main_beginnerbtn;
sg3.Cols[0][12]:=cap_main_intermediatebtn;
sg3.Cols[0][13]:=cap_main_Expertbtn;
sg3.Cols[0][14]:=cap_total;
sumrqp:=0;
i:=get_best_nfrqp(0);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][11]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg3.Cols[2][11]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][11]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
i:=get_best_nfrqp(1);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][12]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg3.Cols[2][12]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][12]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
i:=get_best_nfrqp(2);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][13]:=exttostr(hist[i].rqp);
    sumrqp:=sumrqp+hist[i].rqp;
    sg3.Cols[2][13]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][13]:=fl2str(999,000);
    sumrqp:=sumrqp+999.000;
    end;
if sumrqp>999.000 then sumrqp:=999.000;
sg3.cols[1][14]:=exttostr(sumrqp);

//-------------IOS--------------
sg3.Cols[0][15]:='';
sg3.Cols[1][15]:=cap_ios;
sg3.Cols[2][15]:=cap_date;
sg3.Cols[0][16]:=cap_main_beginnerbtn;
sg3.Cols[0][17]:=cap_main_intermediatebtn;
sg3.Cols[0][18]:=cap_main_Expertbtn;
sg3.Cols[0][19]:=cap_total;
sumios:=0;
i:=get_best_nfios(0);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][16]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg3.Cols[2][16]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][16]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
i:=get_best_nfios(1);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][17]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg3.Cols[2][17]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][17]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
i:=get_best_nfios(2);
if hist[i].dateDay>0 then
    begin
    sg3.Cols[1][18]:=exttostr(hist[i].ios);
    sumios:=sumios+hist[i].ios;
    sg3.Cols[2][18]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][18]:=fl2str(0,0);
    //sumios:=sumios+0;
    end;
sg3.cols[1][19]:=exttostr(sumios);

//IOE
sg3.Cols[0][20]:='';
sg3.Cols[1][20]:=cap_ioeff;
sg3.Cols[2][20]:=cap_date;
sg3.Cols[0][21]:=cap_main_beginnerbtn;
sg3.Cols[0][22]:=cap_main_intermediatebtn;
sg3.Cols[0][23]:=cap_main_Expertbtn;
sg3.Cols[0][24]:=cap_total;

sumioe:=0;
i:=get_best_nfioe(0);
if hist[i].dateDay>0 then
    begin
    {sg3.Cols[1][21]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));
    sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg3.Cols[1][21]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);				
    sg3.Cols[2][21]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][21]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
i:=get_best_nfioe(1);
if hist[i].dateDay>0 then
    begin
    {sg3.Cols[1][22]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));
    sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg3.Cols[1][22]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);				
    sg3.Cols[2][22]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][22]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
i:=get_best_nfioe(2);
if hist[i].dateDay>0 then
    begin
    {sg3.Cols[1][23]:=exttostr((hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt));
    sumioe:=sumioe+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);}
	sg3.Cols[1][23]:=FloatToStrF(hist_ioe(i), ffFixed, 4, 3);
	sumioe:=sumioe+hist_ioe(i);				
    sg3.Cols[2][23]:=t2hour(hist[i].dateHour,hist[i].dateMinute,
        hist[i].dateSecond)+' '+t2date(hist[i].dateDay,hist[i].dateMonth,
            hist[i].dateYear);
    end
    else
    begin
    sg3.Cols[1][23]:=fl2str(0,0);
    //sumioe:=sumioe+0;
    end;
sg3.cols[1][24]:=exttostr(sumioe);

//OBV
{sg3.Cols[0][20]:='';
sg3.Cols[1][20]:=cap_ioe;
sg3.Cols[2][20]:=cap_date;
sg3.Cols[0][21]:=cap_main_beginnerbtn;
sg3.Cols[0][22]:=cap_main_intermediatebtn;
sg3.Cols[0][23]:=cap_main_Expertbtn;
sg3.Cols[0][24]:=cap_total;}
end;

procedure TLocal_High_Scores.page4Show(Sender: TObject);
var sumtime:single;
    sumbvs:single;
    sumios:single;
    sumrqp:single;
    sumioe:single;
    temp:single;
//    sumobv:single;
begin
sg4.ColCount:=2;
sg4.RowCount:=25;
sg4.ColWidths[0]:=170;
sg4.ColWidths[1]:=84;
//time
sg4.Cols[0][0]:='';
sg4.Cols[1][0]:=cap_lTime;
sg4.Cols[0][1]:=cap_main_beginnerbtn;
sg4.Cols[0][2]:=cap_main_intermediatebtn;
sg4.Cols[0][3]:=cap_main_Expertbtn;
sg4.Cols[0][4]:=cap_total;
sumtime:=0;

temp:=get_best_25time(0);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg4.Cols[1][1]:=exttostr(temp);
sumtime:=sumtime+temp;

temp:=get_best_25time(1);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg4.Cols[1][2]:=exttostr(temp);
sumtime:=sumtime+temp;

temp:=get_best_25time(2);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg4.Cols[1][3]:=exttostr(temp);
sumtime:=sumtime+temp;

//if(opt.doRecorderStyletimer) then sumtime:=sumtime+3;
if sumtime>999.000 then sumtime:=999.000;
sg4.cols[1][4]:=exttostr(sumtime);

//-----------------3bv/s----------------------
sg4.Cols[0][5]:='';
sg4.Cols[1][5]:=cap_l3bvs;
sg4.Cols[0][6]:=cap_main_beginnerbtn;
sg4.Cols[0][7]:=cap_main_intermediatebtn;
sg4.Cols[0][8]:=cap_main_Expertbtn;
sg4.Cols[0][9]:=cap_total;
sumbvs:=0;
temp:=get_best_25bvs(0);
sg4.Cols[1][6]:=exttostr(temp);
sumbvs:=sumbvs+temp;
temp:=get_best_25bvs(1);
sg4.Cols[1][7]:=exttostr(temp);
sumbvs:=sumbvs+temp;
temp:=get_best_25bvs(2);
sg4.Cols[1][8]:=exttostr(temp);
sumbvs:=sumbvs+temp;
sg4.cols[1][9]:=exttostr(sumbvs);

//rqp
sg4.Cols[0][10]:='';
sg4.Cols[1][10]:=cap_rqp;
sg4.Cols[0][11]:=cap_main_beginnerbtn;
sg4.Cols[0][12]:=cap_main_intermediatebtn;
sg4.Cols[0][13]:=cap_main_Expertbtn;
sg4.Cols[0][14]:=cap_total;
sumrqp:=0;
temp:=get_best_25rqp(0);
sg4.Cols[1][11]:=exttostr(temp);
sumrqp:=sumrqp+temp;
temp:=get_best_25rqp(1);
sg4.Cols[1][12]:=exttostr(temp);
sumrqp:=sumrqp+temp;
temp:=get_best_25rqp(2);
sg4.Cols[1][13]:=exttostr(temp);
sumrqp:=sumrqp+temp;
sg4.cols[1][14]:=exttostr(sumrqp);

if sumrqp>999.000 then sumrqp:=999.000;
sg4.cols[1][14]:=exttostr(sumrqp);

//-------------IOS--------------
sg4.Cols[0][15]:='';
sg4.Cols[1][15]:=cap_ios;
sg4.Cols[0][16]:=cap_main_beginnerbtn;
sg4.Cols[0][17]:=cap_main_intermediatebtn;
sg4.Cols[0][18]:=cap_main_Expertbtn;
sg4.Cols[0][19]:=cap_total;
sumios:=0;
temp:=get_best_25ios(0);
sg4.Cols[1][16]:=exttostr(temp);
sumios:=sumios+temp;
temp:=get_best_25ios(1);
sg4.Cols[1][17]:=exttostr(temp);
sumios:=sumios+temp;
temp:=get_best_25ios(2);
sg4.Cols[1][18]:=exttostr(temp);
sumios:=sumios+temp;
sg4.cols[1][19]:=exttostr(sumios);
//IOE
sg4.Cols[0][20]:='';
sg4.Cols[1][20]:=cap_ioeff;
sg4.Cols[0][21]:=cap_main_beginnerbtn;
sg4.Cols[0][22]:=cap_main_intermediatebtn;
sg4.Cols[0][23]:=cap_main_Expertbtn;
sg4.Cols[0][24]:=cap_total;

sumioe:=0;
temp:=get_best_25ioe(0);
sg4.Cols[1][21]:=exttostr(temp);
sumioe:=sumioe+temp;
temp:=get_best_25ioe(1);
sg4.Cols[1][22]:=exttostr(temp);
sumioe:=sumioe+temp;
temp:=get_best_25ioe(2);
sg4.Cols[1][23]:=exttostr(temp);
sumioe:=sumioe+temp;
sg4.cols[1][24]:=exttostr(sumioe);

//OBV
{sg4.Cols[0][20]:='';
sg4.Cols[1][20]:=cap_ioe;
sg4.Cols[0][21]:=cap_main_beginnerbtn;
sg4.Cols[0][22]:=cap_main_intermediatebtn;
sg4.Cols[0][23]:=cap_main_Expertbtn;
sg4.Cols[0][24]:=cap_total;}

end;

procedure TLocal_High_Scores.page5Show(Sender: TObject);
var sumtime:single;
    sumbvs:single;
    sumios:single;
    sumrqp:single;
    sumioe:single;
    temp:single;
//    sumobv:single;
begin
sg5.ColCount:=2;
sg5.RowCount:=25;
sg5.ColWidths[0]:=170;
sg5.ColWidths[1]:=84;
//time
sg5.Cols[0][0]:='';
sg5.Cols[1][0]:=cap_lTime;
sg5.Cols[0][1]:=cap_main_beginnerbtn;
sg5.Cols[0][2]:=cap_main_intermediatebtn;
sg5.Cols[0][3]:=cap_main_Expertbtn;
sg5.Cols[0][4]:=cap_total;
sumtime:=0;

temp:=get_best_25ftime(0);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg5.Cols[1][1]:=exttostr(temp);
sumtime:=sumtime+temp;

temp:=get_best_25ftime(1);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg5.Cols[1][2]:=exttostr(temp);
sumtime:=sumtime+temp;

temp:=get_best_25ftime(2);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg5.Cols[1][3]:=exttostr(temp);
sumtime:=sumtime+temp;

//if(opt.doRecorderStyletimer) then sumtime:=sumtime+3;
if sumtime>999.000 then sumtime:=999.000;
sg5.cols[1][4]:=exttostr(sumtime);

//-----------------3bv/s----------------------
sg5.Cols[0][5]:='';
sg5.Cols[1][5]:=cap_l3bvs;
sg5.Cols[0][6]:=cap_main_beginnerbtn;
sg5.Cols[0][7]:=cap_main_intermediatebtn;
sg5.Cols[0][8]:=cap_main_Expertbtn;
sg5.Cols[0][9]:=cap_total;
sumbvs:=0;
temp:=get_best_25fbvs(0);
sg5.Cols[1][6]:=exttostr(temp);
sumbvs:=sumbvs+temp;
temp:=get_best_25fbvs(1);
sg5.Cols[1][7]:=exttostr(temp);
sumbvs:=sumbvs+temp;
temp:=get_best_25fbvs(2);
sg5.Cols[1][8]:=exttostr(temp);
sumbvs:=sumbvs+temp;
sg5.cols[1][9]:=exttostr(sumbvs);

//rqp
sg5.Cols[0][10]:='';
sg5.Cols[1][10]:=cap_rqp;
sg5.Cols[0][11]:=cap_main_beginnerbtn;
sg5.Cols[0][12]:=cap_main_intermediatebtn;
sg5.Cols[0][13]:=cap_main_Expertbtn;
sg5.Cols[0][14]:=cap_total;
sumrqp:=0;
temp:=get_best_25frqp(0);
sg5.Cols[1][11]:=exttostr(temp);
sumrqp:=sumrqp+temp;
temp:=get_best_25frqp(1);
sg5.Cols[1][12]:=exttostr(temp);
sumrqp:=sumrqp+temp;
temp:=get_best_25frqp(2);
sg5.Cols[1][13]:=exttostr(temp);
sumrqp:=sumrqp+temp;
sg5.cols[1][14]:=exttostr(sumrqp);

if sumrqp>999.000 then sumrqp:=999.000;
sg5.cols[1][14]:=exttostr(sumrqp);

//-------------IOS--------------
sg5.Cols[0][15]:='';
sg5.Cols[1][15]:=cap_ios;
sg5.Cols[0][16]:=cap_main_beginnerbtn;
sg5.Cols[0][17]:=cap_main_intermediatebtn;
sg5.Cols[0][18]:=cap_main_Expertbtn;
sg5.Cols[0][19]:=cap_total;
sumios:=0;
temp:=get_best_25fios(0);
sg5.Cols[1][16]:=exttostr(temp);
sumios:=sumios+temp;
temp:=get_best_25fios(1);
sg5.Cols[1][17]:=exttostr(temp);
sumios:=sumios+temp;
temp:=get_best_25fios(2);
sg5.Cols[1][18]:=exttostr(temp);
sumios:=sumios+temp;
sg5.cols[1][19]:=exttostr(sumios);
//IOE
sg5.Cols[0][20]:='';
sg5.Cols[1][20]:=cap_ioeff;
sg5.Cols[0][21]:=cap_main_beginnerbtn;
sg5.Cols[0][22]:=cap_main_intermediatebtn;
sg5.Cols[0][23]:=cap_main_Expertbtn;
sg5.Cols[0][24]:=cap_total;

sumioe:=0;
temp:=get_best_25fioe(0);
sg5.Cols[1][21]:=exttostr(temp);
sumioe:=sumioe+temp;
temp:=get_best_25fioe(1);
sg5.Cols[1][22]:=exttostr(temp);
sumioe:=sumioe+temp;
temp:=get_best_25fioe(2);
sg5.Cols[1][23]:=exttostr(temp);
sumioe:=sumioe+temp;
sg5.cols[1][24]:=exttostr(sumioe);

//OBV
{sg5.Cols[0][20]:='';
sg5.Cols[1][20]:=cap_ioe;
sg5.Cols[0][21]:=cap_main_beginnerbtn;
sg5.Cols[0][22]:=cap_main_intermediatebtn;
sg5.Cols[0][23]:=cap_main_Expertbtn;
sg5.Cols[0][24]:=cap_total;}
end;

procedure TLocal_High_Scores.page6Show(Sender: TObject);
var sumtime:single;
    sumbvs:single;
    sumios:single;
    sumrqp:single;
    sumioe:single;
    temp:single;
//    sumobv:single;
begin
sg6.ColCount:=2;
sg6.RowCount:=25;
sg6.ColWidths[0]:=170;
sg6.ColWidths[1]:=84;
//time
sg6.Cols[0][0]:='';
sg6.Cols[1][0]:=cap_lTime;
sg6.Cols[0][1]:=cap_main_beginnerbtn;
sg6.Cols[0][2]:=cap_main_intermediatebtn;
sg6.Cols[0][3]:=cap_main_Expertbtn;
sg6.Cols[0][4]:=cap_total;
sumtime:=0;

temp:=get_best_25nftime(0);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg6.Cols[1][1]:=exttostr(temp);
sumtime:=sumtime+temp;

temp:=get_best_25nftime(1);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg6.Cols[1][2]:=exttostr(temp);
sumtime:=sumtime+temp;

temp:=get_best_25nftime(2);
if(opt.doRecorderStyleTimer) then temp:=temp+1;
sg6.Cols[1][3]:=exttostr(temp);
sumtime:=sumtime+temp;

//if(opt.doRecorderStyletimer) then sumtime:=sumtime+3;
if sumtime>999.000 then sumtime:=999.000;
sg6.cols[1][4]:=exttostr(sumtime);

//-----------------3bv/s----------------------
sg6.Cols[0][5]:='';
sg6.Cols[1][5]:=cap_l3bvs;
sg6.Cols[0][6]:=cap_main_beginnerbtn;
sg6.Cols[0][7]:=cap_main_intermediatebtn;
sg6.Cols[0][8]:=cap_main_Expertbtn;
sg6.Cols[0][9]:=cap_total;
sumbvs:=0;
temp:=get_best_25nfbvs(0);
sg6.Cols[1][6]:=exttostr(temp);
sumbvs:=sumbvs+temp;
temp:=get_best_25nfbvs(1);
sg6.Cols[1][7]:=exttostr(temp);
sumbvs:=sumbvs+temp;
temp:=get_best_25nfbvs(2);
sg6.Cols[1][8]:=exttostr(temp);
sumbvs:=sumbvs+temp;
sg6.cols[1][9]:=exttostr(sumbvs);

//rqp
sg6.Cols[0][10]:='';
sg6.Cols[1][10]:=cap_rqp;
sg6.Cols[0][11]:=cap_main_beginnerbtn;
sg6.Cols[0][12]:=cap_main_intermediatebtn;
sg6.Cols[0][13]:=cap_main_Expertbtn;
sg6.Cols[0][14]:=cap_total;
sumrqp:=0;
temp:=get_best_25nfrqp(0);
sg6.Cols[1][11]:=exttostr(temp);
sumrqp:=sumrqp+temp;
temp:=get_best_25nfrqp(1);
sg6.Cols[1][12]:=exttostr(temp);
sumrqp:=sumrqp+temp;
temp:=get_best_25nfrqp(2);
sg6.Cols[1][13]:=exttostr(temp);
sumrqp:=sumrqp+temp;
sg6.cols[1][14]:=exttostr(sumrqp);

if sumrqp>999.000 then sumrqp:=999.000;
sg6.cols[1][14]:=exttostr(sumrqp);

//-------------IOS--------------
sg6.Cols[0][15]:='';
sg6.Cols[1][15]:=cap_ios;
sg6.Cols[0][16]:=cap_main_beginnerbtn;
sg6.Cols[0][17]:=cap_main_intermediatebtn;
sg6.Cols[0][18]:=cap_main_Expertbtn;
sg6.Cols[0][19]:=cap_total;
sumios:=0;
temp:=get_best_25nfios(0);
sg6.Cols[1][16]:=exttostr(temp);
sumios:=sumios+temp;
temp:=get_best_25nfios(1);
sg6.Cols[1][17]:=exttostr(temp);
sumios:=sumios+temp;
temp:=get_best_25nfios(2);
sg6.Cols[1][18]:=exttostr(temp);
sumios:=sumios+temp;
sg6.cols[1][19]:=exttostr(sumios);
//IOE
sg6.Cols[0][20]:='';
sg6.Cols[1][20]:=cap_ioeff;
sg6.Cols[0][21]:=cap_main_beginnerbtn;
sg6.Cols[0][22]:=cap_main_intermediatebtn;
sg6.Cols[0][23]:=cap_main_Expertbtn;
sg6.Cols[0][24]:=cap_total;

sumioe:=0;
temp:=get_best_25nfioe(0);
sg6.Cols[1][21]:=exttostr(temp);
sumioe:=sumioe+temp;
temp:=get_best_25nfioe(1);
sg6.Cols[1][22]:=exttostr(temp);
sumioe:=sumioe+temp;
temp:=get_best_25nfioe(2);
sg6.Cols[1][23]:=exttostr(temp);
sumioe:=sumioe+temp;
sg6.cols[1][24]:=exttostr(sumioe);

//OBV
{sg6.Cols[0][20]:='';
sg6.Cols[1][20]:=cap_ioe;
sg6.Cols[0][21]:=cap_main_beginnerbtn;
sg6.Cols[0][22]:=cap_main_intermediatebtn;
sg6.Cols[0][23]:=cap_main_Expertbtn;
sg6.Cols[0][24]:=cap_total;}
end;

procedure TLocal_High_Scores.savehtmlbtnClick(Sender: TObject);
var f:textfile;
    i,k:integer;
begin
case pager.ActivePageIndex of
0: sd.FileName:='scores_best.html';
1: sd.FileName:='scores_best_flagging.html';
2: sd.FileName:='scores_best_no-flagging.html';
3: sd.FileName:='scores_top25.html';
4: sd.FileName:='scores_top25_flagging.html';
5: sd.FileName:='scores_top25_no-flagging.html';
end;
if (sd.Execute)and(sd.filename<>'') then
begin
assignfile(f,sd.filename);
rewrite(f);
writeln(f,'<html>');
writeln(f,'<head>');
writeln(f,'<title>'+extractfilename(sd.filename)+'</title>');
writeln(f,'</head>');
writeln(f,'<body bgcolor="silver" align="center">');
writeln(f,'<table align="center" border="1" cellpadding="3" cellspacing="0">');
case pager.ActivePageIndex of
0:
for i:=0 to sg1.RowCount-1 do
begin
write(f,'<tr>');
for k:=0 to sg1.ColCount-1 do
if sg1.Cells[k,i]<>'' then write(f,'<td>'+sg1.Cells[k,i]+'</td>')
    else write(f,'<td>&nbsp;</td>');
writeln(f,'</tr>');
end;
1:
for i:=0 to sg2.RowCount-1 do
begin
write(f,'<tr>');
for k:=0 to sg2.ColCount-1 do
if sg2.Cells[k,i]<>'' then write(f,'<td>'+sg2.Cells[k,i]+'</td>')
    else write(f,'<td>&nbsp;</td>');
writeln(f,'</tr>');
end;
2:
for i:=0 to sg3.RowCount-1 do
begin
write(f,'<tr>');
for k:=0 to sg3.ColCount-1 do
if sg3.Cells[k,i]<>'' then write(f,'<td>'+sg3.Cells[k,i]+'</td>')
    else write(f,'<td>&nbsp;</td>');
writeln(f,'</tr>');
end;
3:
for i:=0 to sg4.RowCount-1 do
begin
write(f,'<tr>');
for k:=0 to sg4.ColCount-1 do
if sg4.Cells[k,i]<>'' then write(f,'<td>'+sg4.Cells[k,i]+'</td>')
    else write(f,'<td>&nbsp;</td>');
writeln(f,'</tr>');
end;
4:
for i:=0 to sg5.RowCount-1 do
begin
write(f,'<tr>');
for k:=0 to sg5.ColCount-1 do
if sg5.Cells[k,i]<>'' then write(f,'<td>'+sg5.Cells[k,i]+'</td>')
    else write(f,'<td>&nbsp;</td>');
writeln(f,'</tr>');
end;
5:
for i:=0 to sg6.RowCount-1 do
begin
write(f,'<tr>');
for k:=0 to sg6.ColCount-1 do
if sg6.Cells[k,i]<>'' then write(f,'<td>'+sg6.Cells[k,i]+'</td>')
    else write(f,'<td>&nbsp;</td>');
writeln(f,'</tr>');
end;
end;
writeln(f,'</table>');
writeln(f,'</body>');
writeln(f,'</html>');
closefile(f);
end;

end;

end.
