unit FData;interface uses Windows;
CONST
	ver='0.48.5 external';
	verN=48;

//modes
modeBeg=0;modeInt=1;modeExp=2;modeCus=3;
//other
mdX=29;
mdY=29;
Z=16;// cell-width
cHistMax=262144;
sqrt2=1.41;//42135623731;
hsize=49;
{}
TYPE
TCellValue=byte;
sX=0..mdX;sY=0..mdY;tMC=1..999;tfMC=-99..999;
tSeconds=0..1000;tHundreds=0..99;
tTime=record S:tSeconds;H:tHundreds;end;
tOptionsSet=record
	// counter refresh
	ctrr:byte;
	// hi-score autosave
	hspath:string;
	hsmark:string;
	// tray icon
	dotrayicon:boolean;
	
  // IRC
  irccolor1:byte;
  irccolor2:byte;
  doirctype:byte;
  doautocopyblast:boolean;
  doautocopyfinish:boolean;
  dousesmiles:boolean;
  doCntExclude:boolean;
  ircCntExclude:string;
  dosilentmode:boolean;

  //records
  recbegftime:string;
  recintftime:string;
  recexpftime:string;
  recbegnftime:string;
  recintnftime:string;
  recexpnftime:string;
  
  recbegfbvs:string;
  recintfbvs:string;
  recexpfbvs:string;
  recbegnfbvs:string;
  recintnfbvs:string;
  recexpnfbvs:string;

  recbegfrqp:string;
  recintfrqp:string;
  recexpfrqp:string;
  recbegnfrqp:string;
  recintnfrqp:string;
  recexpnfrqp:string;

  recbegfios:string;
  recintfios:string;
  recexpfios:string;
  recbegnfios:string;
  recintnfios:string;
  recexpnfios:string;

  // user setup
  showIDtext:boolean;
  userIDText:String;
  doHistLog:boolean;
  doDotSeparator:boolean;
  doexecutecounters:boolean;
  replayname:String;
  BegName,IntName,ExpName,CusName:String;
  replayFilename:String;//defaule_Name
  CountryNumber:byte;
  cusTimeZone:smallint;
  dateMonthFirst:boolean;
  curFileName:string;
  
  // style setup
  doStartUpMode:byte;
  skinNumber:byte;
  skinTimerNumber:byte;
  doMarks:boolean;
  doShowTenths:boolean;
  doTimer:boolean;
  doShowCounters:boolean;
  doBoardClearance:boolean;
  doClearOnMiddleBtn:boolean;
  doClearOnLeftBtn:boolean;
  doFillFlags:boolean;
  doShowEquals:boolean;
  doShowCountersTitle:boolean;
  doShowCntGreenBorder:boolean;
  doCntOnFinish:boolean;
  doCntOnEnd:boolean;
  seClearanceCompl:byte;
  doforcednewgame:boolean;
  doforcednewgameBEEP:boolean;
  doFNGB:word;
  doFNGI:word;
  doFNGE:word;

  // cheat setup
  doDisableTimer:boolean;
  doRecorderStyleTimer:boolean;
  doAutoFlag:boolean;
  doDisableGroupOpen:boolean;
  doDisableRightClicks:boolean;
  doInfiniteLives:boolean;
  doShowProbabilities:boolean;
  doShowMines:boolean;
  doShow3BVafterGameStart:boolean;
  doMustHave7:boolean;
  doMustHave8:boolean;
  doApprox3BV:boolean;
  doApprox3BV2:boolean;
  se3BVValue:word;
  se3BVValue2:word;//bbbv>=x
  seAttemptsValue:byte;
  // system setup
  doHighPriority:boolean;
  doEnableBossKey:boolean;
  doClipCursor:boolean;
  doBlit:boolean;
//  doAlwaysOnTop:boolean;
  doProhibitMultInstances:boolean;
  doSeekPlugins:boolean;
//  doNotSaveLastReplays:boolean;
  // language setup
  langFileName:String;
  // automation setup
  doCond1:boolean;
{  Rule1:String;
  fName1:String;
  doCond2:boolean;
  Rule2:String;
  fName2:String;
  doCond3:boolean;
  Rule3:String;
  fName3:String;}
  // multiplayer setup
  doBlockChat:boolean;
  doProcListGrab:boolean;
  doSysInfGrab:boolean;
  /// --------
  AppPath:string;
  AppExeName:string;
  hsBegTime:String;
  hsBeg3bvs:String;
  hsBegName:String;
  hsBegJump:String;
  hsIntTime:String;
  hsInt3bvs:String;
  hsIntName:String;
  hsIntJump:String;
  hsExpTime:String;
  hsExp3bvs:String;
  hsExpName:String;
  hsExpJump:String;
  posMainX:integer;
  posMainY:integer;
  posCountersX:integer;
  posCountersY:integer;
  posProgressBarX:integer;
  posProgressBarY:integer;
  posHistX:integer;
  posHistY:integer;
  posHistW:integer;
  posHistH:integer;

  //counters
  widthCr1:byte;
  widthCr2:byte;
  heightCr3:byte;
  // mousechart
  ShowMousePath:boolean;
  ShowDownState:boolean;
  ShowLeftCl:boolean;
  ShowRightCl:boolean;
  ShowDoubleCl:boolean;
  dochangeLayout:boolean;
  DarkenBoard:boolean;
  mpShowCells:boolean;
  mPathColor:byte;
  mpLColor:byte;
  mpRColor:byte;
  mpDColor:byte;
  
  doswitchskin:boolean;
  doclearcounters:boolean;
  end;
{}
tReplayPos=0..500000;/// 999,99 + all that mouse moves/clicks
tHistoryPos=0..cHistMax;
tReplayPattern=record
   _timeS:tSeconds;
   _timeH:tHundreds;
   _mPosX:word;
   _mPosY:word;
   l_do_d:boolean;
   r_do_d:boolean;
   D_Do_d:boolean;
   l_do_u:boolean;
   r_do_u:boolean;
   D_Do_u:boolean;
   outside:boolean;
   end;
tHistoryPattern=record
   dateDay:byte;
   dateMonth:byte;
   dateYear:word;
   dateHour:byte;
   dateMinute:byte;
   dateSecond:byte;
   gameTimeS:word;
   gameTimeH:byte;
   bbbv:word;
   bbbvsS:byte;
   bbbvsH:byte;
   mode:byte;
   fstyle:boolean;
   cell1:word;
   cell2:word;
   cell3:word;
   cell4:word;
   cell5:word;
   cell6:word;
   cell7:word;
   cell8:word;
   rcnt,lcnt,dcnt,lecnt,recnt,decnt:word;
   openings:byte;
   bbbv_islands:byte;
   path:longword;
   rqp:single;
   ios:single;
   bvs:single;
   gzini:word;
   hzini:word;
//   flagsused:word;
   end;

VAR
badwordcnt:word=126;
badword:array[0..126]of string=('anus','ash0le','ash0les','asholes','assface',
'assh0le','asshol','asswip','azzhol','bassterds','bastard','basterd','biatch',
'bitch','blow job','blowjob','boffing','butthole','buttwipe','c0ck','c0k',
'clit','cnts','cntz','cockhead','cock-head','cocksucker','cock-sucker',
'cunt','dild0','dildo','dilld0','dominatr','f u c k','fag ',' fag','fag1t',
'faget','fagg1t','faggit','faggot','fagit','fags','fagz','fuck',' fuk',' fuk ',
'g00k','gayboy','gaygirl','h00r','h0ar','h0re','hoar','hoor','hoore',
'jackoff','jerk-off','jizz','knobs','knobz','kunts','kuntz','lesbian',
'lezzian','lipshit','masochist','masokist','massterbait','masstrb','motha fu',
'mother fu','motherfu','mother-fu','mutha fucker','mutha fuk','n1gr',
'nigger','nigur','orafis','orgasim','orgasm','orgasum','peeenus','peenus',
'peinus','pen1s','penas','penis','penus','penuus','poonani','pr1c','pr1ck',
'pr1k','pusse','pussee','pussy','queer','queers','queerz','qweers','qweerz',
'qweir','recktum','rectum','retard','sadist','Sh!t','sh1t','shit','slut',
'son-of-a-bitch','turd','va1jina','vag1na','vagiina','vagina','vaj1na',
'vajina','vullva','vulva','wh00r','wh0re','whore','xrated','xxx');

sDC:HDC;
cursor_image:tbitmap;
rep_ver:byte=0;

XENDER:tobject;
REPLAY:array[tReplayPos]of tReplayPattern;
replayI:longword=0;//treplaypos=0;
replayPOS:{treplaypos}longword=0;
is_replay_mode:boolean=false;
is_preview_mode:boolean=false;

HIST:array[tHistoryPos]of tHistoryPattern;
bound:array[tHistoryPos]of boolean;
//laststatsentrie:string;
//canwrite:boolean=true;

A:array[0..mdX,0..mdY]of TCellValue; //stored matrix
B:array[0..mdX,0..mdY]of TCellValue; //opened matrix
c:array[0..mdX,0..mdY]of TCellValue; //changed matrix
znp:array[0..mdX,0..mdy] of integer;	// zini premium {0.47}
checked:array[0..mdX,0..mdY] of boolean;
zn_closed:integer;	// for zini {0.47}

//begin_global_params
brd:string;
mode:byte=modeCus;
dX:sX=mdX;
dY:sY=mdY;
MC:tMC=1;
//mut_style:byte=0;
rreleased:boolean=false;
le_ineff_rc:boolean=false;
is_new_game:boolean=true;
was_blasted:boolean=false;
opt:tOptionsSet;
lb_down:boolean=false;
rb_down:boolean=false;
mb_down:boolean=false;
GTime:tTime;//game_time
//gtime_thousandths:byte;
boss_key_activated:boolean=false;
// end_global_params
// Check_SUMS
cs_board:{String}longword=0;
cs_all:{String=''}longword=0;
cs_opt:String='';
PROTECTED_DELTA1:byte=1;

upk:boolean;

c0,c1,c2,c3,c4,c5,c6,c7,c8,cU,cQ,cRB,cXB,cB,cDQ,cF,cV,cS:byte;
//
Lcnt:word=0;
Rcnt:word=0;
Dcnt:word=0;

Lecnt:word=0;//efficiency
Recnt:word=0;
Decnt:word=0;

classicRcnt:word=0;
Rmisflags:word=0;
Runflags:word=0;
Rmisunflags:word=0;

//seems like storing 3 bytes of path will be enough
//mpathx:longword=0;mpathy:longword=0;
mpath:extended=0;
last_x,last_y:word;

beg_totalgames:longInt=0;
int_totalgames:longInt=0;
exp_totalgames:longInt=0;
//rank_time:word=0;
//rank_bbbvs:word=0;


Done:word=0;
openings:byte=0;
bbbv_islands:byte=0;
//usedflags:word=0;
done_openings:word=0;

cell0:word=0;
cell1:word=0;
cell2:word=0;
cell3:word=0;
cell4:word=0;
cell5:word=0;
cell6:word=0;
cell7:word=0;
cell8:word=0;
cell0done:word=0;
cell1done:word=0;
cell2done:word=0;
cell3done:word=0;
cell4done:word=0;
cell5done:word=0;
cell6done:word=0;
cell7done:word=0;
cell8done:word=0;
usedflags:word=0;

gzini:word=0;
hzini:word=0;
obv:extended=0.0;

sess_clicks:longword=0;
sess_start:tsystemtime;
//chording:boolean=false;

      
//form creation hook
debug_form_created:boolean=false;
debug_command_form_created:boolean=false;
options_form_created:boolean=false;
counters_form_created:boolean=false;
progressbar_form_created:boolean=false;
custom_board_size_form_created:boolean=false;
lhs_gain_form_created:boolean=false;
local_high_scores_form_created:boolean=false;
about_form_created:boolean=false;
history_form_created:boolean=false;
mult_form_created:boolean=false;
formula_form_created:boolean=false;

//other_data
open_param:String;
uid:String='';
cnid:byte=0;
fname:string='';
bvstr:String='';
debugmode:boolean=false;
//statsmode:boolean=false;
tz:_time_zone_information;
ts:TSystemTime;
GameStartStr:string;
gameendstr:string;

board_loaded:boolean=false;//if false --> will generate on left_up
doLoadcnttempl:boolean=false;
doLoadauttempl:boolean=false;

board_uncovered:boolean=false;

doclearonleft_last:byte;
doclearonleft_t:TSystemTime;


debug_show_math_module_errors:boolean=false;

// end F_DATA_UNIT

thankscount:byte=23;
//TODO: add all
thankslist:array[0..23]of string=(
'Alain Rousseau  (France)',
'Alex Poehner  (USA)',
'Andrew McCauley  (Australia)',
'Aryeh R.D.  (USA)',
'Benny Benjamin  (Australia)',
'Benoit Duffez  (France)',
'Curtis Bright  (Canada)',
'Dan Cerveny  (USA)',
'Daniel Brim  (USA)',
'Elmar Zimmermann  (Germany)',
'Gregoire Duffez  (France)',
'Kathleen Lavallee  (USA)',
'Jake "Badgers" Warner  (USA)',
'Marko Jeznik  (Slovenia)',
'Robert Farnik  (Czech Republic)',
'Rodrigo Camargo  (Brazil)',
'Roman Gammel  (Russia)',
'Samuel Ambler (USA)',
'Sorin Manea  (Romania)',
'Stephen Arnason  (Canada)',
'Stevan Gvozdenovic  (Montenegro)',
'Vladimir Ogurtsov  (Ukraine)',
'Vladimir Pouzanov  (Ukraine)',
'Yaeli Amir  (Israel)');

smilescnt:word=48;
smileslist:array[0..48]of string=(
'*sigh*',';)',':|',';|',':(',';(',':-)',';-)',':-|',';-|',
':-(',';-(','KAB00M','B00M','bah','-.-','gasp',':/)',';D',':D',
':E',':P',':@',':X',':S',':O','=(',':C',':>',':<',
'>:)','<:)','>:(','<:(',':-#',':''(','8-)',':-x','o.o','@_@',
'O_O','@_-','o_~','~_~','_o_','^(O_O)>','<(O_O)^','<--','<==');

memUsed:longint;//memory used
memUsed_min,memUsed_hour:byte;

cns1,cns2:array[0..100]of string;//counters window strings

clagain:boolean=false;

blastedctrs:string='RTIME 3BV 3BV/S ESTTIME EST TIME EST RTIME EST SCORE';
//repDelta:longword=0;
	
qsa:array[tHistoryPos] of integer;	// {0.47} quicksort preparation
qsd:array[tHistoryPos] of integer;

implementation end.
