unit FFormula;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, Buttons, ExtCtrls, ShellAPI;

type
  TFormula = class(TForm)
    applyBtn: TButton;
    edF: TEdit;
    mnu: TMainMenu;
    q: TMenuItem;
    cbasText: TCheckBox;
    cbasForm: TCheckBox;
    Label1: TLabel;
    sbTIMEREAL: TSpeedButton;
    sbTIME: TSpeedButton;
    sbBBBV: TSpeedButton;
    sbBBBV_DONE: TSpeedButton;
    sbPATHres: TSpeedButton;
    sbMBVres: TSpeedButton;
    sbIOSres: TSpeedButton;
    sbRQPres: TSpeedButton;
    sbBBBV_S: TSpeedButton;
    sbEstimated: TSpeedButton;
    Label2: TLabel;
    sbWIDTHbrd: TSpeedButton;
    sbHEIGHTbrd: TSpeedButton;
    sbMINESbrd: TSpeedButton;
    sbCELLbrd: TSpeedButton;
    sbOPENINGbrd: TSpeedButton;
    sbISLAND: TSpeedButton;
    sbDONEOPENINGbrd: TSpeedButton;
    sbDONECELLbrd: TSpeedButton;
    Label3: TLabel;
    sbD: TSpeedButton;
    sbR: TSpeedButton;
    sbL: TSpeedButton;
    sbLE: TSpeedButton;
    sbRE: TSpeedButton;
    sbDE: TSpeedButton;
    sbTOTALeff: TSpeedButton;
    sbTOTALcl: TSpeedButton;
    sbTOTAL_GAMES: TSpeedButton;
    Label5: TLabel;
    sbTIMErnk: TSpeedButton;
    sbTIMEgrnk: TSpeedButton;
    sbBBBVSrnk: TSpeedButton;
    sbBBBVSgrnk: TSpeedButton;
    sbRPIrnk: TSpeedButton;
    sbRPIgrnk: TSpeedButton;
    sbRQPgrnk: TSpeedButton;
    sbRQPrnk: TSpeedButton;
    sbIOSrnk: TSpeedButton;
    sbIOSgrnk: TSpeedButton;
    sbMBVrnk: TSpeedButton;
    sbMBVgrnk: TSpeedButton;
    Label4: TLabel;
    edName: TEdit;
    gbName: TLabel;
    lFormula: TLabel;
    sbDivide: TSpeedButton;
    sbMult: TSpeedButton;
    sbMinus: TSpeedButton;
    sbPlus: TSpeedButton;
    sbBrackets: TSpeedButton;
    sbopBrackets: TSpeedButton;
    gbOp: TLabel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    cancelBtn: TButton;
    undoBtn: TSpeedButton;
    clearBtn: TSpeedButton;
    helpBtn: TButton;
    panelBtn: TButton;
    sbUSEDFLAGSbrd: TSpeedButton;
    sbMODEbrd: TSpeedButton;
    procedure qClick(Sender: TObject);
    procedure applyBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sbopBracketsClick(Sender: TObject);
    procedure sbBracketsClick(Sender: TObject);
    procedure sbPlusClick(Sender: TObject);
    procedure sbMinusClick(Sender: TObject);
    procedure sbMultClick(Sender: TObject);
    procedure sbDivideClick(Sender: TObject);
    procedure sbTIMEClick(Sender: TObject);
    procedure sbTIMEREALClick(Sender: TObject);
    procedure sbBBBVClick(Sender: TObject);
    procedure sbBBBV_DONEClick(Sender: TObject);
    procedure sbBBBV_SClick(Sender: TObject);
    procedure sbTIMErnkClick(Sender: TObject);
    procedure sbBBBVSrnkClick(Sender: TObject);
    procedure sbTOTAL_GAMESClick(Sender: TObject);
    procedure sbIOSresClick(Sender: TObject);
    procedure sbRQPresClick(Sender: TObject);
    procedure sbDClick(Sender: TObject);
    procedure sbLClick(Sender: TObject);
    procedure sbRClick(Sender: TObject);
    procedure sbTOTALclClick(Sender: TObject);
    procedure sbLEClick(Sender: TObject);
    procedure sbREClick(Sender: TObject);
    procedure sbDEClick(Sender: TObject);
    procedure sbTOTALeffClick(Sender: TObject);
    procedure sbOPENINGbrdClick(Sender: TObject);
    procedure sbPATHresClick(Sender: TObject);
    procedure sbRPIrnkClick(Sender: TObject);
    procedure clearBtnClick(Sender: TObject);
    procedure cbasFormClick(Sender: TObject);
    procedure cbasTextClick(Sender: TObject);
    procedure undoBtnClick(Sender: TObject);
    procedure helpBtnClick(Sender: TObject);
    procedure myVarBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure sbEstimatedClick(Sender: TObject);
    procedure sbTIMEgrnkClick(Sender: TObject);
    procedure sbBBBVSgrnkClick(Sender: TObject);
    procedure sbRPIgrnkClick(Sender: TObject);
    procedure sbDONEOPENINGbrdClick(Sender: TObject);
    procedure sbCELLbrdClick(Sender: TObject);
    procedure sbMINESbrdClick(Sender: TObject);
    procedure sbWIDTHbrdClick(Sender: TObject);
    procedure sbHEIGHTbrdClick(Sender: TObject);
    procedure sbISLANDClick(Sender: TObject);
    procedure sbDONECELLbrdClick(Sender: TObject);
    procedure sbRQPrnkClick(Sender: TObject);
    procedure sbIOSrnkClick(Sender: TObject);
    procedure sbMBVgrnkClick(Sender: TObject);
    procedure sbRQPgrnkClick(Sender: TObject);
    procedure sbIOSgrnkClick(Sender: TObject);
    procedure sbMBVrnkClick(Sender: TObject);
    procedure sbMBVresClick(Sender: TObject);
    procedure cancelBtnClick(Sender: TObject);
    procedure panelBtnClick(Sender: TObject);
    procedure sbUSEDFLAGSbrdClick(Sender: TObject);
    procedure sbMODEbrdClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Formula: TFormula;
  S:String;
  Last:string;



implementation

uses FOptions, Fcap, FMain, FData;

{$R *.DFM}

procedure TFormula.qClick(Sender: TObject);
begin
Options_window.Enabled:=true;
Options_window.show;
hide;
end;

procedure TFormula.applyBtnClick(Sender: TObject);
var s:string;
begin
if edName.text='myName' then
if messagedlg(cap_edname_text_wrong,mtConfirmation,[mbYes,mbNo],0)=mrYes then
   begin activecontrol:=edName;exit;end;

if (edF.text='')and(not cbasText.checked) then
if messagedlg(cap_edF_text_wrong,mtConfirmation,[mbYes,mbNo],0)=mrYes then exit;

if (pos('myVar',edName.text)>1)or
   (pos('myBase',edName.text)>1)or
   (pos('myValue',edName.text)>1)or
   (pos('myGrade',edName.text)>1)or
   (pos('myVar1',edName.text)>1)or
   (pos('myVarN',edName.text)>1)or
   (pos('myValue1',edName.text)>1)or
   (pos('myValueN',edName.text)>1)or
   (pos('myFunction',edName.text)>1)
   then
if messagedlg(cap_edF_myVars,mtConfirmation,[mbYes,mbNo],0)=mrYes then
   begin {myVarBtn.click;}exit;end;


if edF.text<>'' then begin
   if cbasText.Checked then s:='#'
   else if cbasForm.Checked then s:='@'
   else s:='';
   s:=s+edName.text+'| '+edF.text;
   Options_window.mtemplate.Lines.Add(s);
   end;
edF.Text:='';
options_window.PageSeL.SelectedItem:=8;
options_window.PageSeL.OnClick(options_window.pagesel);
Options_window.ActiveControl:=Options_window.mtemplate;
Options_window.Enabled:=true;
Options_window.show;
hide;

end;

procedure TFormula.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Options_window.Enabled:=true;
Options_window.show;
hide;
end;

procedure TFormula.sbopBracketsClick(Sender: TObject);
var s:string;
begin
Last:=edF.Text;
s:=edF.text;
s:=' ( '+s+' )';
edF.text:=s;
end;

procedure TFormula.sbBracketsClick(Sender: TObject);
begin
Last:=edF.Text;
edF.text:=edF.text+' ( )';
end;

procedure TFormula.sbPlusClick(Sender: TObject);
begin
Last:=edF.Text;
edF.text:=edF.text+' +';
end;

procedure TFormula.sbMinusClick(Sender: TObject);
begin
Last:=edF.Text;
edF.text:=edF.text+' -';
end;

procedure TFormula.sbMultClick(Sender: TObject);
begin
Last:=edF.Text;
edF.text:=edF.text+' *';
end;

procedure TFormula.sbDivideClick(Sender: TObject);
begin
Last:=edF.Text;
edF.text:=edF.text+' /';
end;

procedure TFormula.sbTIMEClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' TIME';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' TIME',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbTIMEREALClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' TIMEREAL';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' TIMEREAL',s,edF.selStart+1);
edF.text:=s;
end;            
end;

procedure TFormula.sbBBBVClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' BBBV';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' BBBV',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbBBBV_DONEClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' BBBVDONE';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' BBBVDONE',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbBBBV_SClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' BBBV/TIMEREAL';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' BBBV/TIMEREAL',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbTIMErnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' RANKTIME';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' RANKTIME',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbBBBVSrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' RANKBBBVS';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' RANKBBBVS',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbTOTAL_GAMESClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' TOTALGAMES';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' TOTALGAMES',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbIOSresClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' IOS';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' IOS',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbRQPresClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' RQP';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' RQP',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbDClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' DCLK';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' DCLK',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbLClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' LCLK';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' LCLK',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbRClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' RCLK';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' RCLK',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbTOTALclClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' TOTALCLK';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' TOTALCLK',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbLEClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' LEFF';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' LEFF',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbREClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' REFF';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' REFF',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbDEClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' DEFF';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' DEFF',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbTOTALeffClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' TOTALEFF';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' TOTALEFF',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbOPENINGbrdClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' OPENINGS';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' OPENINGS',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbPATHresClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' PATH';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' PATH',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbRPIrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' RPI';
   exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' RPI',
   s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.clearBtnClick(Sender: TObject);
begin
Last:=edF.Text;
edName.text:='myName';
edF.Text:='';
cbastext.checked:=false;
cbasform.checked:=false;
activecontrol:=edF;
end;

procedure TFormula.cbasFormClick(Sender: TObject);
begin
if cbasForm.Checked then cbasText.checked:=false;
end;

procedure TFormula.cbasTextClick(Sender: TObject);
begin
if cbasText.Checked then cbasForm.checked:=false;
end;

procedure TFormula.undoBtnClick(Sender: TObject);
begin
activecontrol:=edF;
edF.Text:=Last;
end;

procedure TFormula.helpBtnClick(Sender: TObject);
begin
activecontrol:=edF;
{
 activecontrol:=edF;
showerror('You may use usual algebraic correct formulas. The default variables set is below. Compile variables and functions, add numbers and operations.'#13#10#13#10+
'There is no a super-smart correctness check engine. Check the stability of formula by yourself. If a error in calculaions would be found, the 0 (zero) value would be returned.'#13#10#13#10+
'When you press Apply button, the indicator''s Name would be prefixed with "|" symbol to the formula and pasted to to Counters Template Editor.'#13#10#13#10+
'Acknowledgements:'#13#10+
'1) space symbols in the line are just for you. The formula compiler will ignore them.'#13#10'   Simple example: Two? | 1 + 1'#13#10+
'2) ; symbol at the line beginning means that the line is a comment.'#13#10'   Simple example: ;this is comment'#13#10+
'3) # symbol at the line beginning means that the text of formula would be written on the indicator above.'#13#10'   Simple example: #hello|world'#13#10+
'4) @ symbol at the line beginning means that the text (left formula part) would be added to the above indicator''s text and the formula would be added as the result to the same indicator above.'#13#10'   Simple example: @test| TIME'#13#10#13#10+
'Finally, read the Help file!');
}
{showerror(
'1) the big edit box is the formula editor.'#13#10#13#10+
'2) second edit box is the name of your indicator.'#13#10#13#10+
'3) click on a variable to add it to the formula. If you have selected something inside the formula, the variable will replace the selection.'#13#10#13#10+
'4) operations would be added to the formula. Note, that each operation has one or more parameters, which must be replaced for the normal work of formula.'#13#10#13#10+
'5) you may mark formula as "text" or as "text and formula" using proper checkboxes.'#13#10#13#10+
'6) press "myVar" button to select all the artifical variables in formula. Then click on a variable button to replace the selection.'#13#10#13#10+
'7) press "Clear" button to clear text fields'#13#10#13#10+
'8) press "Undo" button to make a step backward.'
);}
showerror('Please see the Help file, "Counters Template Engine" topic');
if not fileexists(opt.apppath+'index.hlp')then
begin
showerror('File "INDEX.HLP" not found');exit;end;
try shellexecute(application.handle,'',pchar(opt.apppath+'index.hlp'),'',
    '',SW_SHOWMAXIMIZED);
    application.Minimize;
///    Application.MainForm.SendToBack;
    exit;except end;
end;

procedure TFormula.myVarBtnClick(Sender: TObject);
begin

end;

{procedure TFormula.myVarBtnClick(Sender: TObject);
begin
activecontrol:=edF;
if (pos('myBase',edF.text)>1) then begin
   edF.SelStart:=pos('myBase',edF.text)-1;
   edF.SelLength:=length('myBase');exit;
   end;
if (pos('myGrade',edF.text)>1) then begin
   edF.SelStart:=pos('myGrade',edF.text)-1;
   edF.SelLength:=length('myGrade');exit;
   end;
if (pos('myVar1',edF.text)>1) then begin
   edF.SelStart:=pos('myVar1',edF.text)-1;
   edF.SelLength:=length('myVar1');exit;
   end;
if (pos('myVarN',edF.text)>1) then begin
   edF.SelStart:=pos('myVarN',edF.text)-1;
   edF.SelLength:=length('myVarN');exit;
   end;
if (pos('myVar',edF.text)>1) then begin
   edF.SelStart:=pos('myVar',edF.text)-1;
   edF.SelLength:=length('myVar');exit;
   end;
if (pos('myValue1',edF.text)>1) then begin
   edF.SelStart:=pos('myValue1',edF.text)-1;
   edF.SelLength:=length('myValue1');exit;
   end;
if (pos('myValueN',edF.text)>1) then begin
   edF.SelStart:=pos('myValueN',edF.text)-1;
   edF.SelLength:=length('myValueN');exit;
   end;
if (pos('myValue',edF.text)>1) then begin
   edF.SelStart:=pos('myValue',edF.text)-1;
   edF.SelLength:=length('myValue');exit;
   end;
if (pos('myFunction',edF.text)>1) then begin
   edF.SelStart:=pos('myFunction',edF.text)-1;
   edF.SelLength:=length('myFunction');exit;
   end;
showerror('Any of these variables found:'#13#10#13#10'myBase myGrade myVar1 '+
'myVarN myVar myValue1 myValueN myValue myFunction');
end;}

procedure TFormula.FormCreate(Sender: TObject);
begin
formula_form_created:=true;
//lang
formula.caption:=cap_frm_caption;
formula.helpbtn.caption:=cap_frm_helpbtn;
//formula.formatbtn.caption:=cap_frm_formatbtn;
//formula.myvarbtn.caption:=cap_frm_myvarbtn;
formula.clearbtn.hint:=cap_frm_clearbtn;
formula.undobtn.hint:=cap_frm_undobtn;
formula.gbname.caption:=cap_frm_gbname;
//formula.gbvar.caption:=cap_frm_gbvar;
formula.gbop.caption:=cap_frm_gbop;
formula.cbastext.caption:=cap_frm_cbastext;
formula.cbasform.caption:=cap_frm_cbasform;
formula.cancelBtn.Caption:=cap_bcancel;
formula.applyBtn.Caption:=cap_bapply;
formula.height:=177;
panelbtn.caption:='>>>';
end;

procedure TFormula.sbEstimatedClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' TIMEEST';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' TIMEEST',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbTIMEgrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' GLRANKTIME';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' GLRANKTIME',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbBBBVSgrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' GLRANKBBBVS';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' GLRANKBBBVS',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbRPIgrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' GLOBRPI';
   exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' GLOBRPI',
   s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbDONEOPENINGbrdClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' OPENINGSDONE';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' OPENINGSDONE',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbCELLbrdClick(Sender: TObject);
var s1:string;
begin
Last:=edF.Text;
s1:=inputbox('Input cell','Number 0..8','0');
if (length(s)<>1)and(pos(s1,'012345678')<1) then
	begin showerror('Please, input the cell number');exit;end;
if edF.SelLength<1 then begin
edF.text:=edF.text+' CELL'+s1;exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' CELL'+s1,s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbMINESbrdClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' MC';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' MC',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbWIDTHbrdClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' DX';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' DX',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbHEIGHTbrdClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' DY';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' DY',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbISLANDClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' ISLANDS';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' ISLANDS',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbDONECELLbrdClick(Sender: TObject);
var s1:string;
begin
Last:=edF.Text;
s1:=inputbox('Input cell','Number 0..8','0');
if (length(s)<>1)and(pos(s1,'012345678')<1) then
	begin showerror('Please, input the cell number');exit;end;
if edF.SelLength<1 then begin
edF.text:=edF.text+' DONECELL'+s1;exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' DONECELL'+s1,s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbRQPrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' RANKRQP';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' RANKRQP',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbIOSrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' RANKIOS';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' RANKIOS',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbMBVgrnkClick(Sender: TObject);
begin
{MBV}
end;

procedure TFormula.sbRQPgrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' GLRANKRQP';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' GLRANKRQP',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbIOSgrnkClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' GLRANKIOS';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' GLRANKIOS',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbMBVrnkClick(Sender: TObject);
begin
{}
end;

procedure TFormula.sbMBVresClick(Sender: TObject);
begin
{}
end;

procedure TFormula.cancelBtnClick(Sender: TObject);
begin
Options_window.Enabled:=true;
Options_window.show;
hide;
end;

procedure TFormula.panelBtnClick(Sender: TObject);
begin
if panelBtn.caption='>>>' then
begin
panelbtn.caption:='<<<';
formula.Height:=498;
if formula.Top+formula.Height+50>screen.height then
begin
formula.top:=formula.top-(50+formula.Top+formula.Height-screen.height);
if formula.top<10 then formula.top:=10;
end;
end
else begin
panelbtn.caption:='>>>';
formula.Height:=177;
end;
end;

procedure TFormula.sbUSEDFLAGSbrdClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' REFF';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' REFF',s,edF.selStart+1);
edF.text:=s;
end;
end;

procedure TFormula.sbMODEbrdClick(Sender: TObject);
begin
Last:=edF.Text;
if edF.SelLength<1 then begin
edF.text:=edF.text+' MODE';exit;end
else begin
s:=edF.text;
delete(s,edF.SelStart+1,edF.sellength);
insert(' MODE',s,edF.selStart+1);
edF.text:=s;
end;
end;

end.
