unit FHistory;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, {Outline,} ExtCtrls, StdCtrls, Buttons, TeeProcs, TeEngine, Chart,
  Series, Menus, Spin, MATH, Outline;

type
  THistory = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel4: TPanel;
    PageSeL: TOutline;
    pChart: TPanel;
    pGrid: TPanel;
    lGridName: TLabel;
    Label1: TLabel;
    Label2: TLabel;
    sdG: TSaveDialog;
    Chart1: TChart;
    Label3: TLabel;
    lChartName: TLabel;
    Label5: TLabel;
    pSetup: TPanel;
    Label6: TLabel;
    lSetupName: TLabel;
    Label8: TLabel;
    Series1: TPieSeries;
    Rotator: TTimer;
    im_chart_colors: TImage;
    SpeedButton2: TSpeedButton;
    Panel5: TPanel;
    sg: TStringGrid;
    sbSaveGrid: TSpeedButton;
    Panel6: TPanel;
    savestatBtn: TButton;
    BackupBtn: TButton;
    ClearBtn: TButton;
    Panel7: TPanel;
    imLogo: TImage;
    odR: TOpenDialog;
    savestatnodebugBtn: TButton;
    pChart2: TPanel;
    Label4: TLabel;
    lchart2name: TLabel;
    Label9: TLabel;
    Chart2: TChart;
    PieSeries1: TPieSeries;
    SpeedButton1: TSpeedButton;
    MainMenu1: TMainMenu;
    ExitBtn: TMenuItem;
    pSearch: TPanel;
    Label7: TLabel;
    lSearchName: TLabel;
    Label11: TLabel;
    Panel9: TPanel;
    sgs: TStringGrid;
    Panel8: TPanel;
    seDateSecond: TSpinEdit;
    seDateMinute: TSpinEdit;
    seDateHour: TSpinEdit;
    seDateDay: TSpinEdit;
    seDateMonth: TSpinEdit;
    seDateyear: TSpinEdit;
    Label13: TLabel;
    seDateSecond2: TSpinEdit;
    seDateMinute2: TSpinEdit;
    seDateHour2: TSpinEdit;
    Label14: TLabel;
    seDateDay2: TSpinEdit;
    seDateMonth2: TSpinEdit;
    seDateYear2: TSpinEdit;
    cbBeg: TCheckBox;
    cbInt: TCheckBox;
    cbExp: TCheckBox;
    seTimeS: TSpinEdit;
    seTimeH: TSpinEdit;
    Label17: TLabel;
    seTimeS2: TSpinEdit;
    seTimeH2: TSpinEdit;
    seBV: TSpinEdit;
    Label19: TLabel;
    seBV2: TSpinEdit;
    seBVSS: TSpinEdit;
    seBVSH: TSpinEdit;
    Label21: TLabel;
    seBVSS2: TSpinEdit;
    seBVSH2: TSpinEdit;
    cbHour: TCheckBox;
    cbDate: TCheckBox;
    cbTime: TCheckBox;
    cbBV: TCheckBox;
    cbBVS: TCheckBox;
    cbF: TCheckBox;
    cbNF: TCheckBox;
    sbSavegrid2: TSpeedButton;
    searchBtn: TSpeedButton;
    defaultBtn: TSpeedButton;
    sortBtn: TSpeedButton;
    cbSort: TComboBox;
    sClearBtn: TSpeedButton;
    hiderBtn: TSpeedButton;
    SpeedButton3: TSpeedButton;
    od2: TOpenDialog;
    SpeedButton4: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure PageSeLClick(Sender: TObject);
    procedure BackupBtnClick(Sender: TObject);
    procedure ClearBtnClick(Sender: TObject);
    procedure RotatorTimer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure Chart1Click(Sender: TObject);
    procedure sbSaveGridClick(Sender: TObject);
    procedure RestoreBtnClick(Sender: TObject);
    procedure savestatBtnClick(Sender: TObject);
    procedure savestatnodebugBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure sbSavegrid2Click(Sender: TObject);
    procedure defaultBtnClick(Sender: TObject);
    procedure sClearBtnClick(Sender: TObject);
    procedure searchBtnClick(Sender: TObject);
    procedure hiderBtnClick(Sender: TObject);
    procedure sortBtnClick(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure LoadExternalFileBtnClick(Sender: TObject);
    procedure seDateDayChange(Sender: TObject);
    procedure seDateHourChange(Sender: TObject);
    procedure seTimeSChange(Sender: TObject);
    procedure seBVSSChange(Sender: TObject);
    procedure seBVChange(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  History: THistory;
{  rotUp:boolean=true;}
{  elevUp:boolean=false;}
  zoomUp:boolean=true;
  number_of_rows:integer;
//  explodeUP:boolean=false;
{  rotVal:longword=101;}

implementation

uses FData,FFunc,FMain,FCap, FCounters, FProgressBar;

{$R *.DFM}

procedure THistory.FormCreate(Sender: TObject);
var i:integer;
begin
cbSort.Clear;
//cbSort.Items.Add(cap_Date);
//cbSort.Items.Add(cap_Hour);
//cbSort.Items.Add(cap_Date+' inverse');
//cbSort.Items.Add(cap_Hour+' inverse');
cbSort.Items.Add(cap_time);
cbSort.Items.Add(cap_time+' inverse');
cbSort.Items.Add(cap_3bvs);
cbSort.Items.Add(cap_3bvs+' inverse');
cbSort.Items.Add(cap_3bv);
cbSort.Items.Add(cap_3bv+' inverse');
cbSort.Items.Add(cap_mode);
cbSort.Items.Add(cap_mode+' inverse');
cbSort.Items.Add(cap_style);
cbSort.Items.Add(cap_style+' inverse');
cbSort.Sorted:=false;
//cbSort.Sorted:=true;
chart1.Series[0].Clear;
chart2.Series[0].Clear;
series1.ExplodeBiggest:={random(40)+20}0;
series1.Rotate(random(360));
PieSeries1.ExplodeBiggest:=0;
PieSeries1.Rotate(random(360));

history_form_created:=true;
imLogo.Picture:=main.imLogo.picture;
top:=0;
left:=0;
width:=800;
height:=580;
pChart.Align:=alClient;
pChart2.Align:=alClient;
pGrid.Align:=alClient;
pSetup.Align:=alClient;
pSearch.Align:=alClient;
pChart.Hide;
pChart2.Hide;
pGrid.Hide;
pSetup.Hide;
pSearch.Hide;

   sg.ColWidths[0]:=94;
for i:=0 to sg.ColCount-1 do
   begin
   sg.Rows[1].Strings[i]:='';
   end;
language_apply;

for i:=1 to 27 do PageSel.OnClick(pagesel);//?????
PageSel.OnClick(pagesel);
end;

procedure THistory.FormClose(Sender: TObject; var Action: TCloseAction);
begin
opt.posHistX:=left;
opt.posHistY:=top;
opt.posHistW:=width;
opt.posHistH:=height;
timer_stop;
hide_history;
//settime(0,0);
parse_counter;
checksum_all_store;
if opt.doShowCounters then counters_show else counters_hide;
if is_replay_mode then showwindow(progressbar.handle,sw_show);
end;

procedure norm_table();
begin with history do begin
   history.Rotator.Enabled:=false;
   pGrid.show;
   pChart2.hide;
   pChart.Hide;
   pSetup.Hide;
   pSearch.Hide;
end;end;

procedure THistory.PageSeLClick(Sender: TObject);
var sF,sNF,gB,gI,gE:word;
begin
//sg.ColWidths[0]:=94;
sg_clear;
// search
if PageSel.SelectedItem=33 then	// search
   begin
   sClearBtn.Click;
   DefaultBtn.Click;
   history.Rotator.Enabled:=false;
   lSearchName.Caption:=pagesel.Items[33].Text+'     ';
   panel8.Visible:=true;
   hiderBtn.Caption:='<<<';
   pSearch.show;
   pSetup.hide;
   pChart.hide;
   pChart2.hide;
   pGrid.hide;
   exit;end;

// history setup
if PageSel.SelectedItem=32 then
   begin
   history.Rotator.Enabled:=false;
   lSetupName.Caption:=pagesel.Items[32].Text;
   pSetup.show;
   pSearch.Hide;
   pChart.hide;
   pChart2.hide;
   pGrid.hide;
   exit;end;
// unsorted   ENTIRE
if PageSel.SelectedItem=31 then
   begin
   history.Rotator.Enabled:=false;
   lGridName.caption:=cap_history_cap24;
   pGrid.show;
   pSearch.Hide;
   pChart.Hide;
   pChart2.hide;
   pSetup.Hide;
   history_fillEntire;
   exit;end;
// activity
if PageSel.SelectedItem=30 then
   begin
   history.Rotator.Enabled:=false;
   lGridName.caption:=cap_history_cap23;
   pGrid.show;
   pSearch.Hide;
   pChart.Hide;
   pChart2.hide;
   pSetup.Hide;
   history_fillActivity;
   exit;end;
//Style chart
if PageSel.SelectedItem=28 then
   begin
   pGrid.hide;
   pSearch.Hide;
   pChart2.hide;
   pSetup.Hide;
   history.Rotator.Enabled:=true;
   lChartName.caption:=cap_history_cap22;
   sF:=calculate_F;
   sNF:=calculate_NF;
//   if sF=sNF then sF:=sf+1;
   With chart1.Series[0] do
      Begin
      clear;
      if sf<>0 then Add(sF,cap_history_chartFS,im_chart_colors.Canvas.Pixels[5,0]);
      if sNF<>0 then Add(sNF,cap_history_chartNFS,im_chart_colors.Canvas.Pixels[3,0]);
      end;
   pChart.Show;
   exit;end;
//GAMES chart
if PageSel.SelectedItem=29 then
   begin
   pGrid.hide;
   pSetup.Hide;
   pChart.hide;
   pSearch.Hide;
   history.Rotator.Enabled:=true;
   lChart2Name.caption:=cap_history_cap26;

   gB:=calculate_BEG_games;
   gI:=calculate_INT_games;
   gE:=calculate_EXP_games;

   if (gE=gI)and(gE<>0) then gI:=gI+1;
   if (gE=gB)and(gE<>0) then gB:=gB+1;
   if (gB=gI)and(gB<>0) then gB:=gB+1;

   With chart2.Series[0] do
      Begin
      clear;
      if gB<>0 then Add(GB,cap_beg,im_chart_colors.Canvas.Pixels[5,0]);
      if gI<>0 then Add(GI,cap_int,im_chart_colors.Canvas.Pixels[1,0]);
      if gE<>0 then Add(GE,cap_exp,im_chart_colors.Canvas.Pixels[3,0]);
      end;
   pChart2.Show;
   exit;end;

//Overall beg chart
if PageSel.SelectedItem=9 then
   begin
   pGrid.hide;
   pSetup.Hide;
   pChart2.hide;
   pSearch.Hide;
   history.Rotator.Enabled:=true;
   lChartName.caption:=cap_history_cap07;
   sF:=calculate_beg_F;
   sNF:=calculate_beg_NF;
   if sF=sNF then sF:=sf+1;
   With chart1.Series[0] do
      Begin
      clear;
      if sf<>0 then Add(sF,cap_history_chartFS,im_chart_colors.Canvas.Pixels[5,0]);
      if sNF<>0 then Add( sNF,cap_history_chartNFS,im_chart_colors.Canvas.Pixels[3,0]);
      end;
   pChart.Show;
   exit;end;
//Overall intermediate chart
if PageSel.SelectedItem=18 then
   begin
   pGrid.hide;
   pSetup.Hide;
   pSearch.Hide;
   pChart2.hide;
   history.Rotator.Enabled:=true;
   lChartName.caption:=cap_history_cap14;
   sF:=calculate_int_F;
   sNF:=calculate_int_NF;
   if sF=sNF then sF:=sf+1;
   With chart1.Series[0] do
      Begin
      clear;
      if sf<>0 then Add(sF,cap_history_chartFS,im_chart_colors.Canvas.Pixels[5,0]);
      if sNF<>0 then Add( sNF,cap_history_chartNFS,im_chart_colors.Canvas.Pixels[3,0]);
      end;
   pChart.Show;
   exit;end;
//Overall expert-stylechart
if PageSel.SelectedItem=27 then
   begin
   pGrid.hide;
   pSetup.Hide;
   pSearch.Hide;
   pChart2.hide;
   history.Rotator.Enabled:=true;
   lChartName.caption:=cap_history_cap21;
   sF:=calculate_exp_F;
   sNF:=calculate_exp_NF;
   if sF=sNF then sF:=sf+1;
   With chart1.Series[0] do
      Begin
      clear;
      if sf<>0 then Add(sF,cap_history_chartFS,im_chart_colors.Canvas.Pixels[5,0]);
      if sNF<>0 then Add( sNF,cap_history_chartNFS,im_chart_colors.Canvas.Pixels[3,0]);
      end;
   pChart.Show;
   exit;end;
//beginner review
if (PageSel.SelectedItem=1) then
   begin
	norm_table;
	lGridName.caption:=cap_history_cap01;
	history_fillBReview;
   exit;end;
//int review
if (PageSel.SelectedItem=10) then
   begin
	norm_table;
    lGridName.caption:=cap_history_cap08;
  history_fillIReview;
   exit;end;
//exp review
if (PageSel.SelectedItem=19) then
   begin
	norm_table;
    lGridName.caption:=cap_history_cap15;
  history_fillEReview;
   exit;end;

   //beginner daily
if (PageSel.SelectedItem=8) then
   begin
	norm_table;
   lGridName.caption:=cap_history_capN0;
	history_filldaily(0);
   exit;end;
//int daily
if (PageSel.SelectedItem=17) then
   begin
	norm_table;
   lGridName.caption:=cap_history_capN1;
   history_filldaily(1);
   exit;end;
//exp review
if (PageSel.SelectedItem=26) then
   begin
	norm_table;
   lGridName.caption:=cap_history_capN2;
   history_filldaily(2);
   exit;end;

   //beginner evo
if (PageSel.SelectedItem=7) then
   begin
	norm_table;
   lGridName.caption:=cap_history_capE0;
	history_fillevolution(0);
   exit;end;
//int daily
if (PageSel.SelectedItem=16) then
   begin
	norm_table;
   lGridName.caption:=cap_history_capE1;
   history_fillevolution(1);
   exit;end;
//exp review
if (PageSel.SelectedItem=25) then
   begin
	norm_table;
   lGridName.caption:=cap_history_capE2;
   history_fillevolution(2);
   exit;end;

   //beg top times
if (PageSel.SelectedItem=2)then
   begin
   lGridName.caption:=cap_history_cap02;
	norm_table;
   history_fillBTopTime;
   exit;end;
//int top times
if (PageSel.SelectedItem=11)then
   begin
   lGridName.caption:=cap_history_cap09;
	norm_table;
   history_fillITopTime;
   exit;end;
//exp top times
if (PageSel.SelectedItem=20)then
   begin
   lGridName.caption:=cap_history_cap16;
	norm_table;
   history_fillETopTime;
   exit;end;

//beg top 3BVs
if (PageSel.SelectedItem=3)then
   begin
   lGridName.caption:=cap_history_cap03;
	norm_table;
   history_fillBTop3bv;
   exit;end;
//int top 3bvs
if (PageSel.SelectedItem=12)then
   begin
   lGridName.caption:=cap_history_cap10;
	norm_table;
   history_fillITop3bv;
   exit;end;
//exp top 3bvs
if (PageSel.SelectedItem=21)then
   begin
   lGridName.caption:=cap_history_cap17;
	norm_table;
   history_fillETop3bv;
   exit;end;

//beg time rev
if (PageSel.SelectedItem=4)then
   begin
   lGridName.caption:=cap_history_cap04;
	norm_table;
   history_fillBTimeReview;
   exit;end;
//int time rev
if (PageSel.SelectedItem=13)then
   begin
   lGridName.caption:=cap_history_cap11;
	norm_table;
   history_fillITimeReview;
   exit;end;
//exp time rev
if (PageSel.SelectedItem=22)then
   begin
   lGridName.caption:=cap_history_cap18;
	norm_table;
   history_fillETimeReview;
   exit;end;

//beg 3bvS rev
if (PageSel.SelectedItem=5)then
   begin
   lGridName.caption:=cap_history_cap05;
	norm_table;
   history_fillB3bvsReview;
   exit;end;
//int 3bvS rev
if (PageSel.SelectedItem=14)then
   begin
   lGridName.caption:=cap_history_cap12;
	norm_table;
   history_fillI3bvsReview;
   exit;end;
//exp 3bvS rev
if (PageSel.SelectedItem=23)then
   begin
   lGridName.caption:=cap_history_cap19;
	norm_table;
   history_fillE3bvsReview;
   exit;end;
// beg 3BV review
if (PageSel.SelectedItem=6)then
   begin
   lGridName.caption:=cap_history_cap06;
	norm_table;
   history_fillB3bvReview;
   exit;end;
// beg 3BV review
if (PageSel.SelectedItem=15)then
   begin
   lGridName.caption:=cap_history_cap13;
	norm_table;
   history_fillI3bvReview;
   exit;end;
// beg 3BV review
if (PageSel.SelectedItem=24)then
   begin
   lGridName.caption:=cap_history_cap20;
	norm_table;
   history_fillE3bvReview;
   exit;end;

end;

procedure THistory.BackupBtnClick(Sender: TObject);
var s:String;
begin
try
init_timer;
s:='stats_backup_'+
   inttostr(ts.wDay)+'-'+
   inttostr(ts.wMonth)+'-'+
   inttostr(ts.wYear)+'_'+
   inttostr(ts.wHOur)+'-'+
   inttostr(ts.wMinute)+'-'+
   inttostr(ts.wSecond)+'.dat';
   CopyFile(pchar(opt.apppath+historyfile),pchar(opt.apppath+s),false);
showerror(cap_history_backupfile+' "'+s+'"');
except
showerror(cap_history_needreopen);
end;
end;

procedure THistory.ClearBtnClick(Sender: TObject);
var s:String;
begin
if messagedlg(cap_history_ask1,mtWarning,[mbNo,mbYes],0)=mrYes then
try
init_timer;
s:='stats_backup_'+inttostr(ts.wHOur)+'h'+
   inttostr(ts.wMinute)+'m'+
   inttostr(ts.wSecond)+'s-'+
   inttostr(ts.wDay)+'d'+
   inttostr(ts.wMonth)+'m'+
   inttostr(ts.wYear)+'y.dat';
   CopyFile(pchar(opt.apppath+historyfile),pchar(opt.apppath+s),false);
deletefile(opt.apppath+historyfile);
deletefile(opt.apppath+'statszini.dat');
fillchar(hist,sizeof(hist),0);
beg_totalgames:=0;
int_totalgames:=0;
exp_totalgames:=0;
hide_history;exit;
except end;
end;

procedure THistory.RotatorTimer(Sender: TObject);
begin
series1.Rotate(1);
Pieseries1.Rotate(1);
if ZoomUp then
begin
   chart1.View3DOptions.Zoom:=chart1.View3DOptions.Zoom+1;
   if chart1.View3DOptions.Zoom>140 then ZoomUp:=false;
   chart2.View3DOptions.Zoom:=chart1.View3DOptions.Zoom;
   end
else
   begin
   chart1.View3DOptions.Zoom:=chart1.View3DOptions.Zoom-1;
   if chart1.View3DOptions.Zoom<75 then ZoomUp:=true;
   chart2.View3DOptions.Zoom:=chart1.View3DOptions.Zoom;
   end;
end;

procedure THistory.SpeedButton2Click(Sender: TObject);
begin
showerror(cap_history_piedrawing);
end;

procedure THistory.Chart1Click(Sender: TObject);
begin
rotator.Enabled:=not rotator.Enabled;
end;

procedure THistory.sbSaveGridClick(Sender: TObject);
begin
sdG.InitialDir:=opt.apppath;
if sdG.Execute then
if sdG.FileName<>'' then
   begin
   grid_save(sdG.filename);
   sdG.FileName:='';
   end;
end;

procedure THistory.RestoreBtnClick(Sender: TObject);
var s:String;
    f:file of char;
    tz:String;
    c:char;
    i:integer;
begin
showerror('Disabled in this debug version');
exit;
if messagedlg(cap_history_ask1,mtWarning,[mbNo,mbYes],0)=mrNo then exit;
odr.InitialDir:=opt.apppath;
if odR.Execute then
if odR.FileName<>'' then
begin


if not fileexists(odR.filename)then begin
showerror(cap_history_nothf);
odr.FileName:='';exit;end;
assignfile(f,odR.filename);
reset(f);
if filesize(f) mod 14 <> 0 then begin
closefile(f);
showerror(cap_history_nothf);
odr.FileName:='';exit;end;

try
while not eof(f) do
begin
  tz:='';
  for i:=1 to 14 do begin read(f,c);tz:=tz+c;end;
    if meta_cs(copy(tz,1,12))<>copy(tz,13,2) then
    begin
    closefile(f);
    showerror(cap_history_nothf);
    odr.FileName:='';
    exit;
    end;
end;
closefile(f);
except closefile(f);
showerror(cap_history_nothf);
odr.FileName:='';exit;end;

init_timer;
s:='history_backup_'+inttostr(ts.wHOur)+'-'+
   inttostr(ts.wMinute)+'-'+
   inttostr(ts.wSecond)+'_'+
   inttostr(ts.wDay)+'-'+
   inttostr(ts.wMonth)+'-'+
   inttostr(ts.wYear)+'.dat';
   CopyFile(pchar(opt.apppath+historyfile),pchar(opt.apppath+s),false);
deletefile(pchar(opt.apppath+historyfile));
CopyFile(pchar(odR.filename),pchar(opt.apppath+historyfile),false);
odR.FileName:='';
showerror(cap_history_needreopen);
hide_history;
end;
end;

procedure THistory.savestatBtnClick(Sender: TObject);
begin
sdG.InitialDir:=opt.apppath;
if sdG.Execute then
if sdG.FileName<>'' then
   begin
   full_grid_save(sdG.filename);
   sdG.FileName:='';
   end;
end;

procedure THistory.savestatnodebugBtnClick(Sender: TObject);
begin
sdG.InitialDir:=opt.apppath;
if sdG.Execute then
if sdG.FileName<>'' then
   begin
   full_nodebug_grid_save(sdG.filename);
   sdG.FileName:='';
   end;
end;

procedure THistory.ExitBtnClick(Sender: TObject);
begin
main.Enabled:=true;
main.show;
history.hide;
if opt.doShowCounters then counters_show else counters_hide;
end;

procedure THistory.sbSavegrid2Click(Sender: TObject);
begin
sdG.InitialDir:=opt.apppath;
if sdG.Execute then
if sdG.FileName<>'' then
   begin
   grid2_save(sdG.filename);
   sdG.FileName:='';
   end;
end;

procedure THistory.defaultBtnClick(Sender: TObject);
begin
try
cbBeg.Checked:=true;
cbInt.Checked:=true;
cbExp.Checked:=true;
cbF.Checked:=true;
cbNF.Checked:=true;
seDateDay.value:=ts.wDay;
seDateMonth.value:=ts.wMonth;
seDateYear.value:=ts.wyear;
seDateSecond.value:=0;
seDateMinute.value:=0;
seDateHour.value:=0;
init_timer;
seDateDay2.value:=ts.wDay;
seDateMonth2.value:=ts.wMonth;
seDateYear2.value:=ts.wyear;
//seDateSecond2.value:=ts.wSecond;
//seDateMinute2.value:=ts.wMinute;
//seDateHour2.value:=ts.wHour;
seDateSecond2.value:=59;
seDateMinute2.value:=59;
seDateHour2.value:=23;
seTimeS.Value:=0;
seTimeH.Value:=0;
seTimeS2.Value:=999;
seTimeH2.Value:=99;
seBVSS.Value:=0;
seBVSH.Value:=0;
seBVSS2.Value:=99;
seBVSH2.Value:=99;
seBV.Value:=1;
seBV2.Value:=379;
//cbSort.Text:=cap_Date;
//try cbSort.ItemIndex:=cbSort.Items.IndexOf(cap_time)
//except cbSort.Text:='';end;
cbSort.ItemIndex:=cbSort.Items.IndexOf(cap_time);
cbDate.checked:=true;
cbHour.checked:=false;
cbTime.checked:=false;
cbBVS.Checked:=false;
cbBV.checked:=false;
except end;
end;

procedure THistory.sClearBtnClick(Sender: TObject);
begin
with history.sgs do begin
ColCount:=8;RowCount:=1;
ColWidths[0]:=46;
ColWidths[1]:=84;
ColWidths[2]:=84;
ColWidths[3]:=64;
ColWidths[4]:=84;
ColWidths[5]:=84;
ColWidths[6]:=84;
ColWidths[7]:=84;
rows[0].Strings[0]:='#';
rows[0].Strings[1]:=cap_date;
rows[0].Strings[2]:=cap_hour;
rows[0].Strings[3]:=cap_mode;
rows[0].Strings[4]:=cap_style;
rows[0].Strings[5]:=cap_time;
rows[0].Strings[6]:=cap_3bv;
rows[0].Strings[7]:=cap_3bvs;
rows[1].Strings[0]:=cap_avg;
end;
end;

function getDaySpan(d:byte;m:byte;y:word):longword;
begin
result:=y*1024+m*64+d;
end;

function getTimeSpan(s:byte;m:byte;h:byte):longword;
begin result:=s+60*m+3600*h;end;

procedure THistory.searchBtnClick(Sender: TObject);
var k,i,cnt,f,tms,tms2,tmh2,tmh:longword;
begin
	i:=0;
	number_of_rows:=0;
	while (hist[i].dateDay<>0)and(i<cHistMax) do 
		i:=i+1;
	i:=i-1;
	sClearBtn.click;
	cnt:=2;
	sgs.RowCount:=1;
	for k:=0 to i do begin//search started
		f:=0;
		if (not cbBeg.Checked) and (hist[k].mode=0) then f:=f+1;
		if (not cbInt.Checked) and (hist[k].mode=1) then f:=f+1;
		if (not cbExp.Checked) and (hist[k].mode=2) then f:=f+1;
		if (not cbF.Checked) and (hist[k].fstyle) then f:=f+1;
		if (not cbNF.Checked) and (not hist[k].fstyle) then f:=f+1;
		if (cbDate.Checked) and ((getDaySpan(seDateDay.value,seDateMonth.value,seDateYear.value)>
								  getDaySpan(hist[k].dateDay,hist[k].dateMonth,hist[k].dateYear))
								or (getDaySpan(seDateDay2.value,seDateMonth2.value,seDateYear2.value)<
									getDaySpan(hist[k].dateDay,hist[k].dateMonth,hist[k].dateYear))) then f:=f+1;
		if (cbHour.Checked) and((getTimeSpan(seDateSecond.value,seDateMinute.value,seDateHour.value)>
								getTimeSpan(hist[k].dateSecond,hist[k].dateMinute,hist[k].dateHour))
							or(getTimeSpan(seDateSecond2.value,seDateMinute2.value,seDateHour2.value)<
								getTIMESpan(hist[k].dateSecond,hist[k].dateMinute,hist[k].dateHour))) then f:=f+1;

		if (cbTime.Checked and opt.doRecorderStyleTimer)
			and((seTimeS.value*100+seTimeH.value>hist[k].gameTimeS*100+100+hist[k].gameTimeH)
			or(seTimeS2.value*100+seTimeH2.value<hist[k].gameTimeS*100+100+hist[k].gameTimeH)) then f:=f+1;

		if (cbTime.Checked and not opt.doRecorderStyleTimer)
			and((seTimeS.value*100+seTimeH.value>hist[k].gameTimeS*100+hist[k].gameTimeH)
			or(seTimeS2.value*100+seTimeH2.value<hist[k].gameTimeS*100+hist[k].gameTimeH)) then f:=f+1;

		if (cbBVS.Checked) and((seBVSS.value*100+seBVSH.value>hist[k].bbbvsS*100+hist[k].bbbvsH)
							or(seBVSS2.value*100+seBVSH2.value<hist[k].bbbvsS*100+hist[k].bbbvsH)) then f:=f+1;

		if (cbBV.checked)and((seBV.Value>hist[k].bbbv)or(seBV2.Value<hist[k].bbbv)) then f:=f+1;

		if f=0 then begin
			qsa[number_of_rows]:=k;
			number_of_rows:=number_of_rows+1;
			sgs.rows[cnt].Strings[0]:=inttostr(cnt-1);
			sgs.rows[cnt].Strings[1]:=t2date(hist[k].dateDay,hist[k].dateMonth,hist[k].dateYear);
			sgs.rows[cnt].Strings[2]:=t2hour(hist[k].datehour,hist[k].dateMinute,hist[k].dateSecond);
			if hist[k].mode=0 then sgs.rows[cnt].Strings[3]:=cap_beg else
			if hist[k].mode=1 then sgs.rows[cnt].Strings[3]:=cap_int else
			if hist[k].mode=2 then sgs.rows[cnt].Strings[3]:=cap_exp;
			if hist[k].fstyle then sgs.rows[cnt].Strings[4]:=cap_flag else
										sgs.rows[cnt].Strings[4]:=cap_nflag;
			sgs.rows[cnt].Strings[5]:=t2str(hist[k].gameTimeS,hist[k].gameTimeH);
			sgs.rows[cnt].Strings[6]:=inttostr(hist[k].bbbv);
			sgs.rows[cnt].Strings[7]:=fl2str(hist[k].bbbvsS,hist[k].bbbvsH);
			cnt:=cnt+1;
		end;

	end;//search end

	if(cnt<=2) then sgs.RowCount:=1 else sgs.RowCount:=cnt;
	for i:=1 to 7 do sgs.rows[1].Strings[i]:='';
	if sgs.RowCount<3 then exit;
	
	//avg time
	tms:=0;tmh:=0;
	try
		for i:=2 to sgs.RowCount-1 do
			try
				tms:=tms+trunc(strtofloat(sgs.rows[i].Strings[5]));
				tmh:=tmh+trunc(10000*frac(strtofloat(sgs.rows[i].Strings[5])));
			except 
				debug_add('#strtofloat error in "'+sgs.rows[i].Strings[5]+'"') 
			end;
		tms:=tms+tmH div 10000;
		tmH:=tmH mod 10000;
		tmS2:=tms div (cnt-2);
		tmh:=tmh+10000*(tms - tmS2 * (cnt-2));
		tmH2:=(tmh div (cnt-2))mod 10000;
		sgs.Rows[1].Strings[5]:=inttostr(tms2)+','+
								inttostr(tmh2 div 1000)+
								inttostr((tmh2 mod 1000) div 100)+
								inttostr((tmh2 mod 100) div 10)+
								inttostr(tmh2 mod 10);
	except 
		sgs.Rows[1].Strings[5]:='ERROR';
	end;
	
	//avg 3bv
	tms:=0;
	try
		for i:=2 to sgs.RowCount-1 do
			try
				tms:=tms+trunc(strtofloat(sgs.rows[i].Strings[6]));
			except 
				debug_add('#strtofloat error in "'+sgs.rows[i].Strings[6]+'"') 
			end;
		tmS2:=tms div (cnt-2);
		tmh:=10000*(tms - tmS2 * (cnt-2));
		tmH2:=(tmh div (cnt-2))mod 10000;
		sgs.Rows[1].Strings[6]:=inttostr(tms2)+','+
							   inttostr(tmh2 div 1000)+
							   inttostr((tmh2 mod 1000) div 100)+
							   inttostr((tmh2 mod 100) div 10)+
							   inttostr(tmh2 mod 10);
	except 
		sgs.Rows[1].Strings[6]:='ERROR';
	end;

	//avg 3bv/s
	tms:=0;tmh:=0;
	try
		for i:=2 to sgs.RowCount-1 do
			try
				tms:=tms+trunc(strtofloat(sgs.rows[i].Strings[7]));
				tmh:=tmh+trunc(10000*frac(strtofloat(sgs.rows[i].Strings[7])));
			except 
				debug_add('#strtofloat error in "'+sgs.rows[i].Strings[7]+'"') 
			end;
		tms:=tms+tmH div 10000;
		tmH:=tmH mod 10000;
		tmS2:=tms div (cnt-2);
		tmh:=tmh+10000*(tms - tmS2 * (cnt-2));
		tmH2:=(tmh div (cnt-2))mod 10000;
		sgs.Rows[1].Strings[7]:=inttostr(tms2)+','+
							   inttostr(tmh2 div 1000)+
							   inttostr((tmh2 mod 1000) div 100)+
							   inttostr((tmh2 mod 100) div 10)+
							   inttostr(tmh2 mod 10);
	except 
		sgs.Rows[1].Strings[7]:='ERROR';
	end;
end;

procedure THistory.hiderBtnClick(Sender: TObject);
begin
panel8.Visible:=not panel8.Visible;
if panel8.Visible then hiderBtn.Caption:='<<<' else hiderBtn.Caption:='>>>';
end;

function comparestr(s1:string;s2:string):boolean;
var i:word;
begin result:=false;
i:=1;
while i<=length(s1) do begin
if ord(s1[i])>ord(s2[i])then begin
//showerror(s2+#13#10+'>'+#13#10+s1);
result:=true;exit;end;
i:=i+1;end;
end;

procedure THistory.sortBtnClick(Sender: TObject);
var {m,}i,k:longword;t,d:byte;s:string;
begin
	if sgs.RowCount<3 then exit;
	if sgs.RowCount>1000 then 
		if MessageDlg(cap_slowsorting_warn,mtConfirmation, [mbYes, mbNo], 0) = mrNo then exit;

	if cbSort.Text=cap_date then
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=getdayspan(hist[qsa[k]].dateday,hist[qsa[k]].datemonth,hist[qsa[k]].dateyear)*10000+
						gettimespan(hist[qsa[k]].datesecond,hist[qsa[k]].dateminute,hist[qsa[k]].datehour)
	else if cbSort.Text=cap_date+' inverse' then 
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=-getdayspan(hist[qsa[k]].dateday,hist[qsa[k]].datemonth,hist[qsa[k]].dateyear)*10000-
						gettimespan(hist[qsa[k]].datesecond,hist[qsa[k]].dateminute,hist[qsa[k]].datehour)
	else if cbSort.Text=cap_Hour then 
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=gettimespan(hist[qsa[k]].datesecond,hist[qsa[k]].dateminute,hist[qsa[k]].datehour)
	else if cbSort.Text=cap_Hour+' inverse' then
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=-gettimespan(hist[qsa[k]].datesecond,hist[qsa[k]].dateminute,hist[qsa[k]].datehour)
	else if cbSort.Text=cap_Mode then 
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=hist[qsa[k]].mode
	else if cbSort.Text=cap_Mode+' inverse' then
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=-hist[qsa[k]].mode
	else if cbSort.Text=cap_Style then
		for k:=0 to number_of_rows-1 do
			if(hist[qsa[k]].fstyle) then qsd[qsa[k]]:=0 else qsd[qsa[k]]:=1
	else if cbSort.Text=cap_Style+' inverse' then
		for k:=0 to number_of_rows-1 do
			if(hist[qsa[k]].fstyle) then qsd[qsa[k]]:=0 else qsd[qsa[k]]:=-1
	else if cbSort.Text=cap_Time then 
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=hist[qsa[k]].gametimes*100+hist[qsa[k]].gametimeh
	else if cbSort.Text=cap_Time+' inverse' then
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=-hist[qsa[k]].gametimes*100-hist[qsa[k]].gametimeh
	else if cbSort.Text=cap_3bv then
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=hist[qsa[k]].bbbv
	else if cbSort.Text=cap_3bv+' inverse' then
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=-hist[qsa[k]].bbbv
	else if cbSort.Text=cap_3bvs then
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=-hist[qsa[k]].bbbvss*100-hist[qsa[k]].bbbvsh
	else if cbSort.Text=cap_3bvs+' inverse' then
		for k:=0 to number_of_rows-1 do
			qsd[qsa[k]]:=hist[qsa[k]].bbbvss*100+hist[qsa[k]].bbbvsh;

	try
		QuickSort(qsa,qsd,number_of_rows);
		for k:=0 to number_of_rows-1 do begin
			sgs.rows[k+2].Strings[0]:=inttostr(k+1);
			sgs.rows[k+2].Strings[1]:=t2date(hist[qsa[k]].dateDay,hist[qsa[k]].dateMonth,hist[qsa[k]].dateYear);
			sgs.rows[k+2].Strings[2]:=t2hour(hist[qsa[k]].datehour,hist[qsa[k]].dateMinute,hist[qsa[k]].dateSecond);
			if hist[qsa[k]].mode=0 then sgs.rows[k+2].Strings[3]:=cap_beg else
			if hist[qsa[k]].mode=1 then sgs.rows[k+2].Strings[3]:=cap_int else
			if hist[qsa[k]].mode=2 then sgs.rows[k+2].Strings[3]:=cap_exp;
			if hist[qsa[k]].fstyle then sgs.rows[k+2].Strings[4]:=cap_flag else
										sgs.rows[k+2].Strings[4]:=cap_nflag;
			sgs.rows[k+2].Strings[5]:=t2str(hist[qsa[k]].gameTimeS,hist[qsa[k]].gameTimeH);
			sgs.rows[k+2].Strings[6]:=inttostr(hist[qsa[k]].bbbv);
			sgs.rows[k+2].Strings[7]:=fl2str(hist[qsa[k]].bbbvsS,hist[qsa[k]].bbbvsH);
		end;
	except 
		showerror('Error occured!'+#13#10+'operation #'+inttostr(1));
	end;
end;

procedure THistory.SpeedButton3Click(Sender: TObject);
begin
showerror(cap_slowsorting+#13#10#13#10'Read the IOS.txt file '+
'about the "Index of Speed"');
end;

procedure THistory.LoadExternalFileBtnClick(Sender: TObject);
var s:string;
    f:file of char;
//    f1:textfile;
    t:String;c:char;i:integer;
    k:longword;
begin
showerror('Disabled in this debug version');
exit;
k:=0;
od2.InitialDir:=opt.apppath;od2.FileName:='';
if od2.execute then begin
   if not fileexists(od2.filename)then exit;
{if uppercase(extractfilename(od2.filename))='ARBITER.DAT'then begin
   debug_add('external arbiter history file corrupted');
   showerror('File "'+od2.filename+'"'+#13#10#13#10+
   'is not a correct Minesweeper Arbiter History File (.DAT)');exit;end;}

s:=od2.Filename;
s:=copy(s,length(s)-2,3);
if uppercase(s)='DAT' then
   BEGIN//load Arbiter history

assignfile(f,od2.filename);
reset(f);

if filesize(f) mod 14 <> 0 then begin
closefile(f);
debug_add('external arbiter history file corrupted');
         showerror('File "'+od2.filename+'"'+#13#10#13#10+
         'is not a correct Minesweeper Arbiter History File (.DAT)');
exit;end;

try
fillchar(hist,sizeof(hist),0);
while not eof(f) do
   begin
   t:='';
   for i:=1 to 14 do
      begin
      read(f,c);
      t:=t+c;
      end;
{ RULEZ
 date      :  (byte+50*mode)-(byte+128)-((byte+128)-(byte+128))             ####
 hour+style:  (style*100)+H_(byte)-M_(byte+128)-S_(byte+128)  #######
 gtime     :  ((byte+128)-byte+128))-(byte+128)                  ##########
 3bv       :  ((byte+128)-(byte+128))                       ############
 -> total     ##### ##### ####    14 bytes per pattern + CheckSum 2 bytes  }

 if meta_cs(copy(t,1,12))<>copy(t,13,2) then
   begin closefile(f);
debug_add('external arbiter history file corrupted');
         showerror('File "'+od2.filename+'"'+#13#10#13#10+
         'is not a correct Minesweeper Arbiter History File (.DAT)');
exit;end;

if not(
 (POS(copy(t,1,12),'ArBiTeRhIsTo')=1)or(
  POS(copy(t,1,12),'RyHuOvEmGoTd')=1)or(
  POS(copy(t,1,12),'OsKiLzToTsTm')=1)or(
  POS(copy(t,1,12),'EyOpAnYoRmIn')=1)or(
  POS(copy(t,1,12),'DsAaFtUmEyHe')=1)or(
  POS(copy(t,1,12),'AaIaMiLaVTIn')=1)or(
  POS(copy(t,1,12),'YrIeLhYpAsPa')=1)or(
  POS(copy(t,1,12),'SiNsTaDoVeAr')=1)or(
  POS(copy(t,1,12),'TlIkWaDgLiOm')=1)or(
  POS(copy(t,1,12),'EnMaAiZyReAc')=1)or(
  POS(copy(t,1,12),'KiDbYe'+chr(23)+chr(25)+
             chr(27)+chr(29)+chr(31)+chr(33))=1)) then
 begin
 hist[k].dateDay:=ord(t[1])mod 50;
 hist[k].dateMonth:=ord(t[12])-129;
 hist[k].dateYear:=(ord(t[8]))*256+(ord(t[2]));
 hist[k].dateHour:=ord(t[5])mod 100;
 hist[k].dateMinute:=ord(t[10])-127;
 hist[k].dateSecond:=ord(t[6])-123;
 hist[k].gameTimeS:=(ord(t[11]))*256+(ord(t[7]));
 hist[k].gameTimeH:=ord(t[3])-121;
 hist[k].bbbv:=(ord(t[4]))*256+(ord(t[9]));
 hist[k].mode:=(ord(t[1]) div 50)-1;
 if ord(t[5]) div 100=1 then hist[k].fstyle:=false
    else hist[k].fStyle:=true;

 if (hist[k].gameTimeS+hist[k].gameTimeH/100)<>0 then
   begin
 hist[k].bbbvsS:=
    trunc(hist[k].bbbv/(hist[k].gameTimeS+hist[k].gameTimeH/100));
 hist[k].bbbvsH:=
    trunc(100*frac(hist[k].bbbv/(hist[k].gameTimeS+hist[k].gameTimeH/100)));
   end;
 k:=k+1;
end;//correct entrie
end;//end of cycle reading file
closefile(f);
//writing null at the array end:
hist[k].dateDay:=0;hist[k].dateMonth:=0;hist[k].dateYear:=0;
hist[k].dateHour:=0;hist[k].dateMinute:=0;hist[k].dateSecond:=0;
hist[k].gameTimeS:=0;hist[k].gameTimeH:=0;hist[k].dateSecond:=0;hist[k].bbbv:=0;
hist[k].bbbvsS:=0;hist[k].bbbvsH:=0;hist[k].mode:=0;hist[k].fstyle:=false;

except end;
debug_add('external history arbiter file loaded ('+inttostr(k)+' entries)');
showerror(cap_histfileloaded);
exit;

   END ELSE
if uppercase(s)='INF' then
   BEGIN//load Clone history

   load_clone_history(od2.filename);
   exit;
   END
ELSE
   BEGIN//load Arbiter history

   debug_add('external history unknown file dismissed');
   showerror('File "'+od2.Filename+'"'+#13#10#13#10+
   'is not a Supported History File (.DAT or .INF)');
   exit;
   END
end;
end;

procedure THistory.seDateDayChange(Sender: TObject);
begin
cbDate.checked:=true;
end;

procedure THistory.seDateHourChange(Sender: TObject);
begin
cbHour.checked:=true;
end;

procedure THistory.seTimeSChange(Sender: TObject);
begin
cbTime.checked:=true;
end;

procedure THistory.seBVSSChange(Sender: TObject);
begin
cbBVS.checked:=true;
end;

procedure THistory.seBVChange(Sender: TObject);
begin
cbBV.checked:=true;
end;

procedure THistory.SpeedButton4Click(Sender: TObject);
var s:string;
    i,cnt,perc:integer;
    speed,speed2,tmp,disp,ios,time,time2:extended;
begin
//IOS calc
if sgs.RowCount<3 then
   begin showmessage('No data for calculations.');exit;end;

s:=inputbox('Request','Exclude percents of games [0..99]:','25');
try strtoint(s); except showmessage('Integer value expected.');exit;end;
   perc:=strtoint(s);
if (perc<0)or(perc>99)then
   begin showmessage('Integer 0..99 value expected.');exit;end;
try
   perc:=100-perc;
   cnt:=trunc((sgs.rowcount-2)*(perc/100));
   if cnt<=0 then cnt:=1;
   ios:=0;
   for i:=1 to cnt do
      begin
      ios:=ios+logN(strtofloat(sgs.Rows[i+1].Strings[5])-1,
         strtofloat(sgs.Rows[i+1].Strings[6]));
      end;
   ios:=ios/cnt;

   tmp:=0;

   if cnt>1 then
      begin
         for i:=1 to cnt do
         begin
         tmp:=tmp+
            sqr(
            logN(strtofloat(sgs.Rows[i+1].Strings[5])-1,
            strtofloat(sgs.Rows[i+1].Strings[6]))-IOS

            );
         end;
         tmp:=tmp/(cnt-1);
      end
   else tmp:=0;
   disp:=sqrt(tmp)/IOS;

   time:=power(250,1/(IOS+3*disp));
   speed:=250/time;

   time2:=power(150,1/(IOS+3*disp));
   speed2:=150/time2;

   time:=120/speed;
   time2:=30/speed2;

   s:='Results for '+inttostr(cnt)+' of '+inttostr(sgs.rowcount-2)+
      ' games ('+inttostr(perc)+'%) are:'#13#10+
      '(for the best forecast inverted 3BV/s sorting needed)'#13#10#13#10+

      floattostrf(ios,ffGeneral,8,8)+' units - average Index of Speed'#13#10+
      floattostrf(disp,ffGeneral,8,8)+' units - dispersion of Index of Speed'+
      #13#10'-----'#13#10+
      'Expert mode forecasts:'#13#10+
      floattostrf(speed,ffGeneral,8,8)+' 3BV/s - speed forecast for 250 3BV'+
      #13#10+
      floattostrf(time,ffGeneral,8,8)+' sec - time forecast for 120 3BV'+
      #13#10'-----'#13#10+
      'Intermediate mode forecasts:'#13#10+
      floattostrf(speed2,ffGeneral,8,8)+' 3BV/s - speed forecast for 150 3BV'+
      #13#10+
      floattostrf(time2,ffGeneral,8,8)+' sec - time forecast for 30 3BV'+
      #13#10#13#10'copied to clipboard.';
      showmessage(s);
      s:=copy(s,1,length(s)-24);
      StrToClipbrd(s);

//##################
except showmessage('ERROR');exit;end;

end;

end.
