unit FProgressBar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls;

type
    THackClass = class(TTrackBar);
   TProgressBar = class(TForm)
    trSpeed: TTrackBar;
    RestartBtn: TSpeedButton;
    trProgress: TTrackBar;
    lSpeed: TLabel;
    lProgress: TLabel;
    PauseBtn: TSpeedButton;
    StopBtn: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure trSpeedChange(Sender: TObject);
    procedure trSpeedKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure RestartBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure PauseBtnClick(Sender: TObject);
    procedure trProgressChange(Sender: TObject);
    procedure trProgressKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
{	procedure trProgressMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
	procedure trProgressMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);}
  private
    { Private declarations }
  public
    { Public declarations }
    dragging:boolean;
  end;

var
  ProgressBar: TProgressBar;

implementation

uses FData,FFunc,FCap, FMain, FCounters;
{$R *.DFM}

procedure TProgressBar.FormCreate(Sender: TObject);
begin
progressbar_form_created:=true;
trSpeed.Position:=20;
lspeed.caption:='1,00x';
lprogress.Caption:='0,00';
//reload_other_options;
progressbar.left:=opt.posProgressbarx;
progressbar.top:=opt.posProgressbary;
if progressbar.Left<0 then progressbar.left:=0;
if progressbar.Left>screen.width-progressbar.width then
   progressbar.Left:=screen.width-progressbar.width;
if progressbar.top<0 then progressbar.top:=0;
if progressbar.top>screen.height-progressbar.height then
   progressbar.top:=screen.height-progressbar.height;
//language_apply;
progressbar.Caption:=cap_progress_bar_caption;
if not is_replay_mode then begin progressbar_hide;exit;end;
if is_replay_mode then
   begin
   load_replay(open_param);
//   progressbar_show;
   if is_replay_mode then progressbar.RestartBtn.Click;
   end;
   {0.47}
{   THackClass(TrProgress).OnMouseDown :=trProgressMouseDown;
   THackClass(TrProgress).OnMouseUp :=trProgressMouseUp;}
end;

procedure TProgressBar.trSpeedChange(Sender: TObject);
begin
if not is_replay_mode then exit;
trSpeed.SelEnd:=trSpeed.Position;
if is_replay_mode then
   begin
   if trspeed.Position<41 then main.timer.interval:=200 div trspeed.position
   else
   main.timer.interval:=2;
   end;
checksum_all_store;
if trSpeed.Position<41 then
lspeed.Caption:=
   t2str(5*trSpeed.position div 100,5*trSpeed.position mod 100)+'x'
else lspeed.Caption:='5,00x';

end;

procedure TProgressBar.trSpeedKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if not is_replay_mode then exit;
if key=vk_left then begin
if trspeed.Position>1 then trspeed.Position:=trspeed.Position-1
else trspeed.Position:=1;end;
if key=vk_right then begin
if trspeed.Position<40 then trspeed.Position:=trspeed.Position+1
else trspeed.Position:=41;end;
if is_replay_mode then
   begin
   if trspeed.Position<41 then main.timer.interval:=200 div trspeed.position
   else
   main.timer.interval:=2;
   end;
   checksum_all_store;
end;

procedure TProgressBar.RestartBtnClick(Sender: TObject);
var x:sx;y:sy;
begin
progressbar.StopBtn.Click;
if replayPOS>replayI then exit;

for x:=0 to mdX do for y:=0 to mdY do begin b[x,y]:=cU;end;
checksum_board_store;
replayPOS:=0;

cell0:=3;
cell1:=5;
cell2:=7;
cell3:=11;
cell4:=13;
cell5:=17;
cell6:=19;
cell7:=23;
cell8:=29;

cell0done:=0;
cell1done:=0;
cell2done:=0;
cell3done:=0;
cell4done:=0;
cell5done:=0;
cell6done:=0;
cell7done:=0;
cell8done:=0;

for x:=0 to dX do for y:=0 to dY do
   if a[x,y]=c0 then cell0:=cell0+1 else
   if a[x,y]=c1 then cell1:=cell1+1 else
   if a[x,y]=c2 then cell2:=cell2+1 else
   if a[x,y]=c3 then cell3:=cell3+1 else
   if a[x,y]=c4 then cell4:=cell4+1 else
   if a[x,y]=c5 then cell5:=cell5+1 else
   if a[x,y]=c6 then cell6:=cell6+1 else
   if a[x,y]=c7 then cell7:=cell7+1 else
   if a[x,y]=c8 then cell8:=cell8+1;
calc_obv;

gtime.s:=0;
gtime.h:=0;
lcnt:=0;
rcnt:=0;
dcnt:=0;
Lecnt:=0;
Recnt:=0;
Decnt:=0;
done:=0;
usedflags:=0;
done_openings:=0;
//mpathx:=0;mpathy:=0;
mpath:=0;
last_x:=replay[0]._mPosX;
last_y:=replay[0]._mPosY;
checksum_all_store;
//timer_start;
progressbar.trProgress.Max:=replay[replayi]._timeS*100+replay[replayi]._timeH;
progressbar.trProgress.Min:=0;
progressbar.trProgress.Frequency:=100;
progressbar.trProgress.Position:=0;
showwindow(progressbar.trprogress.handle,sw_show);
showwindow(progressbar.trSpeed.handle,sw_show);
main.bNewGame.Picture.Bitmap:=main.imf1.Picture.Bitmap;
   begin
   if trspeed.Position<41 then main.timer.interval:=200 div trspeed.position
   else
   main.timer.interval:=2;
   end;
checksum_all_store;
progressbar_show;
//
main.cur.show;
main.cur.top:=replay[0]._mposX;
main.cur.left:=replay[0]._mposY;

//main.lNameLabel.Caption:=uid;
//
opt.doDisableTimer:=false;
//opt.doZeroTimer:=false;	{0.47} {we're going realtime}
opt.doAutoFlag:=false;
opt.doDisableGroupOpen:=false;
opt.doDisableRightClicks:=false;
opt.doInfiniteLives:=false;
opt.doShowProbabilities:=false;
opt.doShowMines:=false;
opt.doShow3BVafterGameStart:=false;
opt.doMustHave7:=false;
opt.doMustHave8:=false;
opt.doApprox3BV:=false;
opt.doApprox3BV2:=false;
checksum_opt_store;
//
is_replay_mode:=true;
is_new_game:=false;
checksum_all_store;
was_blasted:=false;
timer_start;
lb_down:=false;
rb_down:=false;
rreleased:=false;
mb_down:=false;

counters.Color:=clBtnFace;
parse_counter;

reload_image;
main.timer.Enabled:=true;
//main.thousandthtimer.enabled:=true;
end;

procedure TProgressBar.StopBtnClick(Sender: TObject);
var x:sx;y:sy;
begin
//if not is_replay_mode then begin
//   debug_add('stop button pressed while not replay mode');hack_found;exit;end;
main.timer.enabled:=false;
//main.thousandthtimer.enabled:=false;
for x:=0 to mdX do for y:=0 to mdY do begin b[x,y]:=cU;end;
checksum_board_store;
//reload_image;
///////////////////////////////////////
gtime.s:=1;
gtime.h:=0;
lcnt:=0;
rcnt:=0;
dcnt:=0;
Lecnt:=0;
Recnt:=0;
Decnt:=0;
done:=0;
usedflags:=0;
done_openings:=0;
//mpathx:=0;mpathy:=0;
mpath:=0;
replayPOS:=0;
checksum_all_store;
checksum_opt_store;
progressbar.trProgress.Max:=replay[replayi]._timeS*100+replay[replayi]._timeH;
progressbar.trProgress.Min:=0;
progressbar.trProgress.Frequency:=100;
progressbar.trProgress.Position:=0;
showwindow(progressbar.trprogress.handle,sw_show);
showwindow(progressbar.trSpeed.handle,sw_show);
progressbar_show;
main.bNewGame.Picture.Bitmap:=main.imf1.Picture.Bitmap;

{main.timer.interval:=10;}
   begin
   if trspeed.Position<41 then main.timer.interval:=200 div trspeed.position
   else
   main.timer.interval:=2;
   end;
   checksum_all_store;
//
lb_down:=false;
rb_down:=false;
rreleased:=false;
mb_down:=false;
main.cur.hide;
main.cur.top:=replay[0]._mposX;
main.cur.left:=replay[0]._mposY;
//main.lNameLabel.Caption:=uid;
was_blasted:=false;
is_replay_mode:=true;
checksum_all_store;
reload_image;
///////////////////////////////////////
end;

procedure TProgressBar.PauseBtnClick(Sender: TObject);
begin
//if not is_replay_mode then begin
//   debug_add('stop button pressed while not replay mode');hack_found;exit;end;
if replayPOS>replayI then exit;
main.timer.Enabled:= not main.timer.Enabled;
if main.timer.enabled then main.cur.show;
end;

procedure TProgressBar.trProgressChange(Sender: TObject);
begin
trProgress.SelEnd:=gtime.s*100+gtime.h;
end;

procedure TProgressBar.trProgressKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key=vk_left then begin
	if trProgress.Position>10 then begin
		trProgress.Position:=trProgress.Position-10;
		trprogress.Position:=round(trprogress.Position/10)*10;
	end
	else
		trProgress.Position:=0;
end;
if key=vk_right then begin
	if trProgress.Position<trProgress.Max-10 then begin
		trProgress.Position:=trProgress.Position+10;
		trprogress.Position:=round(trprogress.Position/10)*10;
	end
	else
		trProgress.Position:=trProgress.Max;
	end;
progressbar.lProgress.Caption:=t2str(
		trProgress.Position div 100,trProgress.Position mod 100);
end;

{procedure TProgressBar.trProgressMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
begin
	if(button=mbLeft) then dragging:=true;
end;

procedure TProgressBar.trProgressMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
var
	i,j:integer;
begin
	if(button<>mbLeft) then exit;
	if(gtime.s*100+gtime.h<trProgress.Position) then begin	// slider was moved forward
		main.timer.enabled:=false;
		
		// do events
		gtime.s:=trprogress.Position div 100;
		gtime.h:=trprogress.Position mod 100;
		while(replay[replaypos]._timeS*100+replay[replaypos]._timeH <= trprogress.position) do
			doreplay(replay[replaypos]._timeS,replay[replaypos]._timeH);

		checksum_all_store;
		
		main.timer.enabled:=true;
	end
	else if(gtime.s*100+gtime.h>trProgress.Position) then begin	// slider was moved back
		main.timer.enabled:=false;

		// initialize board
		for i:=0 to mdx do for j:=0 to mdY do b[i,j]:=cU;
		reload_user_interface;
		hard_reload_image;
		was_blasted:=false;
		main.init_counters_0_47;
		set_all_up;
		checksum_all_store;
		
		// do events
		gtime.s:=trprogress.Position div 100;
		gtime.h:=trprogress.Position mod 100;
		replaypos:=0;
		while(replay[replaypos]._timeS*100+replay[replaypos]._timeH <= trprogress.position) do
			doreplay(replay[replaypos]._timeS,replay[replaypos]._timeH);
		
		checksum_all_store;
		
		main.timer.enabled:=true;
	end;
	dragging:=false;
end;
}
end.
