unit FVideo;

interface uses SysUtils;

procedure savereplay(var f:textfile);
function REPLAYFILE_CORRECT(fn:string):boolean;

implementation

uses FFunc,FData,FMain;

procedure savereplay(var f:textfile);
var s,s1:String;
    bbv:word;
    i,t,r:longword;
    x:sX;y:sY;
{sub}function a2res(x:byte):byte;
     begin result:= 1;
     if x=c1 then result:= 2;
     if x=c2 then result:= 3;
     if x=c3 then result:= 4;
     if x=c4 then result:= 5;
     if x=c5 then result:= 6;
     if x=c6 then result:= 7;
     if x=c7 then result:= 8;
     if x=c8 then result:= 9;
     if x=cB then result:=10;
     end;
begin
	try
		bbv:=bbbv;
		//saving gamemode
		s:=chr(verN mod 256);
		//write(f,s);
		for i:=1 to 4 do s:=s+chr(random(31)+1);
		write(f,s);
		case mode of
			0:write(f,chr(3));
			1:write(f,chr(4));
			2:write(f,chr(5));
			3:write(f,chr(6));
		end;
		if mode=3 then begin
			write(f,chr(dX));
			write(f,chr(dY));
			write(f,chr(MC div 256));
			write(f,chr(MC mod 256));
		end;
		//saving bomb map
		s:='';
		for x:=0 to dx do 
			for y:=0 to dY do 
				if a[x,y]=cB then begin
					s:=s+chr(y+1)+chr(x+1);
					//write(f,chr(y+1)+chr(x+1));
				end;
		write(f,s);
		//saving bomb map checksum
		t:=0;
		for x:=0 to dx do 
			for y:=0 to dY do 
				t:=t+a2res(a[x,y])*(x+x*y);
		s:=inttostr(t);
		s1:='';
		for t:=1 to length(s) do s1:=s1+chr(ord(s[t])-45);
		write(f,s1);
		//saving replayI     4 bytes
		t:=replayI+6;
		s1:=chr(T div 256*256*256);t:=t-(T div 256*256*256)*256*256*256;
		s1:=s1+chr(T div 256*256);t:=t-(T div 256*256)*256*256;
		s1:=s1+chr(T div 256);t:=t-(T div 256)*256;
		s1:=s1+chr(T mod 256);
		s:='';
		for t:=1 to 4 do s:=s+chr(ord(s1[t])-45);
		write(f,s);
		s:='';
		s1:='';
		//saving user text
		write(f,chr(opt.countrynumber));
		write(f,chr(length(opt.userIDtext)));
		t:=0;
		for i:=1 to length(opt.userIDtext) do begin
			write(f,chr(ord(opt.userIDtext[i])-45));
			t:=t+i*ord(opt.userIDtext[i]);
		end;
		s:=inttostr(t);
		s1:='';
		for i:=1 to length(s) do s1:=s1+chr(ord(s[i])-45);
		write(f,s1);
		//saving domarks option
		if opt.doMarks then write(f,chr(17)) else write(f,chr(127));
		//saving time stamp
		///init_timer;

		s1:='['+gamestartstr+'|'+gameendstr+'|HS|';
		s1:=s1+'B'+inttostr(bbv)+'T'+fl2str(gtime.s+1,gtime.h)+']';

		write(f,chr(length(s1))+s1);
		t:=0;for i:=1 to length(s1) do t:=t+i*ord(s1[i]);
		s:=inttostr(t);
		s1:='';for i:=1 to length(s) do s1:=s1+chr(ord(s[i])-45);
		write(f,s1);
		//write(f,generate_replay_cs);
		//saving replay patterns+cs
		replay_fill_nomousemoves;

		for i:=0 to replayI do	{replay itself}
			write(f,replay_pattern_store(i,1));
		for i:=replayI+1 to replayI+6 do	{garbage}
			write(f,replay_pattern_store(i,0));
		
		for i:=1 to 15 do begin r:=random(10);write(f,chr(r+48)); end;
		
		t:=random(10)+5;
		for i:=1 to t do begin r:=random(10);write(f,chr(r+48)); end;
		write(f,inttostr(main.timer.interval));
		write(f,inttostr(opt.skinnumber));

		for i:=0 to 4 do begin r:=random(32);write(f,chr(r)); end;
		t:=random(10);
		for i:=1 to t do begin r:=random(32);write(f,chr(r)); end;
		write(f,chr(13)+'cs=');
		for i:=0 to 4 do begin r:=random(256);write(f,chr(r)); end;
		for i:=0 to 6 do write(f,chr(random(256)));
		write(f,chr(13)+'RealTime: '+fl2str(gtime.s,gtime.h));
		write(f,chr(13)+'Skin: '+skintostr);
		write(f,chr(13)+opt.userIDText);
		write(f,chr(13)+projectname+#32+ver+'. '+cop+#32+auth);
	except
		debug_add('fatal error: file/memory access violation');
	end;
end;

function REPLAYFILE_CORRECT(fn:string):boolean;
{sub}function a2res(x:byte):byte;
     begin result:= 1;     if x=c1 then result:= 2;
     if x=c2 then result:= 3;     if x=c3 then result:= 4;
     if x=c4 then result:= 5;     if x=c5 then result:= 6;
     if x=c6 then result:= 7;     if x=c7 then result:= 8;
     if x=c8 then result:= 9;     if x=cB then result:=10;     end;
var f:file of char;
    c:char;
    i,t,erc:longword;
    tx,x:sX;tY,y:sY;
    s,s1:String;
 	skn:int64;
   v:byte;//version_id
	oldfm:integer;
	newv:boolean;
{sub}procedure err;begin erc:=erc+1;end;
begin result:=false;
if not fileexists(fn)then exit;
oldfm:=FileMode;
newv:=true;
v:=0;erC:=0;
//repDelta:=0;
try
	assignfile(f,fn);
	FileMode:= 0;  { Set file access to read only }
	Reset(F);
  
	// version
	ERR;read(f,c);
	v:=ord(c);
	rep_ver:=v;

	// random bytes
	for i:=1 to 4 do begin 
		ERR;read(f,c);
	end;
	
	// mode
	ERR;read(f,c);
	if (ord(c)<>3)and(ord(c)<>4)and(ord(c)<>5)and(ord(c)<>6)then begin 
		closefile(f);
		FileMode:=oldfm;
		debug_add({mode}'replay load: #'+{inttostr(erC)+}
			  ' global load error (v.'+inttostr(v)+')');exit;
	end;
	case ord(c)of
		3:begin dx:=7;dy:=7;mc:=10;mode:=0;end;
		4:begin dx:=15;dy:=15;mc:=40;mode:=1;end;
		5:begin dx:=29;dy:=15;mc:=99;mode:=2;end;
		6:begin {dx:=29;dy:=15;mc:=99;}mode:=3;end;
	end;
	for x:=0 to mdX do for y:=0 to mdY do begin a[x,y]:=c0;b[x,y]:=cU;end;
	if mode=3 then begin
		read(f,c);
		dX:=ord(c);
		read(f,c);
		dY:=ord(c);
		read(f,c);
		MC:=ord(c)*256;
		read(f,c);
		MC:=MC+ord(c);
	end;

	// layout
	for i:=1 to mc do begin
		ERR;read(f,c);ty:=ord(c)-1;
		ERR;read(f,c);tx:=ord(c)-1;
		a[tx,ty]:=cB;
	end;
	calc_a;
	calc_zini;
	bbbv_islands:=bbbv_island_get;
	checksum_board_store;

	// layout cs
	t:=0;for x:=0 to dx do for y:=0 to dY do t:=t+a2res(a[x,y])*(x+x*y);
	s:=inttostr(t);
	s1:='';for t:=1 to length(s) do s1:=s1+chr(ord(s[t])-45);
	s:='';for i:=1 to length(s1) do begin 
		ERR;read(f,c);s:=s+c;
	end;
	if s<>s1 then begin 
		closefile(f);
		FileMode:=oldfm;
		debug_add({board}'replay load: #'+{inttostr(erC)+}
			' global load error (v.'+inttostr(v)+')');
		exit;
	end;

	// replayi
	s1:='';
	for i:=1 to 4 do begin 
		ERR;read(f,c);s1:=s1+c;
	end;
	s:='';for i:=1 to 4 do s:=s+chr(ord(s1[i])+45);
	replayI:=ord(s[1])*256*256*256;
	replayI:=replayI+ord(s[2])*256*256;
	replayI:=replayI+ord(s[3])*256;
	replayI:=replayI+ord(s[4]);
	
	// country
	ERR;read(f,c);
	cnid:=ord(c);//country number
	
	// ID
	ERR;read(f,c);
	t:=ord(c);
	s1:='';
	for i:=1 to t do begin 
		ERR;read(f,c);s1:=s1+c;
	end;
	uid:='';for i:=1 to t do uid:=uid+chr(ord(s1[i])+45);
	
	// ID cs
	t:=0;
	for i:=1 to length(uid) do t:=t+i*ord(uid[i]);
	s:=inttostr(t);
	s1:='';for i:=1 to length(s) do s1:=s1+chr(ord(s[i])-45);
	s:='';
	for i:=1 to length(s1) do begin 
		ERR;read(f,c);s:=s+c;
	end;
	if s<>s1 then begin 
		closefile(f);
		FileMode:=oldfm;
		debug_add({UID}'replay load: #'+{inttostr(erC)+}
			' global load error (v.'+inttostr(v)+')');
		exit;
	end;

	// question marks (lol)
	ERR;
	read(f,c);
	if ord(c)=17 then 
		opt.doMarks:=true 
	else if ord(c)=127 then 
		opt.doMarks:=false 
	else begin 
		closefile(f);
		FileMode:=oldfm;
		debug_add({marks}'replay load: #'+{inttostr(erC)+}
			' global load error (v.'+inttostr(v)+')');
		exit;
	end;
	checksum_opt_store;

	// timestamp
	ERR;read(f,c);
	t:=ord(c);
	s:='';
	for i:=1 to t do begin 
		ERR;read(f,c);s:=s+c;
	end;
	debug_add(s);
	t:=0;for i:=1 to length(s) do t:=t+i*ord(s[i]);
	s:=inttostr(t);
	s1:='';for i:=1 to length(s) do s1:=s1+chr(ord(s[i])-45);
	s:='';
	for i:=1 to length(s1) do begin 
		ERR;read(f,c);s:=s+c;
	end;
	if s<>s1 then begin 
		closefile(f);
		FileMode:=oldfm;
		debug_add({time_stamp}'replay load: #'+{inttostr(erC)+}
			' global load error (v.'+inttostr(v)+')');
		exit;
	end;

	// replay
	fillchar(replay,sizeof(replay),0);
	for i:=0 to replayI do begin
		s:='';
		for t:=1 to 8 do begin 
			ERR;read(f,c);s:=s+c;
		end;
		replay_pattern_load(i{+repDelta},s);  //!REPDELTA
	end;
	
	for i:=1 to 5 do begin ERR;read(f,c); end;

	read(f,c);
	skn:=0;
	while (ord(c)>=48) do begin skn:=ord(c)-48; read(f,c); end;
	skn:=skn;
	
	if(opt.doswitchskin) and (skn<>opt.skinnumber) then begin
		opt.skinnumber:=skn;
		checksum_opt_store;
		hard_reload_image;
	end;
		
	closefile(f);

	ERR;
	main.imFlag.Picture:=main.IEmpty.Picture;
	if cnid>0 then
		main.imC.GetBitmap(cnid,main.imFlag.picture.bitmap)
	else 
		main.imFlag.picture:=main.IEmpty.Picture;

	//success
	debug_add('replay loaded (v.'+inttostr(v)+')');
	result:=true;
except
	FileMode:=oldfm;
	closefile(f);result:=false;
	debug_add('#'+inttostr(erC)+
         ' replay load unknown error (v.'+inttostr(v)+')');
	exit;
end;

FileMode:=oldfm;

end;

end.