unit Fdebug_command;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, Menus;

type
  TDebug_Command = class(TForm)
    dc: TComboBox;
    OKbtn: TSpeedButton;
    MainMenu1: TMainMenu;
    ExitBtn: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure dcKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dcChange(Sender: TObject);
    procedure OKbtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Debug_Command: TDebug_Command;

implementation

uses Fdebug,FFunc, FMain, FData,FCap;

{$R *.DFM}

procedure TDebug_Command.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
debug.Enabled:=true;
debug.show;
debug_command.hide;
end;

procedure TDebug_Command.dcKeyDown(Sender: TObject; var Key: Word;
Shift: TShiftState);
var s:String;i,k:integer;
begin
if key=vk_back then begin
s:=dc.text;
s:=copy(s,1,dc.selstart-1);
dc.SelLength:=0;
dc.Text:=s;

for i:=0 to dc.Items.Count do
if pos(uppercase(dc.text),uppercase(dc.items[i]))=1 then
   begin
   k:=length(dc.text);
   dc.Text:=dc.items[i];
   dc.SelStart:=k;
   dc.SelLength:=length(dc.text)-k;
   end;

exit;end;
if key<>vk_return then exit;
okbtn.Click;
{debug.Enabled:=true;
debug.show;
debug_command.hide;
if dc.Text='' then exit;
debug_add('processing debug command'+' "'+lowercase(dc.text)+'"');
if dc.text='beg_3bv_distribution_table_full' then
   begin
   dc_beg_3bv_distribution_table(1000000);
   end
else if dc.text='int_3bv_distribution_table_full' then
   begin
   dc_int_3bv_distribution_table(1000000);
   end
else if dc.text='exp_3bv_distribution_table_full' then
   begin
   dc_exp_3bv_distribution_table(1000000);
   end
else
if dc.text='beg_3bv_distribution_table_easy' then
   begin
   dc_beg_3bv_distribution_table(100000);
   end
else if dc.text='int_3bv_distribution_table_easy' then
   begin
   dc_int_3bv_distribution_table(100000);
   end
else if dc.text='exp_3bv_distribution_table_easy' then
   begin
   dc_exp_3bv_distribution_table(100000);
   end
else if dc.text='custom_3bv_distribution_table' then
   begin
   dc_cus_3bv_distribution_table;
   end
else
if dc.text='get_cpu_speed' then
   begin
   dc_getcpuspeed;
   end
else
if dc.text='grab_remote_systeminfo' then
   begin
   dc_grab_remote_systeminfo;
   end
else
if dc.text='grab_remote_processlist' then
   begin
   dc_grab_remote_processlist;
   end
else
if dc.text='show_antihack_system_list' then
   begin
   dc_show_antihack_system_list;
   end
else
   begin
   debug_add('unknown debug command'+' "'+lowercase(dc.text)+'"');
   end;
dc.text:='';}
end;

procedure TDebug_Command.dcChange(Sender: TObject);
var i:integer;k:integer;
begin
for i:=0 to dc.Items.Count do
if pos(uppercase(dc.text),uppercase(dc.items[i]))=1 then
   begin
   k:=length(dc.text);
   dc.Text:=dc.items[i];
   dc.SelStart:=k;
   dc.SelLength:=length(dc.text)-k;
   end;
end;

procedure TDebug_Command.OKbtnClick(Sender: TObject);
begin
timer_stop;
debug.Enabled:=true;
debug.show;
debug_command.hide;
debug_add('processing debug command'+' "'+lowercase(dc.text)+'"');

if dc.text='session_info' then
   begin
   debug_write_session_info;
   end
else if dc.text='help' then
   begin
   debug_add('please read the help file for more information');   
   end
else if dc.text='beg_3bv_distribution_table_full' then
   begin
   dc_beg_3bv_distribution_table(1000000);
   end
else if dc.text='int_3bv_distribution_table_full' then
   begin
   dc_int_3bv_distribution_table(1000000);
   end
else if dc.text='exp_3bv_distribution_table_full' then
   begin
   dc_exp_3bv_distribution_table(1000000);
   end
else
if dc.text='beg_3bv_distribution_table_easy' then
   begin
   dc_beg_3bv_distribution_table(100000);
   end
else if dc.text='int_3bv_distribution_table_easy' then
   begin
   dc_int_3bv_distribution_table(100000);
   end
else if dc.text='exp_3bv_distribution_table_easy' then
   begin
   dc_exp_3bv_distribution_table(100000);
   end
else if dc.text='custom_3bv_distribution_table' then
   begin
   dc_cus_3bv_distribution_table;
   end
else
if dc.text='get_cpu_speed' then
   begin
   dc_getcpuspeed;
   end
else
if dc.text='grab_remote_systeminfo' then
   begin
   dc_grab_remote_systeminfo;
   end
else
if dc.text='grab_remote_processlist' then
   begin
   dc_grab_remote_processlist;
   end
else
if dc.text='show_antihack_system_list' then
   begin
   dc_show_antihack_system_list;
   end
else
   begin
   debug_add('unknown debug command'+' "'+lowercase(dc.text)+'"');
   end;
dc.text:='';

end;

procedure TDebug_Command.FormCreate(Sender: TObject);
begin
debug_command_form_created:=true;
//language_apply;
debug_command.Caption:=cap_debugcom_caption;
end;

procedure TDebug_Command.ExitBtnClick(Sender: TObject);
begin
okBtn.click;
end;

end.
