unit Ffuncstats;

interface

uses FData, Sysutils;
//var 
//	fucking_debug:string;
	
function exttostr(x:extended):string;

function get_best_25time(m:byte):single;
function get_best_25bvs(m:byte):single;
function get_best_25rqp(m:byte):single;
function get_best_25ios(m:byte):single;
function get_best_25ioe(m:byte):single;

function get_best_25ftime(m:byte):single;
function get_best_25fbvs(m:byte):single;
function get_best_25frqp(m:byte):single;
function get_best_25fios(m:byte):single;
function get_best_25fioe(m:byte):single;

function get_best_25nftime(m:byte):single;
function get_best_25nfbvs(m:byte):single;
function get_best_25nfrqp(m:byte):single;
function get_best_25nfios(m:byte):single;
function get_best_25nfioe(m:byte):single;


function get_best_time(m:byte):thistorypos;
function get_best_ftime(m:byte):thistorypos;
function get_best_nftime(m:byte):thistorypos;

function get_best_bvs(m:byte):thistorypos;
function get_best_fbvs(m:byte):thistorypos;
function get_best_nfbvs(m:byte):thistorypos;

function get_best_ios(m:byte):thistorypos;
function get_best_fios(m:byte):thistorypos;
function get_best_nfios(m:byte):thistorypos;

function get_best_rqp(m:byte):thistorypos;
function get_best_frqp(m:byte):thistorypos;
function get_best_nfrqp(m:byte):thistorypos;

function get_best_ioeff(m:byte):thistorypos;
function get_best_fioe(m:byte):thistorypos;
function get_best_nfioe(m:byte):thistorypos;

function get_best_fzinis(m:byte):thistorypos;
function get_best_nfzinis(m:byte):thistorypos;

function get_best_fhzinis(m:byte):thistorypos;
function get_best_nfhzinis(m:byte):thistorypos;

function get_best_fobvs(m:byte):thistorypos;
function get_best_nfobvs(m:byte):thistorypos;

function hist_ioe(m:thistorypos):single;
function hist_obv(m:thistorypos):single;
function hist_gzinis(i:thistorypos):single;
function hist_hzinis(i:thistorypos):single;
function hist_obvs(i:thistorypos):single;

implementation

function exttostr(x:extended):string;
begin
result:=floattostrf(x,ffFixed,7,3);
if opt.doDotSeparator then
    begin
    if pos(',',result)>0 then result[pos(',',result)]:='.';
    end
else
    begin
    if pos('.',result)>0 then result[pos('.',result)]:=',';
    end
end;

//-----------best-time------------------
function get_best_time(m:byte):thistorypos;
var i:longword;
    times,timeh:word;
begin
times:=999;
timeh:=99;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and
        ((hist[i].gameTimeS<times)or
        ((hist[i].gameTimeS=times)and(hist[i].gameTimeH<timeh)))then
        begin
        times:=hist[i].gameTimeS;
        timeh:=hist[i].gameTimeH;
        result:=i;
        end;
   i:=i+1;
   end;
end;


//--------best-3bv/s-------------------
function get_best_bvs(m:byte):thistorypos;
var i:longword;
    tbvs:single;
begin
tbvs:=0;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and
        (hist[i].bvs>tbvs)then
        begin
        tbvs:=hist[i].bvs;
        result:=i;
        end;
   i:=i+1;
   end;
end;

//--------best-ios-------------------
function get_best_ios(m:byte):thistorypos;
var i:longword;
    tios:single;
begin
result:=cHistMax;
//beg ios is not calculated
if m=0 then exit;
tios:=0;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and
        (hist[i].ios>tios)then
        begin
        tios:=hist[i].ios;
        result:=i;
        end;
   i:=i+1;
   end;
end;

//---------best-RQP--------------------
function get_best_rqp(m:byte):thistorypos;
var i:longword;
    trqp:single;
begin
trqp:=999.99;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and
        (hist[i].rqp<trqp)then
        begin
        trqp:=hist[i].rqp;
        result:=i;
        end;
   i:=i+1;
   end;
end;

//-------best f time --------------------
function get_best_ftime(m:byte):thistorypos;
var i:longword;
    times,timeh:word;
begin
times:=999;
timeh:=99;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt>0)and
        ((hist[i].gameTimeS<times)or
        ((hist[i].gameTimeS=times)and(hist[i].gameTimeH<timeh)))then
        begin
        times:=hist[i].gameTimeS;
        timeh:=hist[i].gameTimeH;
        result:=i;
        end;
   i:=i+1;
   end;
end;


//-------best nf time --------------------
function get_best_nftime(m:byte):thistorypos;
var i:longword;
    times,timeh:word;
begin
times:=999;
timeh:=99;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt=0)and
        ((hist[i].gameTimeS<times)or
        ((hist[i].gameTimeS=times)and(hist[i].gameTimeH<timeh)))then
        begin
        times:=hist[i].gameTimeS;
        timeh:=hist[i].gameTimeH;
        result:=i;
        end;
   i:=i+1;
   end;
end;


//--------best-f 3bv/s-------------------
function get_best_fbvs(m:byte):thistorypos;
var i:longword;
    tbvs:single;
begin
tbvs:=0;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt>0)and
        (hist[i].bvs>tbvs)then
        begin
        tbvs:=hist[i].bvs;
        result:=i;
        end;
   i:=i+1;
   end;
end;

//--------best-f 3bv/s-------------------
function get_best_nfbvs(m:byte):thistorypos;
var i:longword;
    tbvs:single;
begin
tbvs:=0;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt=0)and
        (hist[i].bvs>tbvs)then
        begin
        tbvs:=hist[i].bvs;
        result:=i;
        end;
   i:=i+1;
   end;
end;


//---------best-f-RQP--------------------
function get_best_frqp(m:byte):thistorypos;
var i:longword;
    trqp:single;
begin
trqp:=999.99;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt>0)and
        (hist[i].rqp<trqp)then
        begin
        trqp:=hist[i].rqp;
        result:=i;
        end;
   i:=i+1;
   end;
end;

//---------best-Nf-RQP--------------------
function get_best_nfrqp(m:byte):thistorypos;
var i:longword;
    trqp:single;
begin
trqp:=999.99;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt=0)and
        (hist[i].rqp<trqp)then
        begin
        trqp:=hist[i].rqp;
        result:=i;
        end;
   i:=i+1;
   end;
end;

//--------best-F ios-------------------
function get_best_fios(m:byte):thistorypos;
var i:longword;
    tios:single;
begin
result:=cHistMax;
//beg ios is not calculated
if m=0 then exit;
tios:=0;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt>0)and
        (hist[i].ios>tios)then
        begin
        tios:=hist[i].ios;
        result:=i;
        end;
   i:=i+1;
   end;
end;


//--------best-NF ios-------------------
function get_best_nfios(m:byte):thistorypos;
var i:longword;
    tios:single;
begin
result:=cHistMax;
//beg ios is not calculated
if m=0 then exit;
tios:=0;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt=0)and
        (hist[i].ios>tios)then
        begin
        tios:=hist[i].ios;
        result:=i;
        end;
   i:=i+1;
   end;
end;


//-------IOE-------------------
function get_best_ioeff(m:byte):thistorypos;
var i:longword;
    tioe:single;
    tmp:single;
begin
tioe:=0;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)then
        begin
        if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
			tmp:=hist_ioe(i)   {0.47} {ioe isn't correctness!}
        {tmp:=(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)     }
            else tmp:=0;
//		fucking_debug:=fucking_debug+' '+inttostr(i)+' '+floattostr(tmp)+' ';
        if(tmp>tioe)then
            begin
            tioe:=tmp;
            result:=i;
            end;
        end;
   i:=i+1;
   end;
end;


//------best F-IOE-------------------
function get_best_fioe(m:byte):thistorypos;
var i:longword;
    tioe:single;
    tmp:single;
begin
tioe:=0;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt>0)then
        begin
        if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
			tmp:=hist_ioe(i)	{0.47}
{        tmp:=(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)}
            else tmp:=0;
//		fucking_debug:=fucking_debug+' '+inttostr(i)+' '+floattostr(tmp)+' ';
        if(tmp>tioe)then
            begin
            tioe:=tmp;
            result:=i;
            end;
        end;
   i:=i+1;
   end;
end;

//------best NF-IOE-------------------
function get_best_nfioe(m:byte):thistorypos;
var i:longword;
    tioe:single;
    tmp:single;
begin
tioe:=0;
result:=cHistMax;
if hist[0].dateDay=0 then exit;
i:=0;
while(hist[i].dateDay<>0)and(i<cHistMax)do
    begin
    if (hist[i].mode=m)and(hist[i].rcnt=0)then
        begin
        if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
			tmp:=hist_ioe(i)
{        tmp:=(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)} {0.47}
            else tmp:=0;
//		fucking_debug:=fucking_debug+' '+inttostr(i)+' '+floattostr(tmp)+' ';
        if(tmp>tioe)then
            begin
            tioe:=tmp;
            result:=i;
            end;
        end;
   i:=i+1;
   end;
end;

//-----------best -25--time------------------
function get_best_25time(m:byte):single;
var i,rez:longword;
    times,timeh:word;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
times:=999;
timeh:=99;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and
        ((hist[rez].gameTimeS<times)or
        ((hist[rez].gameTimeS=times)and(hist[rez].gameTimeH<timeh)))then
        begin
        times:=hist[rez].gameTimeS;
        timeh:=hist[rez].gameTimeH;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].gameTimeS+hist[i].gameTimeH/100;
end else failed:=true;
end;//k=0..24
if failed then result:=999.99
else result:=result/25;
end;

//-----------best -25--3bv/s------------------
function get_best_25bvs(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and
        (hist[rez].bvs>=tmp)then
        begin
        tmp:=hist[rez].bvs;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].bvs;
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;

//-----------best -25--rqp------------------
function get_best_25rqp(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=999.99;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and
        (hist[rez].rqp<=tmp)then
        begin
        tmp:=hist[rez].rqp;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].rqp;
end else failed:=true;
end;//k=0..24
if failed then result:=999.99
else result:=result/25;
end;

//-----------best -25--IOS------------------
function get_best_25ios(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
if m=0 then exit;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and
        (hist[rez].ios>=tmp)then
        begin
        tmp:=hist[rez].ios;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].ios;
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;

//-----------best -25--IOE------------------
function get_best_25ioe(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp,tmp2:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))then
        begin
        if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
			tmp2:=hist_ioe(i)
        else tmp2:=0;

        if(tmp2>=tmp)then
            begin
            tmp:=tmp2;
            i:=rez;
            end;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
result:=result+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;

//-----------best -25--time------------------
function get_best_25ftime(m:byte):single;
var i,rez:longword;
    times,timeh:word;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
times:=999;
timeh:=99;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt>0)and
        ((hist[rez].gameTimeS<times)or
        ((hist[rez].gameTimeS=times)and(hist[rez].gameTimeH<timeh)))then
        begin
        times:=hist[rez].gameTimeS;
        timeh:=hist[rez].gameTimeH;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].gameTimeS+hist[i].gameTimeH/100;
end else failed:=true;
end;//k=0..24
if failed then result:=999.99
else result:=result/25;
end;

//-----------best -25--3bv/s------------------
function get_best_25fbvs(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt>0)and
        (hist[rez].bvs>=tmp)then
        begin
        tmp:=hist[rez].bvs;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].bvs;
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;

//-----------best -25--rqp------------------
function get_best_25frqp(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=999.99;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt>0)and
        (hist[rez].rqp<=tmp)then
        begin
        tmp:=hist[rez].rqp;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].rqp;
end else failed:=true;
end;//k=0..24
if failed then result:=999.99
else result:=result/25;
end;

//-----------best -25--IOS------------------
function get_best_25fios(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
if m=0 then exit;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt>0)and
        (hist[rez].ios>=tmp)then
        begin
        tmp:=hist[rez].ios;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].ios;
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;

//-----------best -25--IOE------------------
function get_best_25fioe(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp,tmp2:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt>0)then
        begin
        if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
			tmp2:=hist_ioe(i)
        else tmp2:=0;

        if(tmp2>=tmp)then
            begin
            tmp:=tmp2;
            i:=rez;
            end;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
result:=result+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;


//-----------best -25--time------------------
function get_best_25nftime(m:byte):single;
var i,rez:longword;
    times,timeh:word;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
times:=999;
timeh:=99;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt=0)and
        ((hist[rez].gameTimeS<times)or
        ((hist[rez].gameTimeS=times)and(hist[rez].gameTimeH<timeh)))then
        begin
        times:=hist[rez].gameTimeS;
        timeh:=hist[rez].gameTimeH;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].gameTimeS+hist[i].gameTimeH/100;
end else failed:=true;
end;//k=0..24
if failed then result:=999.99
else result:=result/25;
end;

//-----------best -25--3bv/s------------------
function get_best_25nfbvs(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt=0)and
        (hist[rez].bvs>=tmp)then
        begin
        tmp:=hist[rez].bvs;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].bvs;
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;

//-----------best -25--rqp------------------
function get_best_25nfrqp(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=999.99;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt=0)and
        (hist[rez].rqp<=tmp)then
        begin
        tmp:=hist[rez].rqp;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].rqp;
end else failed:=true;
end;//k=0..24
if failed then result:=999.99
else result:=result/25;
end;

//-----------best -25--IOS------------------
function get_best_25nfios(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
if m=0 then exit;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt=0)and
        (hist[rez].ios>=tmp)then
        begin
        tmp:=hist[rez].ios;
        i:=rez;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
result:=result+hist[i].ios;
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;

//-----------best -25--IOE------------------
function get_best_25nfioe(m:byte):single;
var i,rez:longword;
    a:array[0..24]of longword;
    k:byte;
    failed:boolean;
    tmp,tmp2:single;
{sub}
function found(x:longword):boolean;
var i:byte;
begin
result:=false;
for i:=0 to 24 do if a[i]=x then
    begin
    result:=true;
    exit;
    end;
end;
BEGIN
result:=0;
failed:=false;
if hist[0].dateDay=0 then exit;

for k:=0 to 24 do
begin
rez:=0;
i:=cHistMax;
tmp:=0;
while(hist[rez].dateDay<>0)and(rez<cHistMax)do
    begin
    if (hist[rez].mode=m)and(not found(rez))and(hist[rez].rcnt=0)then
        begin
        if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
			tmp2:=hist_ioe(i)
        else tmp2:=0;

        if(tmp2>=tmp)then
            begin
            tmp:=tmp2;
            i:=rez;
            end;
        end;
   rez:=rez+1;
   end;
if i<cHistMax then begin
a[k]:=i;
if (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt)>0 then
result:=result+(hist[i].lecnt+hist[i].recnt+hist[i].decnt)/
            (hist[i].lcnt+hist[i].rcnt+hist[i].dcnt);
end else failed:=true;
end;//k=0..24
if failed then result:=0
else result:=result/25;
end;

function get_best_fzinis(m:byte):thistorypos;
var i:longword;
    zinis,tmp:single;
begin
	zinis:=0.0;
	result:=cHistMax;
	if hist[0].dateDay=0 then exit;
	i:=0;
	while(hist[i].dateDay<>0)and(i<cHistMax)do begin
		tmp:=100.0*hist[i].gzini/(100*hist[i].gametimes+hist[i].gametimeh);
		if (hist[i].mode=m)and(hist[i].rcnt>0)and(tmp>zinis)then begin
			zinis:=tmp;
			result:=i;
		end;
		i:=i+1;
	end;
end;
function get_best_nfzinis(m:byte):thistorypos;
var i:longword;
    zinis,tmp:single;
begin
	zinis:=0.0;
	result:=cHistMax;
	if hist[0].dateDay=0 then exit;
	i:=0;
	while(hist[i].dateDay<>0)and(i<cHistMax)do begin
		tmp:=100.0*hist[i].gzini/(100*hist[i].gametimes+hist[i].gametimeh);
		if (hist[i].mode=m)and(hist[i].rcnt=0)and(tmp>zinis)then begin
			zinis:=tmp;
			result:=i;
		end;
		i:=i+1;
	end;
end;
function get_best_fhzinis(m:byte):thistorypos;
var i:longword;
    zinis,tmp:single;
begin
	zinis:=0.0;
	result:=cHistMax;
	if hist[0].dateDay=0 then exit;
	i:=0;
	while(hist[i].dateDay<>0)and(i<cHistMax)do begin
		tmp:=100.0*hist[i].hzini/(100*hist[i].gametimes+hist[i].gametimeh);
		if (hist[i].mode=m)and(hist[i].rcnt>0)and(tmp>zinis)then begin
			zinis:=tmp;
			result:=i;
		end;
		i:=i+1;
	end;
end;
function get_best_nfhzinis(m:byte):thistorypos;
var i:longword;
    zinis,tmp:single;
begin
	zinis:=0.0;
	result:=cHistMax;
	if hist[0].dateDay=0 then exit;
	i:=0;
	while(hist[i].dateDay<>0)and(i<cHistMax)do begin
		tmp:=100.0*hist[i].hzini/(100*hist[i].gametimes+hist[i].gametimeh);
		if (hist[i].mode=m)and(hist[i].rcnt=0)and(tmp>zinis)then begin
			zinis:=tmp;
			result:=i;
		end;
		i:=i+1;
	end;
end;
function get_best_fobvs(m:byte):thistorypos;
var i:longword;
    zinis,tmp:single;
begin
	zinis:=0.0;
	result:=cHistMax;
	if hist[0].dateDay=0 then exit;
	i:=0;
	while(hist[i].dateDay<>0)and(i<cHistMax)do begin
		tmp:=100.0*hist_obv(i)/(100*hist[i].gametimes+hist[i].gametimeh);
		if (hist[i].mode=m)and(hist[i].rcnt>0)and(tmp>zinis)then begin
			zinis:=tmp;
			result:=i;
		end;
		i:=i+1;
	end;
end;
function get_best_nfobvs(m:byte):thistorypos;
var i:longword;
    zinis,tmp:single;
begin
	zinis:=0.0;
	result:=cHistMax;
	if hist[0].dateDay=0 then exit;
	i:=0;
	while(hist[i].dateDay<>0)and(i<cHistMax)do begin
		tmp:=100.0*hist_obv(i)/(100*hist[i].gametimes+hist[i].gametimeh);
		if (hist[i].mode=m)and(hist[i].rcnt=0)and(tmp>zinis)then begin
			zinis:=tmp;
			result:=i;
		end;
		i:=i+1;
	end;
end;

{0.47}
function hist_ioe(m:thistorypos):single;
begin
	result:=hist[m].bbbv/(hist[m].lcnt+hist[m].rcnt+hist[m].dcnt);
end;

function hist_numbers(m:thistorypos):integer;
begin
	result:=hist[m].cell1+hist[m].cell2+hist[m].cell3+hist[m].cell4+
	hist[m].cell5+hist[m].cell6+hist[m].cell7+hist[m].cell8;
end;

function hist_obv(m:thistorypos):single;
begin
	result:=0.0;
	if(hist[m].mode=0) then
		result:=0.07*hist_numbers(m)+0.43*hist[m].bbbv+2.27*hist[m].openings
	else if(hist[m].mode=1) then
		result:=0.2*hist_numbers(m)+0.32*hist[m].bbbv+1.38*hist[m].openings
	else if(hist[m].mode=2) then
		result:=0.38*hist_numbers(m)+0.23*hist[m].bbbv+0.99*hist[m].openings;
end;

function hist_gzinis(i:thistorypos):single;
begin
	if (hist[i].gametimes>0) or (hist[i].gametimeh>0) then
		result:=100.0*hist[i].gzini/(100*hist[i].gametimes+hist[i].gametimeh)
	else
		result:=0;
end;

function hist_hzinis(i:thistorypos):single;
begin
	if (hist[i].gametimes>0) or (hist[i].gametimeh>0) then
		result:=100.0*hist[i].hzini/(100*hist[i].gametimes+hist[i].gametimeh)
	else
		result:=0;
end;

function hist_obvs(i:thistorypos):single;
begin
	if (hist[i].gametimes>0) or (hist[i].gametimeh>0) then
		result:=100.0*hist_obv(i)/(100*hist[i].gametimes+hist[i].gametimeh)
	else
		result:=0;
end;

end.
